/**
 * Created by bigree on 6/6/2016.
 */
/**
 * @namespace
 */
jQuery.sap.declare("sas.analytics.riskhp.common.riskcommons.CrosstabUtil");
(function() {

    jQuery.sap.require("sas.ltjs.commons.crosstab.CrosstabPickResultEntry");
    var CrosstabPickResultEntry = sas.ltjs.commons.crosstab.CrosstabPickResultEntry;

    jQuery.sap.require("sas.ltjs.commons.crosstab.DisplayTreeNode");
    var DisplayTreeNode = sas.ltjs.commons.crosstab.DisplayTreeNode;

    jQuery.sap.require("sas.ltjs.commons.models.data.DataValue");
    var DataValue = sas.ltjs.commons.models.data.DataValue;

    jQuery.sap.require("sas.ltjs.commons.crosstab.NodeType");
    var NodeType = sas.ltjs.commons.crosstab.NodeType;

    jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataType");
    var DataType = sas.ltjs.commons.models.data.dataset.DataType;

    jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataUsage");
    var DataUsage = sas.ltjs.commons.models.data.dataset.DataUsage;

    jQuery.sap.require("sas.ltjs.commons.models.data.hierarchy.Hierarchy");
    var Hierarchy = sas.ltjs.commons.models.data.hierarchy.Hierarchy;

    jQuery.sap.require("sas.ltjs.commons.models.data.hierarchy.Level");
    var Level = sas.ltjs.commons.models.data.hierarchy.Level;

    jQuery.sap.require("sas.ltjs.commons.pickResults.PickEntryType");
    var PickEntryType = sas.ltjs.commons.pickResults.PickEntryType;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Hierarchy");
    var HIERARCHY = sas.analytics.riskhp.models.dataitems.Hierarchy.HIERARCHY;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Classvar");
    var CLASSVAR = sas.analytics.riskhp.models.dataitems.Classvar.CLASSVAR;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.ResultSet");
    var RESULTSET = sas.analytics.riskhp.models.dataitems.ResultSet.RESULTSET;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Outvar");
    var OUTVAR = sas.analytics.riskhp.models.dataitems.Outvar.OUTVAR;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Compvar");
    var COMPVAR = sas.analytics.riskhp.models.dataitems.Compvar.COMPVAR;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Benchvar");
    var BENCHVAR = sas.analytics.riskhp.models.dataitems.Benchvar.BENCHVAR;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Statistic");
    var STATISTIC = sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Horizon");
    var HORIZON = sas.analytics.riskhp.models.dataitems.Horizon.HORIZON;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.RelativeHorizon");
    var RELATIVEHORIZON = sas.analytics.riskhp.models.dataitems.RelativeHorizon.RELATIVEHORIZON;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.AbsoluteHorizon");
    var ABSOLUTEHORIZON = sas.analytics.riskhp.models.dataitems.AbsoluteHorizon.ABSOLUTEHORIZON;

    jQuery.sap.require("sas.analytics.riskhp.models.dataitems.RiskCube");
    var RISKCUBE = sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE;

    sas.analytics.riskhp.common.riskcommons.CrosstabUtil = {};
    var CrosstabUtil = sas.analytics.riskhp.common.riskcommons.CrosstabUtil;

    // Where to place the total/subtotal results row
    CrosstabUtil.TOTALS_LOCATION_BEFORE = 0;
    CrosstabUtil.TOTALS_LOCATION_AFTER = 1;

    CrosstabUtil.COMPVARHEADER = "compvarHeader";
    CrosstabUtil.BENCHVARHEADER = "benchvarHeader";
    CrosstabUtil.ROWSTATHEADER = "rowstatHeader";
    CrosstabUtil.BASECASEHEADER = "basecaseHeader";

    CrosstabUtil.COLPADCHAR = '\u2060';

    CrosstabUtil._walkRowHeaderDisplayTree = function (rootDTN, resultsNode, pagingArrow, context) {
        var self = this;
        var p = resultsNode.parent;
        var pagingInfoArray = [1, 1, 1];
        if (p !== undefined)
            pagingInfoArray = [p.startRow, p.startRow + p.rows - 1, p.totalRows];

        if ((rootDTN) && (resultsNode)) {
            // If indented, then create a separate subtotal node/row (but not labeled "subtotal")
            if (context.getRowIndent() || (resultsNode.expanded === false) || (resultsNode.children.length <= 0)) {
                //var newDTN = new DisplayTreeNode(resultsNode.name, null);
                var newDTN = new DisplayTreeNode(resultsNode.label, null);

                if (pagingArrow) {
                    if (pagingArrow === "upArrow") {
                        newDTN.setPageUpTooltipLabel(context.getI18NBundle().getText('HPRisk.Crosstab.Paging.Up.tooltip.fmt', pagingInfoArray));
                        newDTN.setPageUpButtonVisible(true);
                    }
                    else if (pagingArrow === "downArrow") {
                        newDTN.setPageDownTooltipLabel(context.getI18NBundle().getText('HPRisk.Crosstab.Paging.Down.tooltip.fmt', pagingInfoArray));
                        newDTN.setPageDownButtonVisible(true);
                    }
                }
                rootDTN.addChild(newDTN);
            }

            if ((resultsNode.expanded === true) && (resultsNode.children.length > 0)) {
                var newDTN;
                // if indented, the create a dummy parent node for the children to reside (Same name but with an added
                // '&' for required uniqueness of node names).  Else just create a parent node.
                //FIXME look at using COLPADCHAR instead of &
                if (context.getRowIndent()) {
                    newDTN = new DisplayTreeNode(resultsNode.label + '&', null);
                } else {
                    newDTN = new DisplayTreeNode(resultsNode.label, null);
                }

                if (pagingArrow) {
                    if (pagingArrow === "upArrow") {
                        newDTN.setPageUpTooltipLabel(context.getI18NBundle().getText('HPRisk.Crosstab.Paging.Up.tooltip.fmt', pagingInfoArray));
                        newDTN.setPageUpButtonVisible(true);
                    }
                    else if (pagingArrow === "downArrow") {
                        newDTN.setPageDownTooltipLabel(context.getI18NBundle().getText('HPRisk.Crosstab.Paging.Down.tooltip.fmt', pagingInfoArray));
                        newDTN.setPageDownButtonVisible(true);
                    }
                }

                rootDTN.addChild(newDTN);

                // If we are not indented and location "before", then add a subtotal node/row.
                if (!context.getRowIndent() && context.isSubtotalsEnabled() && (context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_BEFORE)) {
                    var newDTN_subtotal = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt'), null);
                    newDTN_subtotal.setNodeType(NodeType.SUBTOTAL);
                    newDTN.addChild(newDTN_subtotal);
                }

                for (var idx = 0; idx < resultsNode.children.length; idx++) {
                    var pagingArrow = CrosstabUtil.getPagingArrow(resultsNode, idx, context);
                    self._walkRowHeaderDisplayTree(newDTN, resultsNode.children[idx], pagingArrow, context);
                }

                // If we are not indented and location "after", then add a subtotal node/row.
                if (!context.getRowIndent() && context.isSubtotalsEnabled() && (context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_AFTER)) {
                    var newDTN_subtotal = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt'), null);
                    newDTN_subtotal.setNodeType(NodeType.SUBTOTAL);
                    newDTN.addChild(newDTN_subtotal);
                }

            }
        }
    };

    CrosstabUtil.createRowHeaderDisplayTree = function (context) {
        var rootNode = new DisplayTreeNode("root", null);

        // Handle the total/subtotal row if location is before.
        if (context.drillpath.length > 0) {
            if (context.isSubtotalsEnabled() && context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_BEFORE) {
                var totalNode = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt'), null);
                //totalNode.setNodeType(NodeType.SUBTOTAL);
                totalNode.setNodeType(NodeType.TOTAL);
                rootNode.addChild(totalNode);
            }
        }
        else {
            if (context.isTotalEnabled() && context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_BEFORE) {
                var totalNode = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt'), null);
                totalNode.setNodeType(NodeType.TOTAL);
                rootNode.addChild(totalNode);
            }
        }

        if (context.drillnode.children.length > 0) {
            for (var idx = 0; idx < context.drillnode.children.length; idx++) {
                var paging_arrow = CrosstabUtil.getPagingArrow(context.drillnode, idx, context);
                CrosstabUtil._walkRowHeaderDisplayTree(rootNode, context.drillnode.children[idx], paging_arrow, context);
            }
        }

        // Handle the total/subtotal row if location is after.
        if (context.drillpath.length > 0) {
            if (context.isSubtotalsEnabled() && context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_AFTER) {
                var totalNode = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt'), null);
                totalNode.setNodeType(NodeType.SUBTOTAL);
                rootNode.addChild(totalNode);
            }
        }
        else {
            if (context.isTotalEnabled() && context.getTotalsLocation() === CrosstabUtil.TOTALS_LOCATION_AFTER) {
                var totalNode = new DisplayTreeNode(context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt'), null);
                totalNode.setNodeType(NodeType.TOTAL);
                rootNode.addChild(totalNode);
            }
        }

        //For debuggin
        //rootNode.print();

        return rootNode;
    };

    CrosstabUtil.getPagingArrow = function(node, idx, context) {
        var paging_arrow = undefined;

        // More rows than the number to display?
        if (node.totalRows > context.optionNROWS.value || node.startRow > 1 ) {

            // First child gets upArrow?
            if (idx === 0) {
                paging_arrow = (node.startRow > 1 ? "upArrow" : undefined);
            }

            // Last child gets downArrow?
            else if (idx === node.children.length - 1) {
                paging_arrow = (node.startRow <= node.totalRows - context.optionNROWS.value ? "downArrow" : undefined);
            }
        }
        return paging_arrow;
    };

    CrosstabUtil.createRowHeaderLevels = function (context) {
        var rowLevels = [];
        var rowMemberLabels = context.getClassVariableLabels("drilled");
        for (var i = 0; i < rowMemberLabels.length; i++) {
            rowLevels.push(new Level("rowLevel" + i, rowMemberLabels[i], null, DataType.STRING, true, null));
        }
        return rowLevels;
    };

    CrosstabUtil.createRowHierarchy = function (context, rowLevels) {
        var rowHierarchy = new Hierarchy("rowHierarchy", "Row Hierarchy Label", rowLevels);
        return rowHierarchy;
    };

    CrosstabUtil.createColumnHeaderLevels = function (context) {
        var columnLevels = [];
        var columnDepth = context.getMaxColumnDepth();
        var headerName = CrosstabUtil.COLPADCHAR; // So when header labels turned on, the column header labels are empty.

        // Skip the last column member. The last member is the "measure" and is handled differently.
        for (var i = 0; i < columnDepth - 1; i++) {
            headerName = headerName + CrosstabUtil.COLPADCHAR;
            columnLevels.push(new Level("columnLevel" + i, headerName, null, DataType.STRING, true, null));
        }
        // FIXME  Ok to delete.  This is used for testing changes to the number of column levels in real time.
        // var testIndex1 = 0;
        // if (testIndex1 > 0) {
        //     for (var x = 0; x < testIndex1; x++) {
        //         columnLevels.push(new Level("TESTcolumnLevel" + x, "TESTcolumnLevel" + x, null, DataType.STRING, true, null));
        //     }
        // }
        // var testIndex2 = 0;
        // if (testIndex2 > 0) {
        //     for (var x = 0; x < testIndex2; x++) {
        //         columnLevels.pop();
        //     }
        // }
        return columnLevels;
    };

    CrosstabUtil.createColumnHierarchy = function (context, columnLevels) {
        var columnHierarchy = new Hierarchy("columnHierarchy", "Column Hierarchy Label", columnLevels);
        return columnHierarchy;
    };

    CrosstabUtil.createColumnHeaderDisplayTree = function (context) {

        // Get the option value to show labels or name for the DataItem
        var showLabels = context.getOptionShowLabels().value;

        var _walkTreeGetColumnItems = function(obj, childIndex, node) {
            if (obj) {
                if (obj.children.length > 0) {

                    // Display tree node is set to display the dataItem's label.
                    // Attached to the node is a DataValue object with the dataItem's id.
                    var dv = new DataValue(obj.item.id, -1);

                    // Retrieve the correct string to display for the label of the node
                    var label = obj.item.getDisplayLabel(showLabels);

                    // NOTE: Since we display the regular base Horizon for the BaseCase Horizon in the Crosstab,
                    // we need to adjust the label for that DisplayTreeNode when the Display Horizons option setting
                    // is Relative.  This will give off the impression that the Crosstab and Data Pane are using the same
                    // Horizon data item even though they are not
                    if (context.getCubeDataModel().isDataItemBaseCaseHorizon(obj.item)) {
                        var displayHorizons = context.getOptionDisplayHorizons().value;
                        if (displayHorizons === HprConstants.DISPLAY_HORIZONS_RELATIVE_VALUE) {
                            label = obj.item.constructBaseCaseString();
                        }
                    }

                    // #%&@ $^@$ hack to get peer nodes not to collapse in the ITJS crosstab because
                    // they have the same label such as date in horizons.
                    // \u2060 = https://en.wikipedia.org/wiki/Word_joiner = The word joiner does not produce
                    // any space, and prohibits a line break at its position.
                    var pad = "";
                    for (var i = 0; i <= childIndex; i++) {
                        //pad = pad + '\u2060'; //COLPADCHAR
                        pad = pad + CrosstabUtil.COLPADCHAR;
                    }
                    var newNode = new DisplayTreeNode(label+pad, dv);

                    node.addChild(newNode);

                    newNode.setSpan(obj.children.length);

                    _.each(obj.children, function(child, index) {
                        _walkTreeGetColumnItems(child, index, newNode);
                    });
                }
            }
        };

        var rootNode = new DisplayTreeNode("root", null);

        _.each(context.columnTree.children, function(child, columnIndex, list) {

            _walkTreeGetColumnItems(child, columnIndex, rootNode);
        });

        //Debug hack so I can enable/disable print by changing "a" value in debug session.
        var a = 1;
        if (a > 0) {
            rootNode.print(50);
        }
        return rootNode;
    };

    CrosstabUtil.isStalenessStatistic = function(statDataItem){
        if (statDataItem && statDataItem.getType() === sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC) {
            if (statDataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.STALENESS ||
                statDataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.ALERTDATETIME ||
                statDataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.EXPIREDATETIME) {
                return true;
            }
        }
        return false;
    };

    CrosstabUtil.isNinstStatistic = function(statDataItem){
        if (statDataItem && statDataItem.getType() === sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC) {
            if (statDataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.NINST) {
                return true;
            }
        }
        return false;
    };

    CrosstabUtil.getStalenessColumnIndexes = function (context) {
        var stalenessColumnIndex = -1;

        var columnIndexes = [];

        if (context) {

            _.each(context.getTuples(), function(element, index, list){
                var statObject = context.getStatisticFromColumn(element);
                if (statObject) {
                    var stat = statObject.dataItem;
                    if (stat.name === sas.analytics.riskhp.models.dataitems.Statistic.STALENESS) {
                        columnIndexes.push(index);
                    }
                }
            });
        }
        return columnIndexes;
    };


    CrosstabUtil._lastIndexOf=function(arr, item) {

        for (var idx = arr.length - 1; idx >= 0; idx--){
            if (arr[idx].item === item) {
                return idx;
            }
        }
        return -1;
    };

    CrosstabUtil.findBaseHorizon = function(tuple, index, cubeDataModel) {
        var basecaseIndicated = false;
        var horizon = undefined;
        var proxyHorizon = tuple[index];

        if (proxyHorizon.type === sas.analytics.riskhp.models.dataitems.Horizon.HORIZON) {
            return proxyHorizon;
        }

        var searchKey;
        if (proxyHorizon.basecase && proxyHorizon.basecase === true) {
            basecaseIndicated = true;
            //searchKey = {basecase: true}
        }
        //else {
            if (proxyHorizon.type === sas.analytics.riskhp.models.dataitems.RelativeHorizon.RELATIVEHORIZON) {
                searchKey = {horizonNumber: proxyHorizon.horizonNumber, interval: proxyHorizon.interval, basecase: proxyHorizon.basecase};
            }
            else {
                searchKey = {horizonDate: proxyHorizon.horizonDate, basecase: proxyHorizon.basecase};
            }
        // }

        var scenarioDataItem = _.findWhere(tuple, {type: sas.analytics.riskhp.models.dataitems.Scenario.SCENARIO});
        var resultSetDataItem = _.findWhere(tuple, {type: sas.analytics.riskhp.models.dataitems.ResultSet.RESULTSET});
        // resultset in tuple and basecase indicated, then get find the horizon there
        if (resultSetDataItem !== undefined && basecaseIndicated) {
            horizon = resultSetDataItem.horizon;
        }
        // Scenario in tuple, then get the horizon there
        else if (scenarioDataItem !== undefined) {
            horizon = _.findWhere(scenarioDataItem.horizons, searchKey);
            // scenario might have changed, let's fetch it from the data source
            if (!horizon) {
                scenarioDataItem = cubeDataModel.getDataItemById(scenarioDataItem.getId());
                if (scenarioDataItem) {
                    horizon = _.findWhere(scenarioDataItem.horizons, searchKey);
                }
            }
        }
        else {
            // Riskcube in tuple, then get the horizon there.
            var riskCubeDataItem = _.findWhere(tuple, {type: sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE});
            if (riskCubeDataItem !== undefined) {
                horizon = _.findWhere(riskCubeDataItem.horizons, searchKey);
            }
        }

        if (horizon === undefined) {
            // Catchall, just go to the big horizon list in the data model.
            horizon = _.findWhere(cubeDataModel.horizon, searchKey);
        }

        return horizon;
    };

    /**
     *
     * @param tuple
     * @param cubeDataModel
     * @returns {CapabilitiesObject}
     */
    CrosstabUtil.getCapabilities = function(tuple, cubeDataModel) {
        // Find capabilities from the tuple dataItems
        var riskCubeDataItem = _.findWhere(tuple, {type: RISKCUBE});
        if (riskCubeDataItem && riskCubeDataItem !== undefined) {
            return riskCubeDataItem.capabilities;
        }

        // Find a default capabilities to use.
        else {
            var firstRiskCube = cubeDataModel.riskCube[0]; //FIXME is this the default for the whole cube?
            if (firstRiskCube && firstRiskCube !== undefined) {
                return firstRiskCube.capabilities;
            }
        }
        return undefined;
    };

    CrosstabUtil.hasCashflows = function(cubeDataModel) {
        return (cubeDataModel.cashFlowLeg.length > 0);
    };

    CrosstabUtil.isClassvarDataItemType = function(dataItem) {
        var isCVType = false;
        switch(dataItem.type) {
            case CLASSVAR:
            case HIERARCHY:
                isCVType = true;
                break;
        }
        return isCVType;
    };

    CrosstabUtil.isHeaderDataItem = function(key) {
        var isFake = false;
        switch (key) {
            case CrosstabUtil.COMPVARHEADER:
            case CrosstabUtil.BENCHVARHEADER:
            case CrosstabUtil.ROWSTATHEADER:
            case CrosstabUtil.BASECASEHEADER:
                isFake = true;
                break;
        }
        return isFake;
    };

    CrosstabUtil.getHeaderDataItemObject = function(column) {
        var headerDataItem;
        for (var a = 0; a < column.length; a++) {
            if (CrosstabUtil.isHeaderDataItem(column[a].id)) {
                headerDataItem = column[a];
                return {item: headerDataItem, index: a};
            }
        }
        return undefined;
    };

    CrosstabUtil.removeHeaderFromColumn = function(column) {
        var headerDataItemObject = CrosstabUtil.getHeaderDataItemObject(column);
        if (headerDataItemObject) {
            column.splice(headerDataItemObject.index, 1);
        }
    };

    CrosstabUtil.CompvarHeaderDataItem = {
        type: CrosstabUtil.COMPVARHEADER,
        name: CrosstabUtil.COMPVARHEADER,
        id: CrosstabUtil.COMPVARHEADER,
        getId: function () { return this.id; },
        getType: function () { return this.type; },
        label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.compvar.txt"),
        getLabel: function () { return this.label; },
        // For these fake DataItems, ignore showLabels argument and just return label
        getDisplayLabel: function (showLabels) { return this.label; },
        getName: function() {return this.name;}
    };

    CrosstabUtil.BenchvarHeaderDataItem = {
        type: CrosstabUtil.BENCHVARHEADER,
        name: CrosstabUtil.BENCHVARHEADER,
        id: CrosstabUtil.BENCHVARHEADER,
        getId: function () { return this.id; },
        getType: function() {return this.type;},
        label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.benchvar.txt"),
        getLabel: function() {return this.label;},
        // For these fake DataItems, ignore showLabels argument and just return label
        getDisplayLabel: function (showLabels) { return this.label; },
        getName: function() {return this.name;}
    };

    CrosstabUtil.RowstatHeaderDataItem = {
        type: CrosstabUtil.ROWSTATHEADER,
        name: CrosstabUtil.ROWSTATHEADER,
        id: CrosstabUtil.ROWSTATHEADER,
        getId: function () { return this.id; },
        getType: function() {return this.type;},
        label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.rowstat.txt"),
        getLabel: function() {return this.label;},
        // For these fake DataItems, ignore showLabels argument and just return label
        getDisplayLabel: function (showLabels) { return this.label; },
        getName: function() {return this.name;}
    };

    CrosstabUtil.BasecaseHeaderDataItem = {
        type: CrosstabUtil.BASECASEHEADER,
        name: CrosstabUtil.BASECASEHEADER,
        id: CrosstabUtil.BASECASEHEADER,
        getId: function () { return this.id; },
        getType: function() {return this.type;},
        label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.basecase.txt"),
        getLabel: function() { return this.label; },
        // For these fake DataItems, ignore showLabels argument and just return label
        getDisplayLabel: function (showLabels) { return this.label; },
        getName: function() { return this.name; }
    };


    CrosstabUtil.getDataItem = function(name, type, cubeDataModel) {
        var dataItem = undefined;
        switch(type) {
            //Header DATAITEMS for crosstab header nodes
            case CrosstabUtil.COMPVARHEADER:
                // dataItem = {
                //     type: CrosstabUtil.COMPVARHEADER,
                //     name: CrosstabUtil.COMPVARHEADER,
                //     id: CrosstabUtil.COMPVARHEADER,
                //     getId: function () { return this.id },
                //     getType: function () { return this.type },
                //     label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.compvar.txt"),
                //     getLabel: function () { return this.label },
                //     // For these fake DataItems, ignore showLabels argument and just return label
                //     getDisplayLabel: function (showLabels) { return this.label },
                //     getName: function() {return this.name}
                // };
                dataItem = CrosstabUtil.CompvarHeaderDataItem;
                break;
            case CrosstabUtil.BENCHVARHEADER:
                // dataItem = {
                //     type: CrosstabUtil.BENCHVARHEADER,
                //     name: CrosstabUtil.BENCHVARHEADER,
                //     id: CrosstabUtil.BENCHVARHEADER,
                //     getId: function () { return this.id },
                //     getType: function() {return this.type},
                //     label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.benchvar.txt"),
                //     getLabel: function() {return this.label},
                //     // For these fake DataItems, ignore showLabels argument and just return label
                //     getDisplayLabel: function (showLabels) { return this.label },
                //     getName: function() {return this.name}
                // };
                dataItem = CrosstabUtil.BenchvarHeaderDataItem;
                break;
            case CrosstabUtil.ROWSTATHEADER:
                // dataItem = {
                //     type: CrosstabUtil.ROWSTATHEADER,
                //     name: CrosstabUtil.ROWSTATHEADER,
                //     id: CrosstabUtil.ROWSTATHEADER,
                //     getId: function () { return this.id },
                //     getType: function() {return this.type},
                //     label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.rowstat.txt"),
                //     getLabel: function() {return this.label},
                //     // For these fake DataItems, ignore showLabels argument and just return label
                //     getDisplayLabel: function (showLabels) { return this.label },
                //     getName: function() {return this.name}
                // };
                dataItem = CrosstabUtil.RowstatHeaderDataItem;
                break;
            case CrosstabUtil.BASECASEHEADER:
                // dataItem = {
                //     type: CrosstabUtil.BASECASEHEADER,
                //     name: CrosstabUtil.BASECASEHEADER,
                //     id: CrosstabUtil.BASECASEHEADER,
                //     getId: function () { return this.id },
                //     getType: function() {return this.type},
                //     label: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Crosstab.header.basecase.txt"),
                //     getLabel: function() { return this.label },
                //     // For these fake DataItems, ignore showLabels argument and just return label
                //     getDisplayLabel: function (showLabels) { return this.label },
                //     getName: function() { return this.name }
                // };
                dataItem = CrosstabUtil.BasecaseHeaderDataItem;
                break;
            default:
                dataItem = cubeDataModel.getDataItemByNameAndType(name, type);
                break;
        }
        return dataItem;
    };

    CrosstabUtil.getDataItemById = function(id, type, cubeDataModel) {
        var dataItem = undefined;
        switch(id) {
            //Header DATAITEMS for crosstab header nodes
            case CrosstabUtil.COMPVARHEADER:
                dataItem = CrosstabUtil.CompvarHeaderDataItem;
                break;
            case CrosstabUtil.BENCHVARHEADER:
                dataItem = CrosstabUtil.BenchvarHeaderDataItem;
                break;
            case CrosstabUtil.ROWSTATHEADER:
                dataItem = CrosstabUtil.RowstatHeaderDataItem;
                break;
            case CrosstabUtil.BASECASEHEADER:
                dataItem = CrosstabUtil.BasecaseHeaderDataItem;
                break;
            default:
                dataItem = cubeDataModel.getDataItemById(id);
                break;
        }
        return dataItem;
    };

    CrosstabUtil.getDataItemByIdType = function(id, type, basecase, cubeDataModel) {
        var dataItem = undefined;
        switch(type) {
            //Header DATAITEMS for crosstab header nodes
            case CrosstabUtil.COMPVARHEADER:
                dataItem = CrosstabUtil.CompvarHeaderDataItem;
                break;
            case CrosstabUtil.BENCHVARHEADER:
                dataItem = CrosstabUtil.BenchvarHeaderDataItem;
                break;
            case CrosstabUtil.ROWSTATHEADER:
                dataItem = CrosstabUtil.RowstatHeaderDataItem;
                break;
            case CrosstabUtil.BASECASEHEADER:
                dataItem = CrosstabUtil.BasecaseHeaderDataItem;
                break;
            case ABSOLUTEHORIZON:
                if (basecase !== undefined) {
                    dataItem = _.findWhere(cubeDataModel.absoluteHorizon, {id: id, basecase: basecase});
                }
                else {
                    dataItem = cubeDataModel.getDataItemById(id); // fallback
                }
                break;
            default:
                dataItem = cubeDataModel.getDataItemById(id);
                break;
        }
        return dataItem;
    };

    CrosstabUtil.getDataItemFromDraggable = function(draggable) {
        var draggableObjectId = draggable.rowId;
        var dataSourceId = draggable.dataSourceId;
        var dataSourceDeferred = DataSourceCacheManager.getDataSource(dataSourceId);
        // Note: This will return null if the returned deferred is not resolved.  This should never happen
        var item = null;
        dataSourceDeferred.done(function(cubeDataModel){
            item = CrosstabUtil.getDataItemById(draggableObjectId,null,cubeDataModel);
        });
        return item;
    };

    CrosstabUtil._getNodeKeys = function(node) {
        var keys = [];
        while (node && !node.isRoot()){
            var dv = node.getValue(); // type is sas.ltjs.commons.models.data.DataValue
            var dvString = dv.getStringValue();
            //keys.push(CrosstabUtil.stringTrim(dvString));
            keys.push(dvString);
            node = node.getParent();
        }
        keys.reverse();
        return keys;
    };

    CrosstabUtil.getUniqueNodePathValues = function(uniqueNodePath, context) {
        return uniqueNodePathValues = _.map(uniqueNodePath, function(aNode) {
            // Check for an '&' in the value, if so remove it.
            // Hackish.  This '&' is added to the name of dummy parent node in indented mode.
            var value = aNode.getFormattedValue();
            if ((value.length > 0) && (value[value.length -1] === '&') && context.getRowIndent()) {
                return value.slice(0, value.length -1);
            }
            return aNode.getFormattedValue();
        });

    };

    CrosstabUtil.stringTrim = function(str) {

        var x = str.length - 1;
        while(str[x] === CrosstabUtil.COLPADCHAR) {
            str = str.substr(0, x);
            x--;
        }
        return str;
    };

    CrosstabUtil.getPickInfo = function(pickResults, context) {

        var pickInfo = {};

        if (pickResults) {
            //var entries = pickResult.getEntries();
            var entries = pickResults[0].getEntries();
            if (entries) {
                // Entries is an array but not sure where there would ever be more than one for a gesture/mouse event.
                // Only handle first one unless otherwise needed.
                var entry = entries[0];  // Should be a DataGridPickResultEntry
                if (entry) {
                    if (entry instanceof CrosstabPickResultEntry) {
                        var type = entry.getType();

                        //FIXME below: some vars never used
                        var columnIndex = entry.getColumnIndex();
                        var dropIndex = entry.getDropIndex();
                        var pickId = entry.getPickId();
                        var rowIndex = entry.getRowIndex();
                        var selected = entry.getSelected();
                        var sparkCell = entry.getSparkCell();
                        var formattedValue = entry.getFormattedValue();
                        var label = entry.getLabel();
                        var useAsTooltip = entry.getUseAsTooltip();
                        var value = entry.getValue();

                        var buttonType = entry.getButtonType();
                        var hierarchyName = entry.getHierarchyName();
                        var index = entry.getIndex();

                        // sas.ltjs.commons.models.data.tree.DataTreeNode
                        var node = entry.getNode();
                        if (node) {
                            //var nodeChildForFormattedValue = node.getChildForFormattedValue(value);
                            //var nodeChildNodesAtLevel = node.getChildNodesAtLevel(level);
                            var nodeChildren = node.getChildren();
                            var nodeDepth = node.getDepth();
                            var nodeFormattedValue = node.getFormattedValue();
                            var nodeLeafNodes = node.getLeafNodes();
                            var nodeLevel = node.getLevel();
                            var nodeMeasureAggregators = node.getMeasureAggregators();
                            var nodeMeasureNames = node.getMeasureNames();
                            var nodeMeasurevalues = node.getMeasureValues();
                            var nodeNumberOfChildren = node.getNumberOfChildren();
                            var nodeNumberOfMeasures = node.getNumberOfMeasures();
                            var nodeParent = node.getParent();
                            //var nodeParentNodeAtLevel = node.getParentNodeAtLevel(level);
                            var nodeRoot = node.getRoot();
                            var nodeRowIndexVector = node.getRowIndexVector();
                            //var nodeUniqueNodePath = node.getUniqueNodePath(/*arguments*/);
                            var nodeValue = node.getValue();
                            var nodeIsCollapsed = node.isCollapsed();
                            var nodeIsFirstChild = node.isFirstChild();
                            var nodeIsLastChild = node.isLastChild();
                            var nodeIsRoot = node.isRoot();
                        }
                        //FIXME above: some vars never used

                        // Get location and dimension of the cell.
                        var cellLocation = {x: entry.getX(), y: entry.getY(), height: entry.getCellHeight(), width: entry.getCellWidth()};

                        // Find the location to display a tooltip
                        var tooltipLocation = pickResults[0].getPreferredTargetLocation();

                        if (type === PickEntryType.CROSSTAB_ROW_HEADER) {

                            var uniqueNodePath = node.getUniqueNodePath();
                            // var uniqueNodePathValues = _.map(uniqueNodePath, function(aNode) {
                            //     // Check for an '&' in the value, if so remove it.
                            //     // Hackish.  This '&' is added to the name of dummy parent node in indented mode.
                            //     var value = aNode.getFormattedValue();
                            //     if ((value.length > 0) && (value[value.length -1] === '&') && context.getRowIndent()) {
                            //         return value.slice(0, value.length -1);
                            //     }
                            //     return aNode.getFormattedValue();
                            // });
                            var uniqueNodePathValues = CrosstabUtil.getUniqueNodePathValues(uniqueNodePath, context);

                            var pathByLabel = context.drillpath.concat(uniqueNodePathValues);
                            var pathByName = context.convertRowKeyLabelToName(pathByLabel);

                            var cvValues = context.convertRowKeyLabelToName(uniqueNodePathValues);

                            var name = entry.getNode().getFormattedValue();

                            pickInfo = {
                                pickEntryType: type,
                                name: name,
                                // keys: cvValues,
                                // displayedKeys: uniqueNodePathValues,
                                keys: pathByName,
                                displayedKeys: pathByLabel,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else if (type === PickEntryType.CROSSTAB_MEASURE_HEADER) {
                            var tuple;
                            var columnIndex = entry.getIndex();
                            var column = context.getColumn(columnIndex);
                            var tupleObject = context.getTupleObjects()[columnIndex];
                            if (tupleObject) {
                                tuple = tupleObject.tuple;
                            }
                            var measureName;
                            var dataItemType;
                            if (column && column.length > 0) {
                                // Display the correct label based on the value of the showLabels option
                                var showLabels = context.getOptionShowLabels().value;
                                measureName = column[column.length - 1].getDisplayLabel(showLabels);
                                dataItemType = column[column.length - 1].type;
                            }

                            //Get some kind of column info  (might not be needed here)
                            var columnKeys = _.pluck(column, 'id');

                            // NOTE: column contains dataItems directly from the column tree (only relative or
                            // absolute horizons.  Tuple is the same thing but with the base horizon.
                            // USE column when dealing with the crosstab columnTree.
                            // USE tuple when the need for dealing with the midtier, like plots
                            pickInfo = {
                                pickEntryType: type,
                                name: measureName,
                                dataItemType: dataItemType,
                                tuple: tuple,
                                column: column,
                                columnIndex: columnIndex,
                                keys: columnKeys,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else if (type === PickEntryType.CROSSTAB_COLUMN_HEADER) {
                            var entryNode = entry.getNode();
                            var nodeName = entryNode.getFormattedValue().trim();
                            var name = CrosstabUtil.stringTrim(nodeName);
                            //var dataItemType = CrosstabUtil.getEntryDataItemType(entry, nodeName, context);

                            //Get some kind of column info
                            var node = entryNode;
                            var columnKeys = CrosstabUtil._getNodeKeys(node);
                            var columnNode = context.findColumnTreeNode(columnKeys);
                            var dataItemType = columnNode.item.type;

                            pickInfo = {
                                pickEntryType: type,
                                name: name,
                                dataItemType: dataItemType,
                                keys: columnKeys,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else if (type === PickEntryType.CROSSTAB_ROW_AXIS_LABEL_HEADER) {
                            var name = entry.getLabel().trim();

                            pickInfo =  {
                                pickEntryType: type,
                                name: name,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else if (type === PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER) {
                            var name = entry.getLabel().trim();

                            pickInfo =  {
                                pickEntryType: type,
                                name: name,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else if (type === PickEntryType.CROSSTAB_DATA_CELL) {
                            var name = entry.getLabel().trim();
                            var columnIndex = entry.getColumnIndex();
                            // Get tuples for external use.  (no abs or rel horizons, but real horizons, no fake headers)
                            var tuple = context.getTuples()[columnIndex];
                            var column = context.getColumn(columnIndex);
                            var rowIndex = entry.getRowIndex();
                            var expansionObject = context.getDataResultExpansionObject(rowIndex);

                            // NOTE: column contains dataItems directly from the column tree (only relative or
                            // absolute horizons.  Tuple is the same thing but with the base horizon.
                            // USE column when dealing with the crosstab columnTree.
                            // USE tuple when the need for dealing with the midtier, like plots
                            pickInfo =  {
                                pickEntryType: type,
                                name: name,
                                rowIndex: rowIndex,
                                columnIndex: columnIndex,
                                tuple: tuple,
                                column: column,
                                expansion: expansionObject.expansion,
                                dataResultPathObject: expansionObject.dataResultPathObject,
                                tooltipLocation: tooltipLocation,
                                cellLocation: cellLocation
                            };

                        } else {
                            sas.log.info("CrosstabUtil.getPickInfo unknown PickEntryType");
                        }
                    }
                }
            }
        }
        return pickInfo;
    };

    CrosstabUtil.getEntryDataItemType = function(entry, nodeName, context) {
        var self = this;
        var dataItemType;

        switch(entry.getType()) {
            case PickEntryType.CROSSTAB_ROW_HEADER:

                break;
            case PickEntryType.CROSSTAB_ROW_AXIS_LABEL_HEADER:

                break;
            case PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER:

                break;
            case PickEntryType.CROSSTAB_COLUMN_HEADER:
                if (nodeName === CrosstabUtil.CompvarHeaderDataItem.getLabel()) {
                    dataItemType = CrosstabUtil.CompvarHeaderDataItem.type;
                }
                else if (nodeName === CrosstabUtil.BenchvarHeaderDataItem.getLabel()) {
                    dataItemType = CrosstabUtil.BenchvarHeaderDataItem.type;
                }
                else if (nodeName === CrosstabUtil.RowstatHeaderDataItem.getLabel()) {
                    dataItemType = CrosstabUtil.RowstatHeaderDataItem.type;
                }
                else if (nodeName === CrosstabUtil.BasecaseHeaderDataItem.getLabel()) {
                    dataItemType = CrosstabUtil.BasecaseHeaderDataItem.type;
                } else {
                    var node = entry.getNode();
                    if (node) {
                        var nodeLevel = node.getLevel();
                        var idx = node.getLevel() - 1;  // column headers are zero based, crosstab column headers are 1s based (because of unseen root node)
                        if (idx < context.columnHierarchyMembers.length) {
                            dataItemType = context.columnHierarchyMembers[idx].type;
                        }
                    }
                }
                break;
            case PickEntryType.CROSSTAB_MEASURE_HEADER:
                //dataItemType = self.getMeasureType();
                break;
            case PickEntryType.CROSSTAB_DATA_CELL:
                break;
            default:
                break;
        } //switch

        return dataItemType;
    };

    CrosstabUtil.copyTextToClipboard = function(text) {
        var textArea = document.createElement("textarea");

        //
        // *** This styling is an extra step which is likely not required. ***
        //
        // Why is it here? To ensure:
        // 1. the element is able to have focus and selection.
        // 2. if element was to flash render it has minimal visual impact.
        // 3. less flakyness with selection and copying which **might** occur if
        //    the textarea element is not visible.
        //
        // The likelihood is the element won't even render, not even a flash,
        // so some of these are just precautions. However in IE the element
        // is visible whilst the popup box asking the user for permission for
        // the web page to copy to the clipboard.
        //

        // Place in top-left corner of screen regardless of scroll position.
        textArea.style.position = 'fixed';
        textArea.style.top = 0;
        textArea.style.left = 0;

        // Ensure it has a small width and height. Setting to 1px / 1em
        // doesn't work as this gives a negative w/h on some browsers.
        textArea.style.width = '2em';
        textArea.style.height = '2em';

        // We don't need padding, reducing the size if it does flash render.
        textArea.style.padding = 0;

        // Clean up any borders.
        textArea.style.border = 'none';
        textArea.style.outline = 'none';
        textArea.style.boxShadow = 'none';

        // Avoid flash of white box if rendered for any reason.
        textArea.style.background = 'transparent';


        textArea.value = text;

        document.body.appendChild(textArea);

        textArea.select();

        try {
            var successful = document.execCommand('copy');
            var msg = successful ? 'successful' : 'unsuccessful';
            console.log('Copying text command was ' + msg);
        } catch (err) {
            console.log('Oops, unable to copy');
        }

        document.body.removeChild(textArea);
    };

    CrosstabUtil.buildPlotDataObject = function(crosstab, plotType, info) {

        // Need to ensure startRow information for subportfolio request contains
        // startRow paging for parent to the request node.
        if (plotType.ByType === HprConstants.ByType.Subportfolio) {
            if (info.dataResultPathObject && info.dataResultPathObject.node && info.dataResultPathObject.node.parent) {
                info.expansion.startRow = info.dataResultPathObject.node.parent.startRow;
            }
        }
        // Handle situation where a second call doesn't have an expansion in the info object for some reason
        var requests = null;
        if (info && info.expansion) {
            requests = [info.expansion];
        }
        return {
            type: HprConstants.HPR_PLOT_PANEL,
            plotType: plotType,
            classVariables: crosstab.context.getClassVariables(),
            drill: crosstab.context.findRowTreePath(crosstab.context.drillnode, "name"),
            tuples: [info.tuple],
            sourceColumn: info.column,
            displayHorizons: crosstab.context.optionDisplayHorizons.value,
            showLabels: crosstab.context.optionShowLabels.value,
            dataSourceId: crosstab.context.dataSourceId,
            cacheId: crosstab.context.id, // Must send to midtier to access the correct cache
            sorts: crosstab.context.buildSortJSON(),
            options: crosstab.context.buildOptionsJSON(),
            filters: crosstab.context.getFilters(),
            crosstabId: crosstab.context.id,
            requests: requests
        };
    };

    /**
     * Creates a column template object for the given column array and comparisonDataItemObject.  If the
     * comparisonDataItemObject is a RiskCube then this method will call createColumnTemplateForRiskCube as there is
     * a bit of extra processing that needs to occur
     * @param {DataItem[]} column - The source column to generate the template from
     * @param {DataItem} comparisonDataItemObject - The item to be wildcarded
     * @param {CrosstabContext} context
     * @returns {TemplateItem[]}
     */
    CrosstabUtil.createColumnTemplate = function(column, comparisonDataItemObject, context) {
        if (comparisonDataItemObject.type === sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE) {
            return CrosstabUtil.createColumnTemplateForRiskCube(column, comparisonDataItemObject, context);
        }
        var template = [];
        for (var i = 0; i < column.length; i++) {
            if (column[i].type === comparisonDataItemObject.type) {
                template.push({item: undefined, type: column[i].type}); // wildcard
            } else {
                template.push({item: column[i], type: column[i].type});
            }
        }
        return template;
    };

    /**
     * Handles the special case of building a template column for a RiskCube query
     * @param {DataItem[]} column
     * @param {DataItem} comparisonDataItemObject
     * @param {CrosstabContext} context
     * @returns {Array}
     */
    CrosstabUtil.createColumnTemplateForRiskCube = function(column, comparisonDataItemObject, context) {
        var template = [],
            isInRelativeMode = context.isInRelativeMode();
        for (var i = 0; i < column.length; i++) {
            if (column[i].type === comparisonDataItemObject.type) {
                template.push({item: undefined, type: column[i].type}); // wildcard
            } else {
                // This is pending a discussion with Katie on Defect S1395005
                // if (!isInRelativeMode && context.isAnyHorizonType(column[i])) {
                //     template.push({item: undefined, type: column[i].type}); // wildcard horizon as we want all the cubes included
                // }
                // else {
                    template.push({item: column[i], type: column[i].type});
                }
//            }
        }
        return template;
    };

    /**
     * Returns the lowest level data item in the tuple list that isn't an outvar, statistic or result set (per defect S1418043)
     * @param tuple
     * @returns {DataItem}
     */
    CrosstabUtil.getComparisonDataItemObject=function(tuple){
        for (var i = tuple.length - 1; i >= 0; i--) {
            if ((tuple[i].type !== STATISTIC) && (tuple[i].type !== OUTVAR) && (tuple[i].type !== RESULTSET)){
                return {item: tuple[i], index: i, type: tuple[i].type};
            }
        }
        return undefined;
    };

    /**
     * Creates a special column template where both the scenario, resultset, and any type of
     * horizon are wildcarded
     * @param {DataItem[]} column - The source column to generate the template from
     * @param {CrosstabContext} context
     * @returns {TemplateItem[]}
     */
    CrosstabUtil.createColumnTemplateForScenariosAndResultSets = function(column, context) {
        var template = [];
        //var template = column.concat();
        for (var i = 0; i < column.length; i++) {
            if ((column[i].type === sas.analytics.riskhp.models.dataitems.Scenario.SCENARIO) ||
                (column[i].type === sas.analytics.riskhp.models.dataitems.ResultSet.RESULTSET) ) {
                template.push({item: undefined, type: column[i].type}); // wildcard
            }
            else if (context.isAnyHorizonType(column[i])) {
                template.push({item: undefined, type: column[i].type}); // wildcard
            }
            else {
                template.push({item: column[i], type: column[i].type});
            }
        }
        return template;
    };

    /**
     * @description For the tupleList to be valid for a cashflow we must have an outvar, horizon and statistic
     * in the tuple.  This defect isolates the code to one place to do this check. See defect S1412471
     * @param {DataItem[]} tupleList
     * @param {HprCrosstab} crosstab
     * @returns {boolean}
     */
    CrosstabUtil.isTupleColumnValidForCashflowPlot = function(tupleList, crosstab) {
        var outvar = crosstab.context.getDataItemInfoFromTuple(tupleList, sas.analytics.riskhp.models.dataitems.Outvar.OUTVAR);

        var horizon = _.find(tupleList, function(dataItem) {
            return dataItem.type === sas.analytics.riskhp.models.dataitems.Horizon.HORIZON ||
                dataItem.type === sas.analytics.riskhp.models.dataitems.RelativeHorizon.RELATIVEHORIZON ||
                dataItem.type === sas.analytics.riskhp.models.dataitems.AbsoluteHorizon.ABSOLUTEHORIZON ;
        });

        var statistic = crosstab.context.getDataItemInfoFromTuple(tupleList, sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC);

        if (!outvar || !horizon || !statistic) {
            return false;
        }
        return true;
    };

    /**
     * @description Returns the number of plots linked to the crosstab with the passed in id
     * @param {string} crosstabId
     * @returns {number}
     */
    CrosstabUtil.numLinkedPlots = function(crosstabId) {
        var selectedRiskPanelsView = sas.analytics.riskhp.utils.HprUtil.getPanelsViewForComponent(crosstabId);
        if (selectedRiskPanelsView) {
            var delegate = selectedRiskPanelsView.getDelegate();
            var linkedPlots = _.filter(delegate.plotIds, function(plotId) {
                var chartView = sap.ui.getCore().byId(plotId);
                if (chartView) {
                    var chartModel = chartView.getChartModel();
                    if (chartModel) {
                        return crosstabId === chartModel.crosstabId && chartModel.linkedToCrosstab;
                    }
                }
                return false;
            });
            var linkedTables = _.filter(delegate.tableIds, function(tableId) {
                var tableView = sap.ui.getCore().byId(tableId);
                if (tableView) {
                    var tableModel = tableView.getTableViewerModel();
                    if (tableModel) {
                        return crosstabId === tableModel.crosstabId && tableModel.linkedToCrosstab;
                    }
                }
                return false;
            });
            return linkedPlots.length + linkedTables.length;
        }
        return 0;
    };

    /**
     * @description Notify linked plots that a change was made to the crosstab.  This first checks to
     *      see if there are any plots currently linked to the passed in Crosstab and only if that is true is the event fired.
     *
     * @param {HprCrosstab} crosstab
     */
    CrosstabUtil.notifyLinkedPlotsOfChange = function(crosstab) {
        if (sas.analytics.riskhp.common.riskcommons.CrosstabUtil.hasLinkedPlots(crosstab)) {
            sas.analytics.riskhp.common.riskcommons.CrosstabUtil.notifyLinkedPlotsOfOptionsOrFilterChange(crosstab);
        }
    };

    /**
     * @description Does the passed in crosstab have any linked plots
     * @param {HprCrosstab} crosstab
     * @returns {boolean}
     */
    CrosstabUtil.hasLinkedPlots = function(crosstab) {
        return (sas.analytics.riskhp.common.riskcommons.CrosstabUtil.numLinkedPlots(crosstab.getId()) > 0);
    };

    /**
     * @description Funtion to call to notify any plots, linked to the crosstab, that it's options or filter has been applied(changed)
     * @param {HprCrosstab} crosstab
     */
    CrosstabUtil.notifyLinkedPlotsOfOptionsOrFilterChange = function(crosstab) {
        // Publish an event that any linked plots should be updated
        // It's important to note that HprChartModel.handleCrosstabUpdated is called when this event is fired.  In that
        // code it looks at this data object and will only refresh IFF the currently held items do not match these new
        // items.  This is done in an attempt to distinguish between adding/removing a column from the crosstab and
        // a change in the crosstab's options.  The point is, if structure of this object changes in any way, one should
        // also check the HprChartModel.handlCrosstabUpdated method where it checks these things so it is consistent.
        var data = {
            classVariables: crosstab.context.getClassVariables(),
            drill: crosstab.context.findRowTreePath(crosstab.context.drillnode, "name"),
            displayHorizons: crosstab.context.optionDisplayHorizons.value,
            showLabels: crosstab.context.optionShowLabels.value,
            dataSourceId: crosstab.context.dataSourceId,
            cacheId: crosstab.context.id, // Must send to midtier to access the correct cache
            sorts: crosstab.context.buildSortJSON(),
            options: crosstab.context.buildOptionsJSON(),
            filters: crosstab.context.getFilters(),
            crosstabId: crosstab.context.id,
        };

        sas.eventBus.publish(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_UPDATE_LINKED_PLOTS, {
            crosstabId: crosstab.getId(),
            info: data,
            selectedCellChanged: false
        });
    };

})();