// (c) 2017, SAS Institute Inc.

/**
 * Created by bigree on 4/5/2016.
 *
 * @name sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab
 */
jQuery.sap.declare("sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab");

jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require("sas.ltjs.ltjsLoader");
jQuery.sap.require("sas.ltjs.commons.gestures.GestureHelper");
jQuery.sap.require("sas.ltjs.commons.pickResults.PickEntryType");
jQuery.sap.require("sas.ltjs.commons.models.data.sorting.SortDirection");
jQuery.sap.require("sas.ltjs.commons.crosstab.CrosstabPickResultEntry");
jQuery.sap.require("sas.ltjs.commons.views.Visualization");
jQuery.sap.require("sas.ltjs.commons.models.crosstab.Crosstab");
jQuery.sap.require("sas.ltjs.commons.crosstab.DisplayTreeNode");
jQuery.sap.require("sas.ltjs.commons.crosstab.CrosstabPickButtonType");
jQuery.sap.require("sas.ltjs.commons.crosstab.CrosstabModelBuilder");
jQuery.sap.require("sas.ltjs.commons.util.CrosstabUtilities");
jQuery.sap.require("sas.ltjs.commons.models.data.hierarchy.Level");
jQuery.sap.require("sas.ltjs.commons.models.data.hierarchy.Hierarchy");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.Column");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataSet");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataType");
jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataUsage");
jQuery.sap.require("sas.ltjs.commons.models.datagrid.DataGridColumnInfo");
jQuery.sap.require("sas.ltjs.commons.models.datagrid.ColumnContentType");
jQuery.sap.require("sas.ltjs.commons.ui.tooltip.CustomTooltipData");

jQuery.sap.require("sas.ltjs.commons.ScrollView");

jQuery.sap.require("sas.analytics.riskhp.utils.HprAPI");
jQuery.sap.require("sas.analytics.riskhp.utils.HprConstants");
jQuery.sap.require("sas.analytics.riskhp.utils.HprUtil");
jQuery.sap.require("sas.analytics.riskhp.common.riskcommons.crosstab.HprCrossTabUIView");
jQuery.sap.require("sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstabPopupMenu");
jQuery.sap.require("sas.hc.ui.commons.breadcrumb.Breadcrumb");
jQuery.sap.require("sas.hc.ui.commons.layout.VerticalLayout");
jQuery.sap.require("sap.ui.commons.layout.BorderLayout");
jQuery.sap.require("sap.ui.commons.layout.BorderLayoutAreaTypes");
jQuery.sap.require("sas.analytics.riskhp.models.CrosstabContext");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Classvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Outvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Benchvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Compvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Statistic");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Horizon");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.RiskCube");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.ResultSet");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Scenario");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Hierarchy");
jQuery.sap.require('sas.analytics.riskhp.common.riskcommons.CrosstabUtil');
jQuery.sap.require('sas.analytics.riskhp.views.displayrules.DisplayRulesUtil');
jQuery.sap.require("sas.hc.ui.unified.Menu");
jQuery.sap.require("sas.hc.ui.unified.MenuItem");
jQuery.sap.require("sas.hc.ui.core.CustomData");
jQuery.sap.require("sas.analytics.riskhp.views.datapane.DataPaneUtil");
jQuery.sap.require("sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstabContextMenuProvider");

jQuery.sap.require("sas.analytics.riskhp.models.cache.CacheKey");
jQuery.sap.require("sas.analytics.riskhp.models.cache.CacheManager");

sap.ui.core.Control.extend("sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab", {
    metadata: {
        properties: {
            dirty: {type: "boolean", defaultValue: "false"},
            isCrosstabRendering: {type: "boolean", defaultValue: "false"},

            /* other (configuration) properties */
            width: {type: "sap.ui.core.CSSSize", defaultValue: '100%'},
            height: {type: "sap.ui.core.CSSSize", defaultValue: '100%'}
        },
        aggregations: {
            breadcrumb: {type: "sas.hc.ui.commons.breadcrumb.Breadcrumb", multiple: false, visibility: "public"},
            context : {type: "sas.analytics.riskhp.models.CrosstabContext", multiple: false, visibility: "public"},
            crosstab : {type: "sas.ltjs.commons.models.crosstab.Crosstab", multiple: false, visibility: "public", bindable: "bindable"},
            uiView : {type: "sas.analytics.riskhp.common.riskcommons.crosstab.HprCrossTabUIView", multiple: false, visibility: "hidden"},
            layout : {type: "sas.hc.ui.commons.layout.VerticalLayout", multiple: false, visibility: "public"},
            zeroState : {type: "sas.risk.common.panelsview.DivWrapper", multiple: false, visibility: "hidden"}
        },
        events: {
            rowSelectChange: {allowPreventDefault: true},
            dirtyChange: {allowPreventDefault: true}
        }
    },

    renderer: {
        render: function (oRm, oControl) {
            oRm.write("<div");
            oRm.writeControlData(oControl);

            oRm.addClass("hprCrosstab");
            oRm.writeClasses();

            oRm.write(">");

            // Render the correct control(s) based on some model criteria
            var children = oControl._currentContent();
            _.each(children, function(child) {
                if (!_.isUndefined(child) && child) {
                    oRm.renderControl(child);
                }
            });

            oRm.write("</div>");
        }
    }
});

(function () {

    var PickEntryType = sas.ltjs.commons.pickResults.PickEntryType;
    var SortDirection = sas.ltjs.commons.models.data.sorting.SortDirection;
    var CrosstabPickResultEntry=sas.ltjs.commons.crosstab.CrosstabPickResultEntry;
    var Crosstab = sas.ltjs.commons.models.crosstab.Crosstab;
    var DisplayTreeNode = sas.ltjs.commons.crosstab.DisplayTreeNode;
    var CrosstabPickButtonType = sas.ltjs.commons.crosstab.CrosstabPickButtonType;
    var CrosstabModelBuilder = sas.ltjs.commons.crosstab.CrosstabModelBuilder;
    var CrosstabUtilities = sas.ltjs.commons.util.CrosstabUtilities;
    var Level = sas.ltjs.commons.models.data.hierarchy.Level;
    var Hierarchy = sas.ltjs.commons.models.data.hierarchy.Hierarchy;
    var Column = sas.ltjs.commons.models.data.dataset.Column;
    var DataSet = sas.ltjs.commons.models.data.dataset.DataSet;
    var DataType = sas.ltjs.commons.models.data.dataset.DataType;
    var DataUsage = sas.ltjs.commons.models.data.dataset.DataUsage;
    var DataGridColumnInfo = sas.ltjs.commons.models.datagrid.DataGridColumnInfo;
    var ColumnContentType = sas.ltjs.commons.models.datagrid.ColumnContentType;
    var Breadcrumb = sas.hc.ui.commons.breadcrumb.Breadcrumb;
    var VerticalLayout = sas.hc.ui.commons.layout.VerticalLayout;
    var BorderLayout = sap.ui.commons.layout.BorderLayout;
    var CLASSVAR = sas.analytics.riskhp.models.dataitems.Classvar.CLASSVAR;
    var OUTVAR = sas.analytics.riskhp.models.dataitems.Outvar.OUTVAR;
    var BENCHVAR = sas.analytics.riskhp.models.dataitems.Benchvar.BENCHVAR;
    var COMPVAR = sas.analytics.riskhp.models.dataitems.Compvar.COMPVAR;
    var STATISTIC = sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC;
    var HORIZON = sas.analytics.riskhp.models.dataitems.Horizon.HORIZON;
    var RISKCUBE = sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE;
    var RESULTSET = sas.analytics.riskhp.models.dataitems.ResultSet.RESULTSET;
    var SCENARIO = sas.analytics.riskhp.models.dataitems.Scenario.SCENARIO;
    var HIERARCHY = sas.analytics.riskhp.models.dataitems.Hierarchy.HIERARCHY;
    var CrosstabUtil = sas.analytics.riskhp.common.riskcommons.CrosstabUtil;
    var HprUtil = sas.analytics.riskhp.utils.HprUtil;
    var MenuItem = sas.hc.ui.unified.MenuItem;

    var menuProvider = new sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstabContextMenuProvider();

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getMenuProvider = function () {
        return menuProvider;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.setMenuProvider = function (mp){
        menuProvider = mp;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.init = function () {

        if (sap.ui.core.Control.prototype.init) {
            sap.ui.core.Control.prototype.init.apply(this, arguments);
        }

        // Creation must happen in this order
        var oZeroState = this.setAggregation("zeroState", this._createZeroState());
        var oBreadCrumb = this.setAggregation("breadcrumb", this._createBreadcrumb());
        var oCrosstab = this.setAggregation("crosstab", this._createEmptyCrosstab());
        var oUiView = this.setAggregation("uiView", this._createUiView());

        this.logger = sas.log.getLogger("sas.analytics.riskhp.common.riskcommons.crosstab");

        sas.eventBus.subscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_SCENARIO_UPDATED, this._onScenarioUpdated, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_SCENARIO_DELETED, this._onScenarioDeleted, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_DISPLAY_RULES_CHANGED, this.handleDisplayRulesChanged, this);
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.handleDisplayRulesChanged = function(channelId, eventId, data) {
        var self = this;
        var id = self.context.id;
        var forThisCrosstab = _.find(data.crosstabIds, function(crosstabId){
            return crosstabId === id;
        });
        if (forThisCrosstab) {
            if (data.tuples && data.tuples.length > 0) {
                _.each(data.tuples, function(tuple) {
                    DisplayRulesUtil.clearDisplayRulesFromCrosstabTuple(self, tuple);
                    DisplayRulesUtil.applyLTJSDisplayRulesForCrosstabTuple(self, tuple);
                })
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.exit = function () {

        if (this.context) {
            this.context.exit();
        }
        if (this.crosstab) {
            this.crosstab.release();
        }

        this.removeHandlers();

        sas.eventBus.unsubscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_SCENARIO_UPDATED, this._onScenarioUpdated, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_SCENARIO_DELETED, this._onScenarioDeleted, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_DISPLAY_RULES_CHANGED, this.handleDisplayRulesChanged, this);

        if (sap.ui.core.Control.prototype.exit) {
            sap.ui.core.Control.prototype.exit.apply(this, arguments);
        }
    };

    // This method was found in ManagedObject source and not documented API.
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.updateBindings = function () {

        if (sap.ui.base.ManagedObject.prototype.updateBindings) {
            sap.ui.base.ManagedObject.prototype.updateBindings.apply(this, arguments);
        }

        // New context, clean up stuff that might be hangin around
        if (arguments[1] === this.getId()) {
            this.rebuildCrosstab(true, true, true);
        }

    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.addHandlers = function () {
        var self = this;

        if (self.uiView) {
            // var menu = new sas.hc.ui.unified.Menu();
            // self.uiView.setAggregation("contextMenu", menu);
            //self.uiView.customizeContextMenu = self._onContextMenu.bind(self);

            self.uiView.attachMouseEnter(self._onMouseEnter, self);
            self.uiView.attachMouseLeave(self._onMouseLeave, self);
            self.uiView.attachMouseMove(self._onMouseMove, self);
            self.uiView.attachMouseHover(self._onMouseHover, self);

            // Handler for expand/collapse and drill
            self.uiView.attachMouseUp(self._onMouseUp, self);

            // Internal Drag-n-Drop handlers
            self.uiView.attachSAPTouchStart(self._onSAPTouchStart, self);
            self.uiView.attachSAPTouchMove(self._onSAPTouchMove, self);
            self.uiView.attachSAPTouchEnd(self._onSAPTouchEnd, self);

            // External Drag-n-Drop handlers
            self.uiView.attachExtDragOut(self._onExtDragOut, self);
            self.uiView.attachExtDragOver(self._onExtDragOver, self);
            self.uiView.attachExtDragDrop(self._onExtDragDrop, self);
            self.uiView.attachExtMouseMove(self._onExtMouseMove, self);
            self.uiView.attachExtDoubleClick(self._onExtDoubleClick, self);

            // Under development.  10/2/17  Yilma investigating why this isn't working.
            // Custom crosstab tooltip callback
            //self.uiView.setCustomTooltipCallBack(self._customCrosstabTooltipCallback.bind(self));
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.removeHandlers = function () {
        var self = this;

        if (self.uiView) {
            self.uiView.detachMouseEnter(self._onMouseEnter, self);
            self.uiView.detachMouseLeave(self._onMouseLeave, self);
            self.uiView.detachMouseUp(self._onMouseUp, self);
            self.uiView.detachMouseHover(self._onMouseHover, self);
            self.uiView.detachExtDoubleClick(self._onExtDoubleClick, self);

            // Internal Drag-n-Drop handlers
            self.uiView.detachSAPTouchStart(self._onSAPTouchStart, self);
            self.uiView.detachSAPTouchMove(self._onSAPTouchMove, self);
            self.uiView.detachSAPTouchEnd(self._onSAPTouchEnd, self);

            // External Drag-n-Drop handlers
            self.uiView.detachExtDragOut(self._onExtDragOut, self);
            self.uiView.detachExtDragOver(self._onExtDragOver, self);
            self.uiView.detachExtDragDrop(self._onExtDragDrop, self);
            self.uiView.detachExtMouseMove(self._onExtMouseMove, self);
        }
    };

    /**
     * Determines which controls should be displayed based on some model criteria.
     * @returns {Array} Array of controls that should be displayed
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._currentContent = function() {
        var content = [];
        // Since the context is not set yet, just return a blank content array as (presumably) we'll pick it up in later processing.
        if (!this.context) {
            return content;
        }
        if (!this.isModelValid()) {
            content.push(this.zeroState);
        } else {
            content.push(this.breadcrumb);
            content.push(this.uiView);
        }

        return content;
    };

    /**
     * Pseudo interface method to return the dataSourceId the component is using in a common way
     * @returns String
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getDataSourceId = function() {
        return this.context.dataSourceId;
    };

    /**
     * Pseudo interface method to return the type of control this is in a common way
     * @returns String
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getPanelType = function() {
        return HprConstants.HPR_CROSSTAB_PANEL;
    };

    /**
     * Checks to see if the Crosstab model (aka. context) is valid.
     * @returns {boolean} true | false
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.isModelValid = function() {
        var valid = true;
        var crosstabModel = this.context;

        if (_.isUndefined(crosstabModel) || !crosstabModel) {
            valid = false;
        }

        // These properties could be missing after a replace data source on the Crosstab, we want to display a ZeroState in that case
        if (valid) {
            valid = !(crosstabModel.reportResultsTree && _.isUndefined(crosstabModel.reportResultsTree.name));
        }

        // Again, after a replace data source on the Crosstab, these properties could be missing if we couldn't find suitable replacements
        if (valid) {
            valid = crosstabModel.columnTree && crosstabModel.columnTree.children && crosstabModel.columnTree.children.length > 0;
        }

        // If we are still valid, actually check the context and see if deems itself as valid
        if (valid) {
            valid = !crosstabModel.isZeroState();
        }

        return valid;
    };

    /**
     * When panel is resized, recalculate the size of the crosstab ui view so it properly expands
     * and contracts when set to a fixed size (when the breadcrumb is displayed).
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.handleResize = function() {
        this._adjustCrosstabViewHeight();
    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // Crosstab
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createLayout = function () {
        var self = this;
        this.layout = new sas.hc.ui.commons.layout.VerticalLayout({
            id: self.id + '-verticalLayout1'
        });

        return this.layout;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createUiView = function () {

        this.uiView = new sas.analytics.riskhp.common.riskcommons.crosstab.HprCrossTabUIView();
        this.uiView.setModel(this.crosstab);

        if (this.uiView) {
            var menu = new sas.hc.ui.unified.Menu();
            this.uiView.setAggregation("contextMenu", menu);
            this.uiView.customizeContextMenu = this._onContextMenu.bind(this);

            this.addHandlers();
        }

        var self = this;
        this.uiView.addEventDelegate({
            "onAfterRendering": function(event) {
                self._adjustCrosstabViewHeight();
            }
        });

        return this.uiView;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createEmptyCrosstab = function () {

        if (this.crosstab !== undefined) {
            this.crosstab.release();
            this.crosstab = undefined;
        }
        var xtab = new Crosstab();
        this.crosstab = xtab.retain();
        var fakeDataSet = new DataSet(false, false);

        var builder = new CrosstabModelBuilder(fakeDataSet, this.crosstab);
        builder.build();

        this.crosstab.setDataSet( fakeDataSet );

        return this.crosstab;
    };

    /**
     * Constructs a Empty/ZeroState layout to display instead of the Crosstab.
     * @returns {sas.risk.common.panelsview.DivWrapper}
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createZeroState = function () {
        var zeroStateLayout = new sas.risk.common.widgets.ZeroStateLayout({
            icon: sas.icons.HC.ZEROSTATETABLE,
            title: HprUtil.getBundle().getText('HPRisk.Crosstab.ZeroState.default.txt'),
            buttons: []
        });

        // tableWrapper does not exist yet, have to create it
        this.zeroState = new sas.risk.common.panelsview.DivWrapper({
            height: "100%",
            width: "100%"
        });
        this.zeroState.addStyleClass("hprBoundedControlContainer"); // Needed so content stays within RiskPanelsView
        this.zeroState.setContent(zeroStateLayout);

        return this.zeroState;
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Expand/Collapse
    //*****************************************************************************************************
    //*****************************************************************************************************

    // NOTE: uniqueNodePathValues must be displayed labels (formated for UI).
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doExpand = function (uniqueNodePathValues) {
        var self = this;

        this.logger.trace("HprCrosstab.doExpand");

        // Safety check, should not be a "total" or "subtotal"
        var proceed = !_.find(uniqueNodePathValues, function(value) {
            return ((value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt')) ||
            (value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt')));
        });

        // FIXME this may not be needed if/when we remove expand/collapse menu item.
        if (uniqueNodePathValues.length >= self.context.getClassVariables().length) {
            proceed = false;
        }

        if (proceed) {
            //var node = self.context.findRowTreeNode(uniqueNodePathValues, "name");
            var node = self.context.findRowTreeNode(uniqueNodePathValues, "label");
            if (node) {
                node.expanded = true;
                self.rebuildCrosstab();
            } else {
                this.logger.error("HprCrosstab.doExpand", "Unable to find " + uniqueNodePathValues.toString());
            }
        }
    };

    // NOTE: uniqueNodePathValues must be displayed labels (formated for UI).
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doCollapse = function (uniqueNodePathValues) {
        var self = this;

        this.logger.trace("HprCrosstab.doCollapse");

        // Safety check, should not be a "total" or "subtotal"
        var proceed = !_.find(uniqueNodePathValues, function(value) {
            return ((value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt')) ||
            (value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt')));
        });

        // FIXME this may not be needed if/when we remove expand/collapse menu item.
        if (uniqueNodePathValues.length >= self.context.getClassVariables().length) {
            proceed = false;
        }

        if (proceed) {
            //var node = self.context.findRowTreeNode(uniqueNodePathValues, "name");
            var node = self.context.findRowTreeNode(uniqueNodePathValues, "label");
            if (node) {
                node.expanded = false;
                self.redraw();
                // // Fire off a new query
                // self.rebuildCrosstab();
            } else {
                sas.log.info("HprCrosstab.doCollapse  unable to find " + uniqueNodePathValues.toString());
            }
        }
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Paging
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doPagingSelector = function (direction, info, offset) {
        var self = this;

        // uniqueNodePathValues comes from Ltjs crosstab and was/is built with (and thus shows the user) display labels.
        var uniqueNodePathValues = info.displayedKeys;

        // Safety check, should not be a "total" or "subtotal"
        var proceed = !_.find(uniqueNodePathValues, function(value) {
            return ((value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt')) ||
            (value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt')));
        });

        if (proceed) {
            // Find the row tree node using labels.
            var node = self.context.findRowTreeNode(uniqueNodePathValues, "label");
            if (node && node.parent) {

                self.pagingPopover = sap.ui.jsfragment("sas.analytics.riskhp.fragments.PagingPopover", {
                    jumpText: self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.Jump.txt'),
                    totalRowsText: self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.TotalRows.fmt', node.parent.totalRows),
                    pageTooltip: (direction === "up"
                        ? self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.PageUp.txt')
                        : self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.PageDown.txt')),
                    pageEndTooltip: (direction === "up"
                        ? self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.PageTop.txt')
                        : self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.PageBottom.txt')),
                    rangeErrorMessage: self.context.getI18NBundle().getText('HPRisk.Crosstab.PagingPopover.RangeError.txt'),
                    totalRows: node.parent.totalRows,
                    //row: self.context.findChildIndex(node.parent, node.name) + node.parent.startRow,
                    row: node.parent.startRow,
                    direction: direction,
                    transpose: self.context.getTranspose(),
                    node: node,
                    doPage: self.doPage,
                    doPageEnd: self.doPageEnd,
                    doPageSpecific: self.doPageSpecific,
                    owner: self
                });

                // Calculate the offset to the paging icon in the crosstab.  Reason: popover will be placed next to the crosstab
                // to the right (by default).  Need to move/offset to where the user clicked the paging icon.
                var self$ = this.$();
                var selfInnerHeight = self$.innerHeight();
                var selfInnerWidth = self$.innerWidth();
                var xoffset = -(selfInnerWidth - offset.x);
                var yoffset = -(parseInt(selfInnerHeight / 2) - offset.y);
                self.pagingPopover.setOffsetX(xoffset);
                self.pagingPopover.setOffsetY(yoffset);

                self.pagingPopover.openBy(this);
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doPage = function (direction, node, that) {
        var self = this;

        if (node) {
            // node path is to the node that has the button.  The paging info is in the parent.
            var parent = node.parent;

            // Remove existing children, to be replaced by new kids from new query
            // So we don't "cache" existing children, therefore all paging requires a query to server.
            // Note to self: No caching because how to requery all other pages if alpha changes?
            parent.children = [];

            if (direction === "up") {
                if (parent.startRow < that.context.optionNROWS.value) {
                    parent.startRow = 1;
                } else {
                    parent.startRow = parent.startRow - that.context.optionNROWS.value;
                }
            }
            else if (direction === "down") {
                if (parent.startRow < parent.totalRows - that.context.optionNROWS.value) {
                    parent.startRow = parent.startRow + that.context.optionNROWS.value;
                } else if (parent.startRow === parent.totalRows -
                    that.context.optionNROWS.value) {
                    parent.startRow = parent.totalRows;
                }
            }

            // Fire off a new query
            that.rebuildCrosstab();
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doPageEnd = function (direction, node, that) {
        var self = this;

        if (node) {
            // node path is to the node that has the button.  The paging info is in the parent.
            var parent = node.parent;

            // Remove existing children, to be replaced by new kids from new query
            // So we don't "cache" existing children, therefore all paging requires a query to server.
            // Note to self: No caching because how to requery all other pages if alpha changes?
            parent.children = [];

            if (direction === "up") {
                parent.startRow = 1;
            }
            else if (direction === "down") {
                parent.startRow = parent.totalRows - that.context.optionNROWS.value + 1;
            }

            // Fire off a new query
            that.rebuildCrosstab();
        }
    };


    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doPageSpecific = function (direction, node, row, that) {
        var self = this;

        if (node) {
            // node path is to the node that has the button.  The paging info is in the parent.
            var parent = node.parent;

            // Remove existing children, to be replaced by new kids from new query
            // So we don't "cache" existing children, therefore all paging requires a query to server.
            // Note to self: No caching because how to requery all other pages if alpha changes?
            parent.children = [];

            // var lastPageRow = parent.totalRows - that.context.optionNROWS.value + 1;
            // if (row > lastPageRow) {
            //     parent.startRow = lastPageRow;
            // }
            // else {
            parent.startRow = row;
            // }

            // Fire off a new query
            that.rebuildCrosstab();
        }
    };


    //NOTE: uniqueNodePathValues must be based on displayed keys (formatted)
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doPaging = function (direction, uniqueNodePathValues) {
        var self = this;

        this.logger.trace("HprCrosstab.doPaging");

        // Safety check, should not be a "total" or "subtotal"
        var proceed = !_.find(uniqueNodePathValues, function(value) {
            return ((value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt')) ||
            (value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt')));
        });

        if (proceed) {
            // uniqueNodePathValues comes from Ltjs crosstab and was/is built with (and thus shows the user) display labels.
            // Find the row tree node using labels.
            var node = self.context.findRowTreeNode(uniqueNodePathValues, "label");
            if (node) {

                // node path is to the node that has the button.  The paging info is in the parent.
                var parent = node.parent;

                // Remove existing children, to be replaced by new kids from new query
                // So we don't "cache" existing children, therefore all paging requires a query to server.
                // Note to self: No caching because how to requery all other pages if alpha changes?
                parent.children = [];

                if (direction === "up") {
                    if (parent.startRow < self.context.optionNROWS.value) {
                        parent.startRow = 1;
                    } else {
                        parent.startRow = parent.startRow - self.context.optionNROWS.value;
                    }
                }
                else if (direction === "down") {
                    if (parent.startRow < parent.totalRows - self.context.optionNROWS.value) {
                        parent.startRow = parent.startRow + self.context.optionNROWS.value;
                    } else if (parent.startRow === parent.totalRows -
                        self.context.optionNROWS.value) {
                        parent.startRow = parent.totalRows;
                    }
                }

                // Fire off a new query
                self.rebuildCrosstab();
            } else {
                sas.log.info("HprCrosstab.doPaging  unable to find " + uniqueNodePathValues.toString());
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.isPaging = function (uniqueNodePathValues) {
        var self = this;

        var paged = undefined;

        // Safety check, should not be a "total" or "subtotal"
        var proceed = !_.find(uniqueNodePathValues, function(value) {
            return ((value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Total.txt')) ||
            (value === self.context.getI18NBundle().getText('HPRisk.Crosstab.Subtotal.txt')));
        });

        if (proceed) {
            var node = self.context.findRowTreeNode(uniqueNodePathValues);
            if (node) {

                // node path is to the node that has the button.  The paging info is in the parent.
                var parent = node.parent;

                // Are we paging?
                if (parent && parent.totalRows > self.context.optionNROWS.value || parent.startRow > 1) {
                    if (parent.startRow === 1) {
                        paged = "topPage";
                    }
                    else if (parent.startRow > parent.totalRows - self.context.optionNROWS.value) {
                        paged = "bottomPage";
                    }
                    else {
                        paged = "middlePage";
                    }
                }
            }
        }
        return paged;
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Breadcrumb / Drill
    //*****************************************************************************************************
    //*****************************************************************************************************
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createBreadcrumb = function () {
        var self = this;

        this.breadcrumb = new Breadcrumb().addStyleClass("crosstabBreadcrumb");
        this.breadcrumb.attachItemSelected(this._handleDrillUp, this);

        this.breadcrumb.addEventDelegate({
            "onAfterRendering": function(event) {
                self._adjustCrosstabViewHeight();
            }
        });

        this.buildBreadcrumb();

        return this.breadcrumb;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._handleDrillUp = function(oEvent) {
        var self = this;

        this.logger.trace("HprCrosstab._handleDrillUp");

        if (oEvent) {
            var selectedItem = oEvent.getParameter("item");
            if (selectedItem) {
                if (selectedItem.sId === this.breadcrumb.getId() + "ALL") {
                    this.clearBreadcrumb();
                }
                else {
                    this.context.popDrillPath(selectedItem.getProperty("text"));
                }
                this.rebuildCrosstab();
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._handleDrillDown = function(entry) {
        var self = this;

        this.logger.trace("HprCrosstab._handleDrillDown");

        var numBreadcrumbs = this.breadcrumb.getItems().length;

        var node = entry.getNode();
        var uniqueNodePath = node.getUniqueNodePath();
        var uniqueNodePathValues = CrosstabUtil.getUniqueNodePathValues(uniqueNodePath, this.context);

        var path = [];
        for (var i = 0; i < uniqueNodePathValues.length; i++) {
            path.push(uniqueNodePathValues[i]);
        }

        this.context.pushDrillPath(path);
        //this.buildBreadcrumb();
        this.rebuildCrosstab();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.buildBreadcrumb = function() {

        this.breadcrumb.setVisible(false);

        if (this.context){
            if ((this.context.drillpath) && (this.context.drillpath.length > 0)) {

                this.breadcrumb.destroyItems(); // clear existing breadcrumb
                this.breadcrumb.setVisible(true);  // set visible to true when we are drilled

                // S1406187.  override href in the breadcrumb items to prevent discarding current exploration.
                var allCrumbItem = new sas.hc.ui.commons.breadcrumb.BreadcrumbItem(this.breadcrumb.getId() + "ALL",
                    {
                        key: this.breadcrumb.getId() + "ALL",
                        text: this.context.i18n.getText("HPRisk.Crosstab.Breadcrumb.All.txt"),
                        href: "javascript:void(0);"
                    }
                );
                this.breadcrumb.addItem(allCrumbItem);

                for (var i = 0; i < this.context.drillpath.length; i++) {
                    var crumbItem = new sas.hc.ui.commons.breadcrumb.BreadcrumbItem(this.breadcrumb.getId() + this.context.getClassVariable(i).name,
                        {
                            key: this.breadcrumb.getId() + this.context.getClassVariable(i).name,
                            text: this.context.drillpath[i],
                            href: "javascript:void(0);"
                        }
                    );
                    this.breadcrumb.addItem(crumbItem);
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.clearBreadcrumb = function () {
        this.breadcrumb.destroyItems();
        this.breadcrumb.setVisible(false);
        this.context.clearDrillPath();
    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // Model
    //*****************************************************************************************************
    //*****************************************************************************************************
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.rebuildCrosstab = function(forceFullQuery, rebuildResultsTree, firstTime) {

        var self = this;
        this.logger.debug("HprCrosstab.rebuildCrosstab", "start");

        var deferred = $.Deferred();

        if (forceFullQuery === undefined) {
            forceFullQuery = false;
        }
        if (rebuildResultsTree === undefined) {
            rebuildResultsTree = false;
        }
        if (firstTime === undefined) {
            firstTime = false;
        }

        var myModel = this.getModel(self.getId());
        if (myModel) {
            self.context = myModel.oData;
        }

        var selectedPanelId = HprUtil.getSelectedPanelId(); // Keep track of the selected panel id

        // Set this in the context so we can get back to crosstab if needed
        self.context.crosstab = self;

        if (!self.context.isValidModel()) {
            HprUtil.updateRightPanelsForZeroState();

            self.context.setZeroState();
            self.rerender();

            setTimeout(function() {
                // Make sure to remove the busy state after setBusy 'true' runs
                self.uiView.setBusy(false);
            },0);

            self._isCrosstabRendering = false;
            return deferred.reject();
        }

        self.uiView.setBusyIndicatorDelay(0);
        if (firstTime) {
            setTimeout(function() {
                // Placing this in here prevents the busy indicator from displaying in an incorrect 'small' state,
                // esp. when the Crosstab is first initialized and may not be completely rendered yet
                self.uiView.setBusy(true);
            },0);
        } else {
            // Otherwise, just go ahead and set the busy state
            self.uiView.setBusy(true);
            // Save the crosstab scroll position
            self.context.getScrollPosition();
        }

        self._isCrosstabRendering = true;

        // fire off query based on context
        this.logger.debug("HprCrosstab.rebuildCrosstab", "send query");
        $.when (
            //self.context.query(forceFullQuery)
            self.context.queryCache(forceFullQuery)
        ).done(function(reportResults) {
                if (!reportResults || (reportResults.length === 0)) {
                    self.logger.error("HprCrosstab.rebuildCrosstab", "NO query results  status=" + reportResults.status);

                    //Handling in a 204 as a special case.  No zero state so user can fix and continue.
                    if (reportResults.status === 204) {
                        HprUtil.displayGenericErrorDialog(self.context.getI18NBundle().getText('HPRisk.ErrorCode.204.txt'));
                        //self.redraw(); // rids of busy indicator, rendering and cache reset flags.
                    }
                    else {
                        HprUtil.displayGenericErrorDialog(self.context.getI18NBundle().getText('HPRisk.ErrorCode.noResults.txt'));
                    }
                    // Display the ZeroState by setting the cubeDataModel to invalid and re-rendering;
                    // Then update the right-side panels to ZeroState if the selectedPanelId matches
                    if (selectedPanelId === self.context.getId()) {
                        //HprUtil.updateRightPanelsForZeroState(); // updateRightPanelsForSelectedCrosstab
                        HprUtil.updateRightPanelsForSelectedCrosstab(self.context.getId()); // updateRightPanelsForSelectedCrosstab
                    }
                    self.context.setZeroState();
                    self.rerender();
                } else {
                    self.logger.debug("HprCrosstab.rebuildCrosstab", "query success");

                    self.context.setZeroState(false);
                    self.rerender();

                    // Fix/workaround for S1363217.  Dump existing crosstab and create new one.
                    self.removeHandlers(); //S1408991
                    self.crosstab = self._createEmptyCrosstab();
                    self.uiView.setModel(self.crosstab);
                    self.addHandlers(); //S1408991

                    if (!firstTime) {
                        self.setDirty(true);
                    }
                    self.logger.debug("HprCrosstab.rebuildCrosstab", "set results");

                    // Store the results in the context/model
                    //self.context.setReportResults(reportResults, rebuildResultsTree);
                    self.context.setResults(reportResults, rebuildResultsTree);
                    self.redraw();

                    // After the redraw, see if the right-side panels need to be updated appropriately
                    if (selectedPanelId === self.context.getId()) {
                        HprUtil.updateRightPanelsForSelectedCrosstab(self.context.getId());
                    }
                }

                setTimeout(function() {
                    // Make sure to remove the busy state after setBusy 'true' runs
                    self.uiView.setBusy(false);
                    CrosstabUtil.notifyLinkedPlotsOfChange(self);
                },0);

                self._isCrosstabRendering = false;
                deferred.resolve();

            }).fail(function(jqxhr) {
                // Display the ZeroState by setting the cubeDataModel to invalid and re-rendering;
                // Then update the right-side panels to ZeroState if the selectedPanelId matches
                if (selectedPanelId === self.context.getId()) {
                    HprUtil.updateRightPanelsForZeroState();
                }
                self.context.setZeroState();
                self.rerender();

                setTimeout(function() {
                    // Make sure to remove the busy state after setBusy 'true' runs
                    self.uiView.setBusy(false);
                },0);

                self._isCrosstabRendering = false;

                // Display an error dialog
                if (jqxhr && jqxhr.responseJSON) {
                    var responseJSON = jqxhr.responseJSON;
                    if (responseJSON.errorCode === 0) {
                        // The message for error code of 0 doesn't make sense in this case, so display another general error message about the query
                        HprUtil.displayGenericErrorDialog(self.context.getI18NBundle().getText('HPRisk.Crosstab.problem.query.txt'));
                    } else {
                        HprUtil.displayDetailedErrorDialog(jqxhr);
                    }
                }

                deferred.reject();
            });

        this.logger.debug("HprCrosstab.rebuildCrosstab", "end");
        return deferred;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.redraw = function() {
        var self = this;

        if (self.context) {
            this.logger.debug("HprCrosstab.redraw", "start");
            self._isCrosstabRendering = true;

            // Clear out previous column info settings.
            self._resetCrosstabColumnInfos();

            // Enable or disable the display of the row and column axis headers.
            // These display in the upper left corner of the crosstab.
            self.crosstab.setShowAxisHeaders(self.context.getShowAxisHeaders());

            // Enable or disable the transposing of rows and columns in the crosstab.
            self.crosstab.setTranspose(self.context.getTranspose());

            // Set up Rows
            var rowLevels = CrosstabUtil.createRowHeaderLevels(self.context);
            var rowHierarchy = CrosstabUtil.createRowHierarchy(self.context, rowLevels);
            self.crosstab.setRowHierarchy(rowHierarchy);
            // S1394169  Only levels that are displayed in the crosstab should be set for these row levels.
            var displayedRowLevels = rowLevels.slice(0, self.context.getDrilledExpansionDepth());
            self.crosstab.setRowAxisLevels(displayedRowLevels);
            self.crosstab.setRowDataTreeNode(CrosstabUtil.createRowHeaderDisplayTree(self.context));

            // Set up Columns
            var columnLevels = CrosstabUtil.createColumnHeaderLevels(self.context);
            var columnHierarchy = CrosstabUtil.createColumnHierarchy(self.context, columnLevels);
            self.crosstab.setColumnHierarchy(columnHierarchy);
            self.crosstab.setColumnAxisLevels(columnLevels);
            self.crosstab.setColumnDataTreeNode(CrosstabUtil.createColumnHeaderDisplayTree(self.context, 2));

            // Needed to prevent OOM exception on first column
            self.crosstab.setNumberOfMeasures(1);

            // Build a dataset for the headers
            var processedResults = self._createDataSetFromResults();
            self.crosstab.setDataSet(processedResults.dataSet);

            var columnDecorations = self.context.getColumnDecorations();
            var decoratedColumnIndices = [];
            _.each(columnDecorations, function (decoration) {
                var x = decoration.index;
                decoratedColumnIndices.push(x);

                var columnNodes = self.context.getColumnNodes(x);
                var columnLeafNode = undefined;
                if (columnNodes && columnNodes.length > 0) {
                    columnLeafNode = columnNodes[columnNodes.length - 1];

                    // Set a default DataGridColumnInfo for the column
                    var columnInfo = self.crosstab.getColumnInfo(x);
                    if (columnInfo === null) {
                        columnInfo = new DataGridColumnInfo();
                        // Default column width
                        columnInfo.setColumnWidth(HprConstants.DEFAULT_CROSSTAB_WIDTH);
                    }
                    if (decoration.type.width !== undefined) {
                        columnInfo.setColumnWidth(decoration.type.width);
                    }
                    columnInfo.setSortDirection(SortDirection.DATA);
                    columnInfo.setColumnType(ColumnContentType.TEXT);

                    // Set column info for staleness icon.
                    if (decoration.type.staleness !== undefined) {
                        columnInfo.setColumnType(ColumnContentType.ICON);
                        columnInfo.setColumnIndex(x);
                    }

                    // Set column info for sort indicator
                    if (decoration.type.sort !== undefined) {
                        if (decoration.type.sort === sas.analytics.riskhp.models.CrosstabContext.SORT_DIRECTION_ASCENDING) {
                            columnInfo.setSortDirection(SortDirection.ASCENDING);
                        } else {
                            columnInfo.setSortDirection(SortDirection.DESCENDING);
                        }
                    }
                    self.crosstab.setColumnInfo(x, columnInfo);
                }
            });

            // set default width for all columns
            self.crosstab.setMeasureWidth(HprConstants.DEFAULT_CROSSTAB_WIDTH);

            //the following are required to enable expand/collapse and drill buttons
            self.crosstab.setRowActionEnabled(true);
            // self.crosstab.setColumnActionEnabled(true);
            self.crosstab.setDisplayInteractionButtons(true);

            //Set the indention
            self.crosstab.setRowIndentedViewMode(self.context.getRowIndent());
            self.crosstab.setColumnIndentedViewMode(self.context.getColumnIndent());

            //Set the expand/collapse indicators
            var expressions = self._createExpandExpressions(rowHierarchy);
            if ((expressions) && (expressions.length > 0)) {
                CrosstabUtilities.applyExpandExpression(self.crosstab.getRowHierarchy(), self.crosstab.getRowDataTreeNode(), expressions);
            }

            // EXPERIMENTAL

            // var columnStyle = ".Header { background-color: #00ff00; font-family: 'Courier'}";
            // var measureStyle = ".MeasureHeader { background-color: #00ff00; font-family: 'Courier'}";
            // var rowStyle = ".RowHeader { background-color: #00ff00; font-family: 'Courier'}";
            // var tableStyle = ".Table { background-color: #00ff00; font-family: 'Courier'}";
            // var totalsStyle = ".Totals { background-color: #00ff00; font-family: 'Courier'}";
            // var subTotalsStyle = ".Subtotals { background-color: #00ff00; font-family: 'Courier'}";

            var debugOptionsModel = sas.analytics.riskhp.models.HPRiskModelManager.getDebugOptions();
            if ((debugOptionsModel !== undefined) && (debugOptionsModel.options.crosstabStyleText !== undefined) && (debugOptionsModel.options.crosstabStyleText !== "")) {
                var style = sas.ltjs.commons.styles.Style.instance();
                style.addAttributeBundlesDefinedInCSSString(debugOptionsModel.options.crosstabStyleText);
            }

            //Set the breadcrumb
            self.buildBreadcrumb();

            // adjust the crosstab height to account for breadcrumb visibility
            self._adjustCrosstabViewHeight();

            // Because we may have blown away the original crosstab after rebuild/redraw, need to set back the scroll position
            var crosstabView = self.uiView.getBaseView();
            if (crosstabView) {
                if (self.context.crosstabScrollPosition) {
                    crosstabView.scrollTo(self.context.crosstabScrollPosition[0], self.context.crosstabScrollPosition[1]);
                }
            }

            self.applyDisplayRules();

            setTimeout(function () {
                // Make sure to remove the busy state after setBusy 'true' runs
                self.uiView.setBusy(false);
            }, 0);

            self._isCrosstabRendering = false;

            self.logger.debug("HprCrosstab.redraw", "end");
        }
        else {
            self.logger.warning("HprCrosstab has no model - skipping redraw");
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.applyDisplayRules = function() {
        var self = this;
        sas.analytics.riskhp.views.displayrules.DisplayRulesUtil.applyLTJSDisplayRulesForCrosstab(self);
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.resetCrosstabRows = function() {
        this.context.resetReportResultsTree();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.onNrowsChange = function() {
        this.context.updateDrill();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createExpandExpressions = function (rowHierarchy){
        var self = this;

        var expressions = [];
        if (rowHierarchy) {
            var expansions = self.context.getExpandExpressionKeys(); // need values to be quoted
            for (var idx = 0; idx < expansions.length; idx++) {
                var expandStr = "expand(${rowHierarchy},[" +  expansions[idx].toString() + "])";
                expressions.push(expandStr);
            }
        }
        return expressions;
    };

    // Remove any previous column info settings like sort icon or column type.
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._resetCrosstabColumnInfos = function() {
        var self = this;
        var numberOfColumns = self.context.getNumberOfColumns();
        if (self.crosstab) {
            for (var columnIndex = 0; columnIndex < numberOfColumns; columnIndex++) {
                var columnInfo = self.crosstab.getColumnInfo(columnIndex);
                if (columnInfo) {
                    columnInfo.setSortDirection(SortDirection.DATA);
                    columnInfo.setColumnType(ColumnContentType.TEXT);
                }
            }
        }
    };

    // Realign the columnTree widths to what the ITJS dataGridColumnInfo says it is.
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._realignColumnWidths = function(info) {
        var self = this;
        var logString = "";
        var leafIndexes = [];

        if (info) {
            var node = self.context.findColumnTreeNode(info.keys);
            leafIndexes = self.context.getLeafIndexesFromNode(node);
            _.each(leafIndexes, function(x) {
                var columnNodes = self.context.getColumnNodes(x);
                var columnLeafNode = undefined;
                if (columnNodes && columnNodes.length > 0) {
                    columnLeafNode = columnNodes[columnNodes.length - 1];

                    // Set a default DataGridColumnInfo for the column
                    var columnInfo = self.crosstab.getColumnInfo(x);
                    if (columnInfo === null) {
                        columnInfo = new DataGridColumnInfo();
                        // Default column width
                        columnInfo.setColumnWidth(HprConstants.DEFAULT_CROSSTAB_WIDTH);
                        self.crosstab.setColumnInfo(x, columnInfo);
                    }
                    var itjsColumnWidth = columnInfo.getColumnWidth();
                    logString = logString + " " + x + ":" + columnLeafNode.width + "->" + itjsColumnWidth;
                    columnLeafNode.width = itjsColumnWidth;
                }
            });
        }
        self.logger.debug("HprCrosstab._realignColumnWidths  ", logString);
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Query Results handling
    //*****************************************************************************************************
    //*****************************************************************************************************
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createDataSetFromResults = function() {
        var self = this;

        self.logger.trace("HprCrosstab._createDataSetFromResults");

        var dataSet = new DataSet(true, true);
        var dataColumn = [];
        var stalenessColumnIndexes = [];
        var stringColumnIndexes = [];

        // Create array of arrays of number data.  Also create columns for dataSet.
        var columnObjects = self.context.getColumnObjects(); // Use getColumns() to include hidden/fake/proxy/non-midtier dataItems
        var columnsToAdd = [];
        _.each(columnObjects, function(columnObject, index, list){
            var itjsColumn = new Column();
            var column = columnObject.column;

            // The name of the last dataItem in the column becomes the name of the column in the dataset. This name becomes the measure.
            // In this case, honor the showLabels property for the column 'name' because it uses the label for its value
            var name = column[column.length -1].getDisplayLabel(self.context.getOptionShowLabels().value) + index;
            itjsColumn.setName(name);
            itjsColumn.setLabel(column[column.length -1].getDisplayLabel(self.context.getOptionShowLabels().value));

            var dataItem = self.context.getFormatDataItemFromColumn(column);
            if (dataItem) {
                var columnFormat = dataItem.format;
                if (dataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.STALENESS) {
                    stalenessColumnIndexes.push(index);
                    stringColumnIndexes.push(index);
                    itjsColumn.setDataType(DataType.STRING);
                } else if (dataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.EXPIREDATETIME) {
                    itjsColumn.setFormatName(columnFormat);
                    itjsColumn.setDataType(DataType.NUMBER);
                } else if (dataItem.name === sas.analytics.riskhp.models.dataitems.Statistic.ALERTDATETIME) {
                    itjsColumn.setFormatName(columnFormat);
                    itjsColumn.setDataType(DataType.NUMBER);
                } else {
                    if (dataItem.dataType === "numeric") {
                        // Get an override format if present.
                        var overrideFormat = self.context.getColumnFormatOverride(column);
                        if (overrideFormat) {
                            columnFormat = overrideFormat;
                        }
                        itjsColumn.setFormatName(columnFormat);
                        itjsColumn.setDataType(DataType.NUMBER);
                    }
                    else {
                        // Assume it's a string otherwise
                        stringColumnIndexes.push(index);
                        itjsColumn.setDataType(DataType.STRING);
                    }
                }
            } else {
                sas.log.error("Could not determine the column format, default to number");
                itjsColumn.setDataType(DataType.NUMBER);
            }

            columnsToAdd.push(itjsColumn);
            dataColumn.push([]);
        });
        // add hidden columns to support ltjs display rules which require the columns to be in the crosstab
        var hiddenColumns = self.context.getHiddenTuples();
        var hiddenColumnNames = [];
        for (var hiddenColIndex = 0; hiddenColIndex < hiddenColumns.length; hiddenColIndex++) {
            var ltjsColumn = new Column();
            ltjsColumn.setName("hidden" + hiddenColIndex);
            columnsToAdd.push(ltjsColumn);
            hiddenColumnNames.push(ltjsColumn.getName());
            dataColumn.push([]);
        }
        self.crosstab.setExcludedColumnNames(hiddenColumnNames);

        dataSet.setColumns(columnsToAdd);

        // Fill in the array data. First columns in results are classvar values followed by columns of data, skip them.
        var dataResultObjects = self.context.getDataResultObjects();
        _.each(dataResultObjects, function(dataResultObject, dataIndex){
            for (var dataColIndex = 0; dataColIndex < columnObjects.length + hiddenColumns.length; dataColIndex++) {
                var value = dataResultObject.results[dataColIndex];
                if (_.contains(stalenessColumnIndexes, dataColIndex)) {
                    // Substitute 0,1,2 to IconName string
                    switch (value) {
                        case 2:
                            value = "Status-Flagged.png";
                            break;
                        case 1:
                            value = "Status-Warning.png";
                            break;
                        case 0:
                        default:
                            value = "Status-Complete.png";
                            break;
                    }
                }
                dataColumn[dataColIndex].push(value);
            }
        });

        // Set the data in the dataset columns
        for (var i = 0; i < dataColumn.length; i++) {
            var col = dataSet.getColumnAtIndex(i);
            if (_.contains(stringColumnIndexes, i)) {
                col.setStrings(dataColumn[i]);
            } else {
                col.setNumbers(dataColumn[i]);
            }
        }

        dataSet.update();

        return {dataSet: dataSet};
    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // Public API
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.forceTableRedraw = function() {
        this.redraw();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.setDirty = function(dirty) {
        this.dirty = dirty;
        this.fireDirtyChange({dirty: dirty});
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.isDirty = function() {
        return this.dirty;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getRowIndentedViewMode = function() {
        return this.crosstab.getRowIndentedViewMode();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.setRowIndentedViewMode = function(indentedViewMode){
        this.context.setRowIndent(indentedViewMode);
        this.crosstab.setRowIndentedViewMode(indentedViewMode);
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getColumnIndentedViewMode = function() {
        return this.crosstab.getColumnIndentedViewMode();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.setColumnIndentedViewMode = function(indentedViewMode){
        this.context.setColumnIndent(indentedViewMode);
        this.crosstab.setColumnIndentedViewMode(indentedViewMode);
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getQueryData = function() {
        var self = this;

        return this.context.toJSON();
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Utilities
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._transformCellLocation = function(cellLocation) {
        // It appears HC 8.0 changed the cell location again.  Now 0,0 is upper left, instead of bottom left.
        //cellLocation.y = Math.floor(this.uiView.getBounds().height - cellLocation.y - cellLocation.height);
        return cellLocation;
    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // Event Handlers
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseUp = function(oEvent) {
        var self = this;

        this.logger.trace("HprCrosstab._onMouseUp");

        // Make pagingPopover disappear
        if (self.pagingPopover !== undefined) {
            self.pagingPopover.close();
        }

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;
            if (pickResults) {
                var pickResult = pickResults[0];
                if (pickResult) {
                    var entries = pickResult.getEntries();
                    if (entries) {
                        var entry = entries[0];  // Should be a DataGridPickResultEntry
                        if (entry) {
                            if (entry instanceof CrosstabPickResultEntry) {
                                var info = CrosstabUtil.getPickInfo(pickResults, self.context);
                                var type = info.pickEntryType;

                                var buttonType = entry.getButtonType();
                                this.logger.debug("HprCrosstab._onMouseUp", "ButtonType = " + buttonType);

                                if (buttonType === CrosstabPickButtonType.CROSSTAB_DRILLDOWN_BUTTON) {
                                    this._handleDrillDown(entry);
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_EXPAND_BUTTON) {
                                    this.doExpand(info.displayedKeys);
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_COLLAPSE_BUTTON) {
                                    this.doCollapse(info.displayedKeys);
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_PAGE_UP_BUTTON) {
                                    this.doPagingSelector("up", info, {x: parameters.sourceEvent.offsetX, y:parameters.sourceEvent.offsetY});
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_PAGE_UP_END_BUTTON) {
                                    //alert("App: Open Page Dialog");
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_PAGE_DOWN_BUTTON) {
                                    this.doPagingSelector("down", info, {x: parameters.sourceEvent.offsetX, y:parameters.sourceEvent.offsetY});
                                }
                                else if (buttonType === CrosstabPickButtonType.CROSSTAB_PAGE_DOWN_END_BUTTON) {
                                    //alert("App: Open Page Dialog");
                                }
                                else {
                                    this.logger.warning("HprCrosstab._onMouseUp", "Unknown Button");
                                }
                            }
                        }
                    }
                }
            }
            else {
                // pagingPopover will not disappear if clicking in the crosstab, but does outside of the crosstab.
                // Dunno why, so added this here to make it happen.
                if (self.pagingPopover !== undefined) {
                    self.pagingPopover.close();
                }
            }
        }
    };

    var previousHighlightLocation = undefined;

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseHover = function(oEvent) {
        var self = this;

        //return; // FIXME

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;
            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if(entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            // var info = CrosstabUtil.getPickInfo(pickResults, self.context);
                            //
                            // var type = info.pickEntryType;
                        }
                    }
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseEnter = function(oEvent) {
        var self = this;

        this.logger.trace("HprCrosstab._onMouseEnter");
        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;

            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if (entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                            var type = info.pickEntryType;
                            //sas.log.info("HprCrosstab._onMouseEnter  type= " + type);

                        }
                    }
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseEnter = function(oEvent) {
        var self = this;

        this.logger.trace("HprCrosstab._onMouseEnter");
        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;

            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if (entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                            var type = info.pickEntryType;
                            //sas.log.info("HprCrosstab._onMouseEnter  type= " + type);

                        }
                    }
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseLeave = function(oEvent) {
        var self = this;

        this.logger.debug("HprCrosstab._onMouseLeave");
        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;

            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if (entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                            var type = info.pickEntryType;
                            //sas.log.info("HprCrosstab._onMouseLeave  type= " + type);

                        }
                    }
                }
            }

            // Change the cursor back to the default when done draggin around in the crosstab.
            $('html,body').css('cursor','default');

        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onMouseMove = function(oEvent) {
        var self = this;

        this.logger.trace("HprCrosstab._onMouseMove");

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;

            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if (entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                            var type = info.pickEntryType;
                            //sas.log.info("HprCrosstab._onMouseMove  type= " + type);

                        }
                    }
                }
            }

            // // Change the cursor back to the default when done draggin around in the crosstab.
            // $('html,body').css('cursor','default');

        }
    };



    //*****************************************************************************************************
    //*****************************************************************************************************
    // Internal Drag Drop handlers
    //*****************************************************************************************************
    //*****************************************************************************************************
    var sapTouchStartInfo = undefined;

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onSAPTouchStart = function(oEvent) {

        var self = this;

        this.logger.trace("HprCrosstab._onSAPTouchStart");

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;
            if (self._isCrosstabRendering === false && pickResults) {
                var pickResult = pickResults[0];
                if (pickResult) {
                    var entries = pickResult.getEntries();
                    if (entries) {
                        var entry = entries[0];  // Should be a DataGridPickResultEntry
                        if (entry) {
                            if (entry instanceof CrosstabPickResultEntry) {
                                var type = entry.getType();
                                var info = CrosstabUtil.getPickInfo(pickResults, this.context);
                                sas.log.info("HprCrosstab._onSAPTouchStart  type= " + type);

                                switch (type) {
                                    case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                    case PickEntryType.CROSSTAB_COLUMN_HEADER :

                                        // Save the pickInfo for the starting click
                                        sapTouchStartInfo = info;

                                        // Change the cursor to give visual indication to user that they are moving something.
                                        $('html,body').css('cursor', 'move');
                                        break;

                                }
                            }
                        }
                    }
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onSAPTouchMove = function(oEvent) {

        this.logger.trace("HprCrosstab._onSAPTouchMove");
        var self = this;

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            // var dataItems = parameters.dataItems;
            // if (dataItems && dataItems.length > 0) {
            var pickResults = parameters.pickResults;
            if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                var entries = pickResults[0].getEntries();
                if (entries) {
                    var entry = entries[0];  // Should be a DataGridPickResultEntry
                    if (entry) {
                        if (entry instanceof CrosstabPickResultEntry) {
                            var type = entry.getType();

                            var infoStart = sapTouchStartInfo;
                            var infoEnd = CrosstabUtil.getPickInfo(pickResults, this.context);
                            sas.log.info("HprCrosstab._onSAPTouchMove  type= " + type + "  startName= " + (infoStart ? infoStart.name : "undefined") + "  endName= " + infoEnd.name);
                            if ((infoStart) && (infoEnd)) {
                                //if ((infoStart) && (infoStart.name != infoEnd.name)) {
                                //sas.log.info("HprCrosstab._onSAPTouchMove  type= " + type + "  startName= " + infoStart.name + "  endName= " + infoEnd.name);
                                switch (type) {
                                    case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                    case PickEntryType.CROSSTAB_COLUMN_HEADER :
                                        // Change the cursor to give visual indication to user.
                                        $('html,body').css('cursor', 'move');
                                        break;
                                    case PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER:
                                    case PickEntryType.CROSSTAB_ROW_AXIS_LABEL_HEADER:
                                    case PickEntryType.CROSSTAB_ROW_HEADER:
                                    case PickEntryType.CROSSTAB_DATA_CELL:
                                    default:
                                        // Change the cursor to give visual indication to user.
                                        $('html,body').css('cursor', 'not-allowed');
                                        break;

                                }
                            }
                        }
                    }
                }
            }
            // }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onSAPTouchEnd = function(oEvent) {

        var self = this;

        this.logger.debug("HprCrosstab._onSAPTouchEnd");

        // Change the cursor back to the default when done draggin around in the crosstab.
        $('html,body').css('cursor','default');

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var pickResults = parameters.pickResults;
            if (self._isCrosstabRendering === false && pickResults) {
                var pickResult = pickResults[0];
                if (pickResult) {
                    var entries = pickResult.getEntries();
                    if (entries) {
                        var entry = entries[0];  // Should be a DataGridPickResultEntry
                        if (entry) {
                            if (entry instanceof CrosstabPickResultEntry) {
                                var type = entry.getType();
                                var infoStart = sapTouchStartInfo;
                                var infoEnd = CrosstabUtil.getPickInfo(pickResults, this.context);

                                var isInfoDifferent = function (info1, info2) {
                                    // S1395396: Only allow drag/drop to/from headers.  Column and measure header pickInfos have keys
                                    if (!info1.keys || !info2.keys) {
                                        return false;  // ignore dropping column header on data cell
                                    }

                                    if (info1.keys.length === info2.keys.length) {
                                        for (var i = 0; i < info1.keys.length; i++) {
                                            if (info1.keys[i] !== info2.keys[i]) {
                                                return true;
                                            }
                                        }
                                        return false;
                                    }
                                    return true;
                                };

                                if ((infoStart && infoEnd) && isInfoDifferent(infoStart, infoEnd)) {
                                    this.logger.debug("HprCrosstab._onSAPTouchEnd", "type= " + type + "  startName= " + infoStart.name + "  endName= " + infoEnd.name);

                                    switch (type) {
                                        case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                        case PickEntryType.CROSSTAB_COLUMN_HEADER :
                                            // Realign the column widths before the move.
                                            setTimeout(function() {
                                                self._realignColumnWidths(infoEnd);
                                                self._handleDropCrosstabColumnHeader(infoStart, infoEnd);
                                                self.rebuildCrosstab();
                                            },0);
                                            break;
                                        case PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER:
                                            break;
                                        case PickEntryType.CROSSTAB_ROW_HEADER:
                                            //self._handleDropCrosstabColumnHeader(infoStart, infoEnd);
                                            //self.rebuildCrosstab();
                                            break;

                                    }
                                }
                                else {
                                    switch (type) {
                                        case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                        case PickEntryType.CROSSTAB_COLUMN_HEADER :
                                            // Realign the column widths before the move.
                                            setTimeout(function() {
                                                self._realignColumnWidths(infoEnd);
                                            },0);
                                            break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else {
                this.logger.debug("HprCrosstab._onSAPTouchEnd   no pickResult");
            }
            sapTouchStartInfo = undefined;
        }
        else {
            this.logger.debug("HprCrosstab._onSAPTouchEnd   no event");
        }
        sapTouchStartInfo = undefined;

        // Change the cursor to give visual indication to user.
        $('html,body').css('cursor', 'default');
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._handleDropCrosstabColumnHeader = function(infoStart, infoEnd) {

        this.logger.trace("HprCrosstab._handleDropCrosstabColumnHeader");
        var self = this;

        // Do we have what we need?
        if (infoStart.keys  && infoStart.keys.length > 0 && infoEnd.keys && infoEnd.keys.length > 0) {

            // Ensure the keys are the same length, if not bail
            if (infoStart.keys.length === infoEnd.keys.length) {

                var nodePath = [];
                for (var idx = 0; idx < infoEnd.keys.length; idx++) {
                    var endKey = infoEnd.keys[idx];
                    if (infoStart.keys.length > idx) {
                        var startKey = infoStart.keys[idx];

                        // Find difference? If so get column tree node and adjust accordingly
                        if (endKey !== startKey) {
                            // find node
                            var parentNode = self.context.findColumnTreeNode(nodePath);

                            var startIndex = _.indexOf(_.pluck(parentNode.children, 'name'), startKey);
                            var endIndex = _.indexOf(_.pluck(parentNode.children, 'name'), endKey);

                            var tmp = parentNode.children[startIndex];
                            parentNode.children.splice(startIndex, 1); // remove it
                            parentNode.children.splice(endIndex, 0, tmp);

                            // invalidate the columnTuples
                            self.context.columnTuples = undefined;

                            // done so break out
                            break;
                        } else {
                            nodePath.push(endKey);
                        }
                    }
                }
            }

        }

    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // External Drag Drop handlers
    //*****************************************************************************************************
    //*****************************************************************************************************
    var externalDragStart = false;

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onExtDragOut = function(oEvent) {

        var self = this;

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            if (externalDragStart === true) {
                externalDragStart = false;
                // Change the cursor to give visual indication to user.
                $('html,body').css('cursor', 'default');
            }
            this.logger.debug("HprCrosstab._onExtDragOut", "externalDragStart =" + externalDragStart);
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onExtDragOver = function(oEvent) {

        var self = this;

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            externalDragStart = true;
            // Change the cursor to give visual indication to user.
            $('html,body').css('cursor', 'move');
            this.logger.debug("HprCrosstab._onExtDragOver", "externalDragStart =" + externalDragStart);
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onExtMouseMove = function(oEvent) {

        var self = this;

        // Make pagingPopover disappear
        if (self.pagingPopover !== undefined) {
            self.pagingPopover.close();
        }

        if (oEvent && externalDragStart) {
            oEvent.preventDefault();
            oEvent.cancelBubble();

            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var extDataSourceId = parameters.dataSourceId;
            if (extDataSourceId === self.context.dataSourceId) {
                var pickResults = parameters.pickResults;
                if (self._isCrosstabRendering === false && pickResults && pickResults[0]) {
                    var entries = pickResults[0].getEntries();
                    if (entries) {
                        var entry = entries[0];  // Should be a DataGridPickResultEntry
                        if (entry) {
                            if (entry instanceof CrosstabPickResultEntry) {
                                var type = entry.getType();
                                var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                                // Do we have dataItems being dragged?
                                if (parameters.dataItems && parameters.dataItems.length > 0) {
                                    var dataItems = parameters.dataItems;
                                    this.logger.debug("HprCrosstab._onExtMouseMove", "externalDragStart =" + externalDragStart + "  dataItem.length= " + dataItems.length);

                                    switch (type) {
                                        case PickEntryType.CROSSTAB_ROW_AXIS_LABEL_HEADER:
                                        case PickEntryType.CROSSTAB_ROW_HEADER:
                                            if (dataItems) {
                                                if (dataItems[0].type === HIERARCHY) {
                                                    // Change the cursor to give visual indication to user.
                                                    $('html,body').css('cursor', 'move');
                                                }
                                                else {
                                                    var filteredList = _.where(dataItems, {type: CLASSVAR});
                                                    if (dataItems.length === filteredList.length) {
                                                        // Change the cursor to give visual indication to user.
                                                        $('html,body').css('cursor', 'move');
                                                    } else {
                                                        // Change the cursor to give visual indication to user.
                                                        $('html,body').css('cursor', 'not-allowed');
                                                    }
                                                }
                                            }
                                            break;
                                        case PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER:
                                            // Change the cursor to give visual indication to user.
                                            $('html,body').css('cursor', 'not-allowed');
                                            break;
                                        case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                        case PickEntryType.CROSSTAB_COLUMN_HEADER:
                                            if (dataItems) {
                                                var filteredList = _.where(dataItems, {type: CLASSVAR});
                                                if (filteredList.length === 0) {
                                                    // IF one dataItem and a valid tuple can be created
                                                    // OR multiple dataItems and together are a valid tuple
                                                    // OR multiple dataItems of the same type
                                                    // THEN color cell green
                                                    if ((dataItems.length === 1) && (self.context.createValidTuplesForDataItem(dataItems[0], info)) ||
                                                        (dataItems.length > 1) && (self.context.validTuple(dataItems)) ||
                                                        (dataItems.length > 1) && (_.every(dataItems, function(item){return item.type === dataItems[0].type;}))) {
                                                        // Change the cursor to give visual indication to user.
                                                        $('html,body').css('cursor', 'move');
                                                    }
                                                } else {
                                                    // Change the cursor to give visual indication to user.
                                                    $('html,body').css('cursor', 'not-allowed');
                                                }
                                            }
                                            break;
                                        case PickEntryType.CROSSTAB_DATA_CELL:
                                            // Change the cursor to give visual indication to user.
                                            $('html,body').css('cursor', 'not-allowed');
                                            break;
                                        default:
                                            this.logger.warning("HprCrosstab._onExtMouseMove", "Unknown type");
                                    }
                                }
                                else {
                                    // We can do something else here in the future.
                                }
                            }
                        }
                    }
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onExtDragDrop = function(oEvent) {

        var self = this;

        self.logger.trace("HprCrosstab._onExtDragDrop");

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters(); // :CrosstabPickResultEntry
            var dataItems = parameters.dataItems;
            var extDataSourceId = parameters.dataSourceId;
            if (extDataSourceId === self.context.dataSourceId) {
                if (dataItems && dataItems.length > 0) {
                    var pickResults = parameters.pickResults;
                    if (self._isCrosstabRendering === false) {
                        if (pickResults && pickResults[0]) {
                            var entries = pickResults[0].getEntries();
                            if (entries) {
                                var entry = entries[0];  // Should be a DataGridPickResultEntry
                                if (entry) {
                                    if (entry instanceof CrosstabPickResultEntry) {
                                        var type = entry.getType();
                                        var info = CrosstabUtil.getPickInfo(pickResults, self.context);

                                        self.logger.debug("HprCrosstab._onExtDragDrop", " externalDragStart= " + externalDragStart + "  dataItem.length= " + dataItems.length);
                                        switch (type) {
                                            case PickEntryType.CROSSTAB_ROW_HEADER:
                                                self.doDropRowHeader(dataItems, info);
                                                break;
                                            case PickEntryType.CROSSTAB_COLUMN_HEADER:
                                            case PickEntryType.CROSSTAB_MEASURE_HEADER:
                                                self.doDropColumnHeader(dataItems, info);
                                                break;
                                            case PickEntryType.CROSSTAB_ROW_AXIS_LABEL_HEADER:
                                            case PickEntryType.CROSSTAB_COLUMN_AXIS_LABEL_HEADER:
                                            case PickEntryType.CROSSTAB_DATA_CELL:
                                                break;
                                            default:
                                                this.logger.warning("HprCrosstab._onExtDragDrop", "Unknown type");
                                        }
                                    }
                                }
                            }
                        }

                        // no pick result?
                        else {
                            self.logger.warning("HprCrosstab._onExtDragDrop", "Default drop");

                            if (_.every(dataItems, function (dataItem) {
                                    return CrosstabUtil.isClassvarDataItemType(dataItem);
                                })) {
                                self.doDropRowHeader(dataItems, info);
                            }
                            else if (_.every(dataItems, function (dataItem) {
                                    return !CrosstabUtil.isClassvarDataItemType(dataItem);
                                })) {
                                self.doDropColumnHeader(dataItems, info);
                            }
                            else {
                                // Got a mix of classvar and non-classvar dataItems?  No soup for you.
                            }
                        }
                    } // crosstab is rendering
                }
                else {
                    self.logger.warning("HprCrosstab._onExtDragDrop", "No dataItems to drop");
                }
            }
            else {
                var extDSParams = DataSourceCacheManager.getDataSourceParam(extDataSourceId);
                var selfDSParams = DataSourceCacheManager.getDataSourceParam(self.context.dataSourceId);
                var messageText = self.context.getI18NBundle().getText('HPRisk.Crosstab.dataSource.dataItem.mismatch.fmt', [extDSParams.label, self.context.optionName, selfDSParams.label]);
                self.logger.warning("HprCrosstab._onExtDragDrop", messageText);
                HprUtil.displayGenericErrorDialog(messageText);
            }
        }

        // Set our drag flag.
        externalDragStart = false;

        // Clear out the draggable objects because they have been consumed.
        sas.analytics.riskhp.views.datapane.DataPaneUtil.clearSelections();
        sas.analytics.riskhp.models.HPRiskModelManager.setDraggableObjects([]);

        // Change the cursor to give visual indication to user.
        $('html,body').css('cursor', 'default');
    };

    /**
     * Handle dropping dataItem(s) on the crosstab column header.
     * @param dataItems
     * @param info
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doDropColumnHeader = function(dataItems, info) {
        var self = this;

        if (dataItems) {
            var dataItem = dataItems[0];

            var doAddDataItemToColumns = function () {
                var numColumnBefore = self.context.getNumberOfColumns();
                var numColumns = self.context.addDataItemToColumns(dataItem, info);
                self.rebuildCrosstab();
                var numColumnAfter = self.context.getNumberOfColumns();
                if (numColumnAfter > numColumnBefore)
                    if (numColumnAfter - numColumnBefore === 1) {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Column.Added.fmt", [self.context.getOptionName()]));
                    }
                    else {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Columns.Added.fmt", [numColumnAfter - numColumnBefore, self.context.getOptionName()]));
                    }
            };

            var doAddColumn = function (dataItemIds) {
                var dataItemsToAdd = [];
                if (dataItemIds) {
                    _.each(dataItemIds, function(dataItemId) {
                        dataItemsToAdd.push(self.context.getCubeDataModel().getDataItemById(dataItemId));
                    });
                }
                else {
                    dataItemsToAdd = dataItemsToAdd.concat(dataItems);
                }
                var successAdd = self.context.addColumn(dataItemsToAdd);
                self.rebuildCrosstab();
                if (successAdd)
                    sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Column.Added.fmt", [self.context.getOptionName()]));
            };

            var doMultiAddDataItemsToColumns = function (dataItemIds) {
                var dataItemsToAdd = [];
                if (dataItemIds) {
                    _.each(dataItemIds, function(dataItemId) {
                        dataItemsToAdd.push(self.context.getCubeDataModel().getDataItemById(dataItemId));
                    });
                }
                else {
                    dataItemsToAdd = dataItemsToAdd.concat(dataItems);
                }
                var numColumnBefore = self.context.getNumberOfColumns();
                for (var k = 0; k < dataItemsToAdd.length; k++) {
                    self.context.addDataItemToColumns(dataItemsToAdd[k], info);
                }
                self.rebuildCrosstab();
                var numColumnAfter = self.context.getNumberOfColumns();
                if (numColumnAfter > numColumnBefore) {
                    if (numColumnAfter - numColumnBefore === 1) {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Column.Added.fmt", [self.context.getOptionName()]));
                    }
                    else {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Columns.Added.fmt", [numColumnAfter - numColumnBefore, self.context.getOptionName()]));
                    }
                }
            };

            // filter out invalid computed variables
            var origNumItems = dataItems.length;
            dataItems = _.reject(dataItems, function(dataItem){
                return dataItem.type === COMPVAR && dataItem.subType === "expression" && dataItem.error !== 0;
            });
            if (origNumItems !== dataItems.length) {
                sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Cannot.Add.Invalid.Computed.Variables.Error.txt"));
            }

            // Multiple dataItem DND
            if (dataItems.length > 1) {
                // Use first dataItem as the type to be compared against all others.
                // If the dataItems are the same type, otherDataItems will be empty.
                // If there are otherDataItems, then we have mixed dataItem types and
                // the user may be trying to add a column.
                var dataItemType = dataItems[0].type;
                var otherDataItems = _.filter(dataItems, function (dataItem) {
                    return (dataItem.type !== dataItemType);
                });

                // Are we a proper column tuple (ie different dataItem types)?
                if (otherDataItems.length > 0) {
                    // If no classvars, then continue on and try to add a column.
                    if (_.every(dataItems, function (dataItem) {
                            return !CrosstabUtil.isClassvarDataItemType(dataItem);
                        })) {
                        for (var j = 0; j < dataItems.length; j++) {
                            self.logger.debug("HprCrosstab._onExtDragDrop", "Dropping  name: " + dataItems[j].name + "  id: " + dataItems.id + "  type: " + dataItems[j].type);
                        }
                        if (self.context.isValidColumn(dataItems)) {
                            //If there is a scenario here, add it only if it is activated.
                            var scenarioDataItemInfo = self.context.getDataItemInfoFromTuple(dataItems, SCENARIO);
                            if (_.isUndefined(scenarioDataItemInfo) || scenarioDataItemInfo.dataItem.isActivated()) {
                                doAddColumn();
                            }
                        }
                        else {
                            self.logger.warning("HprCrosstab._onExtDragDrop   DataItems do not make a valid column");
                        }
                    }
                }
                // There must be multiple dataItems all the same type.
                else {
                    // Scenarios?
                    if (dataItems[0].type === SCENARIO) {
                        var scenarioIdList = [];
                        // get a list of activated scenario ids
                        for (var n = 0; n < dataItems.length; n++) {
                            if (dataItems[n].activated) {
                                scenarioIdList.push(dataItems[n].getId());
                            }
                        }
                        doMultiAddDataItemsToColumns(scenarioIdList);
                    }
                    // Handle non-scenario dataItems
                    else {
                        doMultiAddDataItemsToColumns();
                    }
                }
            }
            // Single dataItem DND
            else if (dataItems.length === 1){

               // Always add a resultset as it's scenarios are implicitly activated
               if ((dataItem.type === RESULTSET)) {
                    doAddDataItemToColumns();
                }
                // Check here if dataItem is a scenario and it is active and if so add it.
                else if ((dataItem.type !== SCENARIO) || (dataItem.isActivated())) {
                    doAddDataItemToColumns();
                }
            } // single dataItem DND
        }
    };

    /**
     * Handle dropping dataItem(s) on the crosstab row header.
     * @param dataItems
     * @param info
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.doDropRowHeader = function(dataItems, info) {
        var self = this;

        //if (dataItems && info) {
        if (dataItems) {
            var optionHierarchy = self.context.getOptionHIERARCHY();
            if (dataItems.length === 1) {
                this.logger.debug("HprCrosstab.doDropRowHeader", "Dropping  name: " + dataItems[0].name + "  id: " + dataItems[0].id);
                if (dataItems[0].type === CLASSVAR) {
                    if (optionHierarchy.value.length > 0) {
                        var hierarchyDialog = sap.ui.jsfragment("sas.analytics.riskhp.fragments.HierarchyDialog", {
                            messageText: HprUtil.getBundle().getText("Hierarchy.forced.modify.dialog.txt"),
                            messageText2: HprUtil.getBundle().getText("Hierarchy.forced.modify.append.dialog.txt"),
                            doAppend: function () {
                                self.context.pushClassVariable(dataItems[0]);

                                // Set hierarchy option
                                var optionHierarchy = self.context.getOptionHIERARCHY();
                                optionHierarchy.value = "";
                                self.context.setOptionHIERARCHY(optionHierarchy);

                                self.updateHierarchiesPane();
                                self.rebuildCrosstab();
                            },
                            doInsert: function () {
                                // clear results and clear drill
                                self.context.resetReportResultsTree();

                                self.context.insertClassVariable(dataItems[0]);

                                self.updateHierarchiesPane();
                                self.rebuildCrosstab();
                            }
                        });
                        hierarchyDialog.open();
                    }
                    else {
                        self.context.pushClassVariable(dataItems[0]);
                        self.updateHierarchiesPane();
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Classvar.Added.fmt", [self.context.getOptionName()]));
                        self.redraw();
                        self.setDirty(true); // Class Variables added, need to set dirty
                    }
                } else if (dataItems[0].type === HIERARCHY) {
                    // If forced hierarchy, then set the option, remove existing cvs and clear drill
                    if (dataItems[0].forced === true) {
                        var hierarchyDialog = sap.ui.jsfragment("sas.analytics.riskhp.fragments.HierarchyDialog", {
                            messageText: HprUtil.getBundle().getText("Hierarchy.forced.enable.dialog.txt"),
                            doContinue: function() {
                                // remove existing classvars
                                self.context.setClassVariables([]);
                                // clear results and clear drill
                                self.context.resetReportResultsTree();

                                // Loop thru classvar ids, get the dataItem and add to crosstab
                                for (var j = 0; j < dataItems[0].classVariables.length; j++) {
                                    self.context.pushClassVariable(dataItems[0].classVariables[j]);
                                }

                                // Set hierarchy option
                                var optionHierarchy = self.context.getOptionHIERARCHY();
                                optionHierarchy.value = dataItems[0].name;
                                self.context.setOptionHIERARCHY(optionHierarchy);

                                self.updateHierarchiesPane();
                                self.rebuildCrosstab(true);
                            }
                        });
                        hierarchyDialog.open();
                    }
                    else {
                        // Loop thru classvar ids, get the dataItem and add to crosstab
                        for (var j = 0; j < dataItems[0].classVariables.length; j++) {
                            self.context.pushClassVariable(dataItems[0].classVariables[j]);
                        }
                        self.updateHierarchiesPane();
                        if (dataItems[0].classVariables.length === 1) {
                            sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Classvar.Added.fmt"), [self.context.getOptionName()]);
                        } else {
                            sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Classvars.Added.fmt", [dataItems[0].classVariables.length, self.context.getOptionName()]));
                        }
                        self.redraw();
                        self.setDirty(true); // Class Variables added, need to set dirty
                    }
                }
            }
            else {
                var isAllClassvars = _.every(dataItems, function(dataItem){
                    return dataItem.type === CLASSVAR;
                });
                if (isAllClassvars) {
                    if (optionHierarchy.value.length > 0) {
                        var hierarchyDialog = sap.ui.jsfragment("sas.analytics.riskhp.fragments.HierarchyDialog", {
                            messageText: HprUtil.getBundle().getText("Hierarchy.forced.modify.dialog.txt"),
                            messageText2: HprUtil.getBundle().getText("Hierarchy.forced.modify.append.dialog.txt"),
                            doAppend: function () {
                                for (var i = 0; i < dataItems.length; i++) {
                                    self.logger.debug("HprCrosstab.doDropRowHeader", "Dropping  name: " + dataItems[i].name + "  id: " + dataItems[i].id);
                                    self.context.pushClassVariable(dataItems[i])
                                }

                                // Set hierarchy option
                                var optionHierarchy = self.context.getOptionHIERARCHY();
                                optionHierarchy.value = "";
                                self.context.setOptionHIERARCHY(optionHierarchy);

                                self.updateHierarchiesPane();
                                self.rebuildCrosstab();
                            },
                            doInsert: function () {
                                // clear results and clear drill
                                self.context.resetReportResultsTree();

                                for (var i = dataItems.length - 1; i >= 0; i--) {
                                    self.logger.debug("HprCrosstab.doDropRowHeader", "Dropping  name: " + dataItems[i].name + "  id: " + dataItems[i].id);
                                    self.context.insertClassVariable(dataItems[i])
                                }

                                self.updateHierarchiesPane();
                                self.rebuildCrosstab();
                            }
                        });

                        hierarchyDialog.open();
                    }
                    else {
                        for (var i = 0; i < dataItems.length; i++) {
                            self.logger.debug("HprCrosstab.doDropRowHeader", "Dropping  name: " + dataItems[i].name + "  id: " + dataItems[i].id);
                            self.context.pushClassVariable(dataItems[i]);
                        }
                        self.updateHierarchiesPane();
                        if (dataItems.length === 1) {
                            sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Classvar.Added.fmt"), [self.context.getOptionName()]);
                        } else {
                            sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Classvars.Added.fmt", [dataItems.length, self.context.getOptionName()]));
                        }
                        self.redraw();
                        self.setDirty(true); // Class Variables added, need to set dirty
                    }
                }
                else {
                    // We got a non-classvar in the dataItems list.
                }
            }
        }
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onExtDoubleClick = function(oEvent) {

        var self = this;

        this.logger.trace("HprCrosstab._onExtDoubleClick");

        if (oEvent) {
            oEvent.preventDefault();
            oEvent.cancelBubble();
            var parameters = oEvent.getParameters();
            var pickResults =  parameters.pickResults;
            if (pickResults && pickResults.length > 0) {
                var info = sas.analytics.riskhp.common.riskcommons.CrosstabUtil.getPickInfo(pickResults, self.context);

                // Only let the plots get an update event if the double click was on a data cell
                if (info.pickEntryType === PickEntryType.CROSSTAB_DATA_CELL) {
                    sas.eventBus.publish(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_UPDATE_LINKED_PLOTS, {
                        crosstabId: self.getId(),
                        selectedCellChanged: true,
                        info: info
                    });
                }
            }
        }
    };


    /**
     * Publish an event that will update the Hierarchies pane/pain  ;-)
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.updateHierarchiesPane = function() {
        var self = this;

        sas.eventBus.publish(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_UPDATED, {
            hierarchiesType: HprConstants.HPR_HIERARCHIES_PANE_CROSSTAB_TYPE,
            crosstabId: self.context.getId(),
            checkIdOfHierarchiesPane: true
        });
    };

    //*****************************************************************************************************
    //*****************************************************************************************************
    // Panel View toolbar handlers
    //*****************************************************************************************************
    //*****************************************************************************************************

    /**
     * Returns the toolbar actions for the view.
     * @returns {Array}
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.getToolbarActions = function() {
        var self = this;

        // Use sas.analytics.riskhp.utils.HprUtil.getBundle() in this case because self.context has not
        // been initialized when this method is called
        var actions = [];

        // Only add these actions if the model is valid
        if (self.isModelValid()) {
            var addComputedVariableAction = {
                text: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Add.Computed.Variable.txt"),
                tooltip: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Add.Computed.Variable.tip"),
                press: function() {
                    $.proxy(self._openComputedVariableEditor(),self);
                }
            };
            var exportToExcelAction = {
                text: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Export.txt"),
                tooltip: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Export.tip"),
                startsSection: true,
                press: function() {
                    $.proxy(self.exportCrosstabToExcel(),self);
                }
            };
            actions.unshift(exportToExcelAction);
            actions.unshift(addComputedVariableAction); // Add Computed Variable should go first
        }

        // Add these actions if the model is valid or the model is invalid but a data source id is
        // provided (this will allow a reset on the Crosstab to complete correctly)
        if (self.isModelValid() || (!self.isModelValid() && self.context.getDataSourceId() && !_.isEmpty(self.context.getDataSourceId()))) {
            var resetToDefaultsAction = {
                text: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Defaults.txt"),
                tooltip: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Defaults.tip"),
                groupWithRemoveAction: true,
                press: function() {
                    // Construct a dialog to prompt the user
                    new sas.hc.m.MessageDialog.warning({
                        text: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Defaults.Confirmation.Dialog.Warning.txt"),
                        title: HprUtil.getBundle().getText("HPRisk.Crosstab.Toolbar.Defaults.Confirmation.Dialog.title"),
                        buttonActions: [
                            {
                                text: sas.hc.m.MessageDialogAction.Yes
                            },
                            {
                                text: sas.hc.m.MessageDialogAction.No,
                                initialFocus: true,
                                defaultButton: true
                            }
                        ]
                    }).attachButtonPress(function(evt) {
                            var oButton = evt.getParameter("origin");
                            // Try to match up the text by using lowercase
                            if (oButton.getText().toLowerCase() === sas.hc.m.MessageDialogAction.Yes.toLowerCase()) {
                                $.proxy(self._resetToDefaults(), self);
                            }
                    });
                }
            };
            actions.push(resetToDefaultsAction);
        }

        return actions;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._resetToDefaults = function() {
        var self = this;

        self.context.setDefaultOptions(self.context.getCubeDataModel().getOptions(), self.context.optionName);
        self.context.setDefaultFilters(self.context.getCubeDataModel().getDefaultFilters());
        self.context.resetToDefaults();
        self.rebuildCrosstab();

        // Since this deferred might complete after the Crosstab has been returned to the window manager,
        // we need to refresh the panel to make sure to pick up the correct panel title and footer
        sas.analytics.riskhp.utils.HprUtil.getSelectedRiskPanelsView().refreshPanelWithId(self.context.getId(), true, null);

        // Publish an event that will update the Options pane based on the Crosstab
        sas.eventBus.publish(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_OPTIONS_PANE_CHANGED, {
            optionsType: HprConstants.HPR_OPTIONS_PANE_CROSSTAB_TYPE,
            crosstabId: self.context.id,
            updateOptionsModel: true
        });

        // Publish an event that will update the name of the Crosstab
        // This will also remove the (Forced Hierarchy) indicator if present
        sas.eventBus.publish(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_NAME_UPDATED, {
            crosstabId: self.context.id,
            newCrosstabName: self.context.getOptionName()
        });

        // Publish an event that will update the Filters pane based on a Zero State
        sas.eventBus.publish(HprConstants.CHANNEL_FILTERS_PANE, HprConstants.EVENT_FILTERS_CROSSTAB_CHANGED, {
            filtersType: HprConstants.HPR_FILTERS_PANE_CROSSTAB_TYPE,
            crosstabId: self.context.getId()
        });

        // Publish an event that will update the Hierarchies pane/pain  ;-)
        sas.eventBus.publish(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_UPDATED, {
            hierarchiesType: HprConstants.HPR_HIERARCHIES_PANE_CROSSTAB_TYPE,
            crosstabId: self.context.getId(),
            checkIdOfHierarchiesPane: true
        });

    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._openComputedVariableEditor = function() {
        var self = this;

        var expCtrl = sas.analytics.riskhp.utils.ViewManager.getExplorationView().getController();
        expCtrl.createComputedVariable.call(expCtrl, self.context.getId());
    };


    //*****************************************************************************************************
    //*****************************************************************************************************
    // Context Menu handlers
    //*****************************************************************************************************
    //*****************************************************************************************************

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onContextMenu = function(oMenu, oEvent) {

        var self = this;
        this.logger.trace("HprCrosstab._onContextMenu");

        oMenu.removeAllItems();
        var location = sas.ltjs.commons.gestures.GestureHelper.getMousePosition(oEvent, this.uiView._visualizationManager._gestureHelper._element);
        var pickResults =  this.uiView.getPickResults(location.localX, location.localY);
        if (pickResults && pickResults.length > 0) {
            menuProvider.buildContextMenu(oMenu, pickResults, self);
        }

        return oMenu;
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.moveColumn = function (direction, info) {
        var self = this;

        var currentNode = this.context.findColumnTreeNode(info.keys);
        var parentNode = currentNode.parent;
        // moveBegin
        // Get current index
        var currentIndex = _.findIndex(parentNode.children, function (childNode) {
            return childNode.name === currentNode.name;
            // return (childNode.name === currentNode.name ? true : false);
        });

        switch (direction) {
            case "begin":
                // Remove current node
                parentNode.children.splice(currentIndex, 1);

                // Insert node at index 0
                parentNode.children.unshift(currentNode);
                break;
            case "end":
                // Remove current node
                parentNode.children.splice(currentIndex, 1);

                // Insert node at last index
                parentNode.children.push(currentNode);
                break;
            case "left":
                // Remove current node if it isn't the first one
                if (currentIndex > 0) {
                    parentNode.children.splice(currentIndex, 1);

                    // Insert node at index - 1
                    parentNode.children.splice(currentIndex - 1, 0, currentNode);
                }
                break;
            case "right":
                // Remove current node if it isn't the first one
                if (currentIndex < parentNode.children.length - 1) {
                    parentNode.children.splice(currentIndex, 1);

                    // Insert node at last index
                    parentNode.children.splice(currentIndex + 1, 0, currentNode);
                }
                break;
        }

        // Realign the column widths after the move.
        //self._realignITJSWidths();

        this.rebuildCrosstab();
    };

    /**
     * Creates a new menu item given label and name
     *
     * @param label {string}
     * @param name {string}
     * @param enabled [boolean}
     * @param data {Array<KeyValuePair>}
     * @returns {sas.hc.ui.unified.MenuItem}
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._createMenuItem = function(label, name, enabled, selectedHandler) {
        var item = new MenuItem({
            text: label,
            select: selectedHandler,
            enabled: enabled,
            tooltip: label
        });

        return item;
    };

    // override
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._contextMenuItemSelected = function(name, item, selectedHandler) {
        sas.log.info("HprCrosstab._contextMenuItemSelected for: " +  name);
        selectedHandler();
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._getStatListForPlot = function() {
        var self = this;
        return _.map(
            [
                sas.analytics.riskhp.models.dataitems.Statistic.MIN,
                sas.analytics.riskhp.models.dataitems.Statistic.Q1,
                sas.analytics.riskhp.models.dataitems.Statistic.MEDIAN,
                sas.analytics.riskhp.models.dataitems.Statistic.Q3,
                sas.analytics.riskhp.models.dataitems.Statistic.MAX,
                sas.analytics.riskhp.models.dataitems.Statistic.MEAN,
                sas.analytics.riskhp.models.dataitems.Statistic.STD,
                sas.analytics.riskhp.models.dataitems.Statistic.NUMPRICE
            ],
            function (name) {
                return CrosstabUtil.getDataItem(name, STATISTIC, self.context.cubeDataModel);
            });
    };

    /**
     * Adjust the height of the crosstab view based on the height (or lack thereof) of the breadcrumb displayed
     * when the crosstab is drilled. Without this adjustment, the crosstab would size to 100% of the container
     * height, resulting in a scrollbar when the breadcrumb is visible and has height greater than 0.
     *
     * When the breadcrumb is displayed, the height of the crosstab view will be set to that of the parent container
     * minus the height of the breadcrumb, meaning the crosstab will fill the remaining space available without causing
     * the container to scroll.
     *
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._adjustCrosstabViewHeight = function() {
        // get jQuery references to this control, the crosstab view, and the breadcrumb
        var self$ = this.$();
        var uiView$ = self$.children(".sasView");
        var breadcrumb$ = self$.children(".sasUiBreadcrumb");

        // determine the height of the container and the breadcrumb
        var selfInnerHeight = self$.innerHeight();
        var breadcrumbHeight = breadcrumb$.outerHeight(true);

        // set the crosstab view height adjusted for the breadcrumb if it is displayed
        uiView$.height(breadcrumbHeight ? selfInnerHeight - breadcrumbHeight : "100%");
    };

    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onScenarioUpdated = function(channelId, eventId, data) {
        // if this crosstab doesn't point to the DS for which this event was fired, no-op
        if (data.dataSourceId !== this.context.dataSourceId) {
            return;
        }

        // replace the scenario in the crosstab
        var self = this;
        self.setBusy(true);
        sas.analytics.riskhp.models.DataSourceCacheManager.getDataSource(this.context.dataSourceId).done(
            function(dataSource) {
                // replace the scenario in the context
                self.context.replaceScenario(dataSource.getDataItemById(data.scenarioId), data.deletedHorizonIds, data.addedHorizonIds);

                // rebuild the crosstab
                self.rebuildCrosstab();
            }
        ).always(
            function() {
                self.setBusy(false);
            }
        );
    };

    // sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onScenarioDeleted = function(channelId, eventId, data) {
    //     this.context.removeColumnsWithKey(data.scenarioIds, sas.analytics.riskhp.models.dataitems.Scenario.SCENARIO);
    //     this.rebuildCrosstab();
    // };
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._onScenarioDeleted = function(channelId, eventId, data) {
        // if this crosstab doesn't point to the DS for which this event was fired, no-op
        if (data.dataSourceId !== this.context.dataSourceId) {
            return;
        }

        // replace the scenario in the crosstab
        var self = this;
        self.setBusy(true);
        sas.analytics.riskhp.models.DataSourceCacheManager.getDataSource(this.context.dataSourceId).done(
            function(dataSource) {
                // remove the scenarios in the context
                _.each(data.scenarioIds, function (scenarioId) {
                    self.context.removeColumnsBasedOnId(scenarioId);
                });

                // rebuild the crosstab
                self.rebuildCrosstab();
            }
        ).always(
            function() {
                self.setBusy(false);
            }
        );
    };


    /**
     * Runs the scenario by activating it (if necessary) and adding it to the crosstab. This function is for
     * external callers that need the crosstab to handle this request while it might not yet be ready to accept
     * it (i.e. in a busy state while processing a query).
     *
     * @param scenario {sas.analytics.riskhp.models.dataitems.Scenario} the scenario to run
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.runScenario = function(scenario) {
        var self = this;

        var __isCrosstabBusy = function() {
            return self.getBusy() === true || self.getIsCrosstabRendering() === true;
        };

        //FIXME--possibly temporary--not sure if this (interval in this function) is the best way to handle this or not.
        // determine if the crosstab is busy, and if so wait for it to be done before continuing
        if (__isCrosstabBusy() === true) {
            var busyInterval = setInterval(function () {
                if (__isCrosstabBusy() === false) {
                    clearInterval(busyInterval);
                    self._runScenarioInternal(scenario);
                }
            }, 500);
        }
        else {
            self._runScenarioInternal(scenario);
        }
    };

    /**
     * Runs the scenario by activating it (if necessary) and adding it to the crosstab. This function is intended
     * for internal callers that know the current state of the crosstab (i.e. if it is busy processing).
     *
     * @param scenario {sas.analytics.riskhp.models.dataitems.Scenario} the scenario to run
     *
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype._runScenarioInternal = function(scenario) {
        var self = this;
        var rb = sas.analytics.riskhp.utils.HprUtil.getBundle();

        self.setBusy(true);

        if (scenario.isActivated()) {
            var numColumnBefore = self.context.getNumberOfColumns();
            if (self.context.addDataItemToColumns(scenario)) {
                // $.when(
                //     self.context.cacheRefresh() // returns deferred
                // ).done(function () {
                    self.rebuildCrosstab();
                    var numColumnAfter = self.context.getNumberOfColumns();
                    if (numColumnAfter - numColumnBefore === 1) {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Column.Added.fmt", [self.context.getOptionName()]));
                    }
                    else {
                        sas.hc.m.MessageToast.show(self.context.getI18NBundle().getText("HPRisk.Crosstab.Columns.Added.fmt", [numColumnAfter - numColumnBefore, self.context.getOptionName()]));
                    }
                // });
            }
            else {
                sas.analytics.riskhp.utils.HprUtil.displayGenericErrorDialog(rb.getText("RunScenario.error.fmt", [scenario.getLabel()]));
            }
            self.setBusy(false);
        }

    };


    /**
     * Export this crosstab to excel
     *
     * @private
     */
    sas.analytics.riskhp.common.riskcommons.crosstab.HprCrosstab.prototype.exportCrosstabToExcel = function() {
        var self = this;

        // Get export JSON
        var exportData = self.context.exportJSONRequest();

        // fire off call to export servlet
        self.logger.debug("Exporting crosstab to excel");
        $.when(
            self.context.api.exportPanel(exportData)
        ).done(function (exportResults) {

                var success = exportResults.success;

                self.logger.debug("Exporting crosstab to excel - " + success);

                setTimeout(function() {
                    // Make sure to remove the busy state after setBusy 'true' runs
                    self.uiView.setBusy(false);
                },0);

            }).fail(function (jqxhr) {

                setTimeout(function() {
                    // Make sure to remove the busy state after setBusy 'true' runs
                    self.uiView.setBusy(false);
                },0);

                // Construct error message
                var msg = self.context.getI18NBundle().getText('HPRisk.Crosstab.export.to.excel.error.txt');
                if (jqxhr && jqxhr.responseJSON) {
                    msg = jqxhr.responseJSON.message;
                }

                HprUtil.displayGenericErrorDialog(msg);
            });
    };

}());
