// (c) 2018, SAS Institute Inc.

/**
 * SAS HP Risk extension of sap.m.ObjectStatus. Originally created by
 * Strinivas Jonnalagadda.
 * Copyright 2015 SAS Institute Inc.
 * All Rights Reserved.
 * @name sas.analytics.riskhp.controls.HprObjectStatus
 * @extends sap.m.ObjectStatus
 */

jQuery.sap.declare("sas.analytics.riskhp.controls.HprObjectStatus");

jQuery.sap.require("sas.hc.m.ObjectStatus");
jQuery.sap.require("sas.hc.m.ObjectStatusRenderer");


sas.hc.m.ObjectStatus.extend("sas.analytics.riskhp.controls.HprObjectStatus", {
    renderer : {}
});

/**
 * (ryalbe): Clone of the RiskObjectStatus that works with a different icon. In the future,
 * this should be rolled into the existing risk commons version, perhaps with the ability to
 * specify which icon(s) to animate.
 *
 *
 * Animates the displayed icon if it is one of the HC progress icons.
 */
sas.analytics.riskhp.controls.HprObjectStatus.prototype.onAfterRendering = function() {
    var self = this;

    // caching the object for performance reasons
    var $imgElem = this.$("icon");

    function AnimateRotate(angle) {
        if (self.getIcon() !== sas.icons.HC.PROGRESSSTATUS) {
            return;
        }

        // we use a pseudo object for the animation (starts from `0` to `angle`),
        // you can name it as you want
        $({deg: 0}).animate({deg: angle}, {
            duration: 1500,
            step: function(now, tween) {
                // in the step-callback (that is fired each step of the animation),
                // you can use the `now` parameter which contains the current
                // animation-position (`0` up to `angle`)
                $imgElem.css({
                    transform: 'rotate(' + now + 'deg)'
                });
            },
            easing: "linear",
            complete: function() {
                AnimateRotate(360);
            }
        });
    }

    if (this.getIcon() === sas.icons.HC.PROGRESSSTATUS) {
        AnimateRotate(360);
    }
};
