// (c) 2018, SAS Institute Inc.

jQuery.sap.require("sas.analytics.riskhp.controls.RiskPropertyPaneBorderLayout");
jQuery.sap.require("sas.analytics.riskhp.utils.HprUtil");
jQuery.sap.require("sas.hc.m.HelpPopup");

sap.ui.jsfragment("sas.analytics.riskhp.fragments.DisplayRulesPane", {

    _getResourceBundle: function() {
        return sas.analytics.riskhp.utils.HprUtil.getBundle();
    },

    createContent: function (controller) {
        var displayRulesPaneView = sap.ui.view({
            id: this.createId('_displayRulesPaneView'),
            type: sap.ui.core.mvc.ViewType.JS,
            height: "100%",
            viewName: "sas.analytics.riskhp.views.displayrules.DisplayRulesPane"
        });

        // Create a BorderLayout for this PropertyPane to help with scrolling
        var borderLayout = new sas.hc.ui.commons.layout.BorderLayout({
            width: "100%",
            height: "100%",
            center: new sas.hc.ui.commons.layout.BorderLayoutArea({
                overflowX: "auto",
                overflowY: "auto",
                content: [displayRulesPaneView]
            }).addStyleClass("sasPropertyPaneLayout_paneArea_centerLayoutArea")
        });

        var propPane = new sas.analytics.riskhp.controls.RiskPropertyPaneBorderLayout({
            text: this._getResourceBundle().getText("HPRisk.DisplayRules.Pane.title.text"),
            showRefresh: false,
            buttonData: {
                icon: sas.icons.HC.CONDITIONALHIGHLIGHTINGRULES,
                tooltip: this._getResourceBundle().getText("HPRisk.DisplayRules.Pane.title.text"),
                enabled: '{' + HprConstants.MODEL_ID_EXPLORATION_PANES_STATE + '>/panes/displayRulesPane/enabled}'
            },
            borderLayout: borderLayout
        });
        return propPane;
    }
});