// (c) 2015, SAS Institute Inc.

jQuery.sap.declare("sas.analytics.riskhp.models.dataitems.Compvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.BaseDataItem");

// noinspection JSClosureCompilerSyntax
/**
 * @name sas.analytics.riskhp.models.dataitems.Compvar
 * @extends sas.analytics.riskhp.models.dataitems.BaseDataItem
 */
sas.analytics.riskhp.models.dataitems.BaseDataItem.extend("sas.analytics.riskhp.models.dataitems.Compvar",{
	constructor:function(json){
		sas.analytics.riskhp.models.dataitems.BaseDataItem.prototype.constructor.call(this, json);

        // computed variables created in exploration will have exploration = true
        if (json.exploration) {
            this.subType = "expression";
        }

        this.error = json.error;
        this._updateIcon();
	}
});

/**
 * Returns an array of string representations of property names for this object which will be used when comparing
 * two Data Source objects.  Only the properties listed here will be compared.
 * @returns {string[]}
 */
sas.analytics.riskhp.models.dataitems.Compvar.prototype.getValidPropertiesToCompare = function() {
	return ["name"];
};

/**
 * sets the label in the dataItem and the matching dataSourceParam
 * @param label
 */
sas.analytics.riskhp.models.dataitems.Compvar.prototype.setLabel = function(label) {
    this.label = label;

    // update label in computed variables manager if its an exploration CV
    if (this.subType === "expression") {
        var compVarParam = ComputedVariablesManager.getComputedVariableByName(this.getName());
        compVarParam.label = label;
    }
};

sas.analytics.riskhp.models.dataitems.Compvar.prototype._updateIcon = function() {
    if (!this.error) {
        if (this.subType === "expression") {
            // computed variables created in exploration should have a different icon
            this.icon = sas.icons.HC.ADHOCCOMPUTEDVARIABLE;
        } else {
            this.icon = sas.icons.HC.CALCULATEDCATEGORY;
        }
    } else {
        this.icon = sas.icons.HC.DRAGINVALID;
    }
};

sas.analytics.riskhp.models.dataitems.Compvar.prototype.setValid = function(valid) {
    // for legacy reasons error being non-zero means the computed variable is invalid
    this.error = (valid ? 0 : 1);

    this._updateIcon();
};

sas.analytics.riskhp.models.dataitems.Compvar.prototype.isValid = function() {
    return !this.error;
};



/* Statics */
sas.analytics.riskhp.models.dataitems.Compvar.COMPVAR = "computedVariable";