// (c) 2015, SAS Institute Inc.

jQuery.sap.declare("sas.analytics.riskhp.models.dataitems.Hierarchy");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.BaseDataItem");

/**
 * @name sas.analytics.riskhp.models.dataitems.Hierarchy
 * @extends sas.analytics.riskhp.models.dataitems.BaseDataItem
 */
sas.analytics.riskhp.models.dataitems.BaseDataItem.extend("sas.analytics.riskhp.models.dataitems.Hierarchy",{
	constructor:function(json){
		sas.analytics.riskhp.models.dataitems.BaseDataItem.prototype.constructor.call(this, json);
        this.icon = sas.icons.HC.HIERARCHYTYPE;
		this.forced = json.forced;
        this.classVariables = []; // Classvar dataItems.  (json.classVariables = classvar ids)
	}
});

sas.analytics.riskhp.models.dataitems.BaseDataItem.prototype.getType = function() {
	if (this.forced === true) {
		return sas.analytics.riskhp.models.dataitems.Hierarchy.FORECEDHIERARCHY;
	}
    return this.type;
};

sas.analytics.riskhp.models.dataitems.Hierarchy.prototype.getClassVariables=function(){
	return this.classVariables;
};

/**
 * Returns an array of string representations of property names for this object which will be used when comparing
 * two Data Source objects.  Only the properties listed here will be compared.
 * @returns {string[]}
 */
sas.analytics.riskhp.models.dataitems.Hierarchy.prototype.getValidPropertiesToCompare = function() {
	return ["id", "classVariables"];
};

/* Statics */
sas.analytics.riskhp.models.dataitems.Hierarchy.HIERARCHY = "hierarchy";
sas.analytics.riskhp.models.dataitems.Hierarchy.FORECEDHIERARCHY = "forcedhierarchy";