// (c) 2015, SAS Institute Inc.

jQuery.sap.declare("sas.analytics.riskhp.models.dataitems.Outvar");
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.BaseDataItem");

/**
 * @name sas.analytics.riskhp.models.dataitems.Outvar
 * @extends sas.analytics.riskhp.models.dataitems.BaseDataItem
 */
sas.analytics.riskhp.models.dataitems.BaseDataItem.extend("sas.analytics.riskhp.models.dataitems.Outvar",{
	constructor:function(json){
		sas.analytics.riskhp.models.dataitems.BaseDataItem.prototype.constructor.call(this, json);
        this.icon = json.mtmOnly ? sas.icons.HC.MTMOUTPUTVARIABLE : sas.icons.HC.DATAITEMS;
        this.mtmOnly = json.mtmOnly;
        this.sensitivitiesSupported = json.sensitivitiesSupported;
	}
});

sas.analytics.riskhp.models.dataitems.Outvar.prototype.isMtmOnly=function(){
    return this.mtmOnly;
};

sas.analytics.riskhp.models.dataitems.Outvar.prototype.isSensitivityAnalysisSupported=function(){
    return this.sensitivitiesSupported;
};

/**
 * Construct a tooltip for the Output Variable by seeing if it is an 'mtmOnly' Output Variable
 * @param mtmOnly
 * @returns {string || null}
 */
sas.analytics.riskhp.models.dataitems.Outvar.prototype.generateTooltip = function(json) {
    return json.mtmOnly ? sas.analytics.riskhp.utils.HprUtil.getBundle().getText("DataItem.outputVariable.mtmOnly.tip") : null;
};

/**
 * Returns an array of string representations of property names for this object which will be used when comparing
 * two Data Source objects.  Only the properties listed here will be compared.
 * @returns {string[]}
 */
sas.analytics.riskhp.models.dataitems.Outvar.prototype.getValidPropertiesToCompare = function() {
	return ["id"];
};

/* Statics */
sas.analytics.riskhp.models.dataitems.Outvar.OUTVAR = "outputVariable";
sas.analytics.riskhp.models.dataitems.Outvar.VALUE = "VALUE";
sas.analytics.riskhp.models.dataitems.Outvar.PL = "PL";