/*
 * '(c) 2017, SAS Institute Inc.'
 */
jQuery.sap.declare("sas.analytics.riskhp.sensitivities.RiskFactorSensitivitiesUtil");
jQuery.sap.require("sas.analytics.riskhp.models.DataSourceCacheManager");
jQuery.sap.require("sas.analytics.riskhp.utils.HprUtil");
jQuery.sap.require("sas.analytics.riskhp.utils.HprAPI");
jQuery.sap.require("sas.analytics.riskhp.utils.ViewManager");

/**
 * @name sas.analytics.riskhp.sensitivities.RiskFactorSensitivitiesUtil
 */
sas.analytics.riskhp.sensitivities.RiskFactorSensitivitiesUtil = {

    generateDefaultSensitivitiesTitle: function(rfsModel, dataSource) {
        var value = "";
        var dataItems = rfsModel.getTuples()[0];
        if (dataItems && dataItems.length > 0) {
            _.each(dataItems, function(dataItem) {
                if (dataItem.type !== sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE &&
                    dataItem.type !== sas.analytics.riskhp.models.dataitems.Statistic.STATISTIC)
                {
                    if (dataItem.type === sas.analytics.riskhp.models.dataitems.Horizon.HORIZON && !rfsModel.areHorizonsAbsolute()) {
                        value += (" | " + dataSource.findRelativeHorizon(dataItem.getInterval(), dataItem.getHorizonNumber(), dataItem.basecase).getLabel());
                    }
                    else {
                        value += (" | " + dataItem.getLabel());
                    }
                }
            });
        }

        return sas.analytics.riskhp.utils.HprUtil.getBundle().getText("HPRisk.Sensitivities.defaultName.fmt", [value]);
    },

    showRiskFactorsSelectorDialog: function(sourcePanelId, locationId, location, contentMetadata) {
        var HprUtil = sas.analytics.riskhp.utils.HprUtil;

        var dialog = sap.ui.jsfragment("sas.analytics.riskhp.sensitivities.RiskFactorSensitivitiesSelectorDialog");

        dialog.successCallback = function(riskFactorIds) {
            contentMetadata.riskFactors = riskFactorIds;

            HprUtil.getPanelsViewForComponent(sourcePanelId).addPanel(locationId, location, contentMetadata);
        };

        // set the contentMetadata as the model of the dialog so can get the showLabels value from the associated crosstab options pane
        var model = new sap.ui.model.json.JSONModel();
        model.setData(contentMetadata);
        dialog.setModel(model);

        dialog.open();
    }

};