// (c) 2017, SAS Institute Inc.

jQuery.sap.declare('sas.analytics.riskhp.utils.HprConstants');

/**
 * @name sas.analytics.riskhp.utils.HprConstants
 */
sas.analytics.riskhp.utils.HprConstants = (function () {
    "use strict";
    return {

        APPLICATION_ID: "HPRiskLogon",
        VAHUB_APPLICATION_ID: "VisualAnalyticsHubLogon",
        EXPLORATION_VERSION: 1,

        HPR_ROUTER_ID: "hprRouter",

        CLASSVAR_SAS_ALL_VALUE: "_sas_ALL_",
        BASECASE_PROPERTY: "basecase",

        ENABLE_DEBUG: false,

        // API constants
        HPR_BASE_EXPLORATIONS_URL: "rest/explorations",
        HPR_BASE_CUBES_URL: "rest/cubes",
        HPR_CUBE_KEEP_ALIVE_URL: "rest/cubes/keepAlive",
        HPR_CUBES_REL: "cubes",

        // Bus channels
        CHANNEL_OPTIONS_PANE: "optionsPane",
        CHANNEL_FILTERS_PANE: "filtersPane",
        CHANNEL_HIERARCHIES_PANE: "hierarchiesPane",
        CHANNEL_DISPLAY_RULES_PANE: "displayRulesPane",
        CHANNEL_EXPLORATION: "exploration",
        CHANNEL_APP_SETTINGS: "appSettings",

        // Bus events
        EVENT_DATA_ITEM_LABEL_UPDATED: "dataItemLabelUpdate",
        EVENT_DATA_ITEM_COUNT_UPDATED: "dataItemCountUpdate",
        EVENT_DELEGATE_SELECTED_CONTROL_CHANGED: "delegateSelectedControlChanged",
        EVENT_UPDATE_DIRTY_STATE: "updateDirtyState",

        EVENT_PAGE_OPTIONS_NAME_UPDATED: "pageOptionsNameUpdate",
        EVENT_CROSSTAB_OPTIONS_NAME_UPDATED: "crosstabOptionsNameUpdate",
        EVENT_CROSSTAB_OPTIONS_INDENT_UPDATED: "crosstabOptionsIndentUpdate",
        EVENT_CROSSTAB_OPTIONS_SHOW_LABELS_UPDATED: "crosstabOptionsShowLabelsUpdate",
        EVENT_CROSSTAB_OPTIONS_TRANSPOSE_UPDATED: "crosstabOptionsTransposeUpdate",
        EVENT_PLOT_OPTIONS_NAME_UPDATED: "plotOptionsNameUpdate",
        EVENT_PLOT_OPTIONS_SHOW_LABELS_UPDATED: "plotOptionsShowLabelsUpdate",
        EVENT_PORTFOLIO_DETAILS_OPTIONS_NAME_UPDATED: "portfolioDetailsOptionsNameUpdate",
        EVENT_PORTFOLIO_DETAILS_OPTIONS_SHOW_LABELS_UPDATED: "portfolioDetailsOptionsShowLabelsUpdate",
        EVENT_RISK_FACTOR_SENSITIVITIES_OPTIONS_NAME_UPDATED: "rfsOptionsNameUpdate",
        EVENT_RISK_FACTOR_SENSITIVITIES_OPTIONS_SHOW_LABELS_UPDATED: "rfsOptionsShowLabelsUpdate",
        EVENT_TABLE_VIEWER_OPTIONS_NAME_UPDATED: "tableViewerOptionsNameUpdate",
        EVENT_TABLE_VIEWER_OPTIONS_SHOW_LABELS_UPDATED: "tableViewerOptionsShowLabelsUpdate",

        EVENT_PORTFOLIO_DETAILS_PAGE_SIZE_CHANGED: "portfolioDetailsPageSizeChange",
        EVENT_HIERARCHIES_PANE_CHANGED: "changeHierarchiesPane",
        EVENT_HIERARCHIES_PANE_UPDATED: "updateHierarchiesPane",
        EVENT_HIERARCHIES_PANE_RESET: "resetHierarchiesPane",
        EVENT_OPTIONS_PANE_CHANGED: "changeOptionsPane",
        EVENT_FILTERS_PANE_CHANGED: "changeFiltersPane",
        EVENT_FILTERS_CROSSTAB_CHANGED: "changeFiltersCrosstab",
        EVENT_DISPLAY_HORIZONS_CHANGED: "displayHorizonsChange",
        EVENT_SHOW_LABELS_CHANGED: "showLabelsChange",
        EVENT_DISPLAY_RULES_PANE_CHANGED: "changeDisplayRulesPane",
        EVENT_DISPLAY_RULES_CHANGED: "changeDisplayRules",

        EVENT_SCENARIO_UPDATED: "sceanarioUpdated",
        EVENT_SCENARIO_DELETED: "scenarioDeleted",
        EVENT_SCENARIO_ADDED: "scenarioAdded",

        EVENT_COMPUTED_VARIABLE_EDITOR: "displayComputedVariableEditor",
        EVENT_CLOSE_COMPUTED_VARIABLE_EDITOR: "closeComputedVariableEditor",

        EVENT_CLOSE_DISPLAY_RULE_EDITOR: "closeDisplayRuleEditor",
        EVENT_DISPLAY_RULES_VALIDATED: "displayRulesValidated",

        EVENT_UPDATE_LINKED_PLOTS: "updateLinkedPlots",
        EVENT_CROSSTAB_DELETED: "crosstabDeleted",

        // Queues
        HPR_QUEUE_REVALIDATE_COMP_VARS_TASKS: "revalidateCompVarsTasks",

        // View constants
        HPR_WELCOME_VIEW_ID: "HprWelcomeView",
        HPR_EXPLORATION_VIEW_ID: "ExplorationView",
        HPR_DEFAULT_ROUTER_VIEW_ID: "Default",

        // URL parameters
        HPR_URL_PARAMETER_INITIAL_VIEW: "initialView",
        HPR_URL_PARAMETER_EXPLORATION: "exploration",
        HPR_URL_PARAMETER_LAUNCHED_FROM_APP_SWITCHER: "launchedFromAppSwitcher",
        HPR_URL_PARAMETER_DEBUG: "debug",

        // Component constants (concatenated with some other identifier)
        HPR_CROSSTAB_COMPONENT_ID: "RiskPanelsViewCrosstab_",
        HPR_PLOT_COMPONENT_ID: "RiskPanelsViewPlot_",
        HPR_PORTFOLIO_DETAILS_COMPONENT_ID: "RiskPanelsViewPortfolioDetails_",
        HPR_SIMULATED_VALUES_COMPONENT_ID: "RiskPanelsViewSimulatedValues_",
        HPR_ZERO_STATE_COMPONENT_ID: "RiskPanelsViewZeroState_",

        // Cube constants
        HPR_CUBE_INFORMATION_TYPE_PRICE: "price",
        HPR_CUBE_INFORMATION_TYPE_STRESS: "stress",
        HPR_CUBE_INFORMATION_TYPE_PRICESTRESS: "priceStress",
        HPR_CUBE_INFORMATION_TYPE_PORTFOLIO: "portfolio",
        HPR_CUBE_INFORMATION_JOINTYPE_NONE: "none",
        HPR_CUBE_INFORMATION_JOINTYPE_AGGREGATE: "aggregate",
        HPR_CUBE_INFORMATION_JOINTYPE_SIDEBYSIDE: "sideBySide",

        // Model constants
        MODEL_ID_EXPLORATION: "EXPLORATION_MODEL",
        MODEL_ID_PAGE_OPTIONS: "PAGE_OPTIONS_MODEL",
        MODEL_ID_CROSSTAB_OPTIONS: "CROSSTAB_OPTIONS_MODEL",
        MODEL_ID_PLOT_OPTIONS: "PLOT_OPTIONS_MODEL",
        MODEL_ID_PORTFOLIO_DETAILS_OPTIONS: "PORTFOLIO_DETAILS_OPTIONS_MODEL",
        MODEL_ID_RISK_FACTOR_SENSITIVITIES_OPTIONS: "RISK_FACTOR_SENSITIVITIES_OPTIONS_MODEL",
        MODEL_ID_DEBUG_OPTIONS: "DEBUG_OPTIONS_MODEL",
        MODEL_ID_CROSSTAB_FILTERS: "CROSSTAB_FILTERS_MODEL",
        MODEL_ID_EXPLORATION_PANES_STATE: "EXPLORATION_PANES_STATE_MODEL",

        // DataItem constants
        DEFAULT_RESULT_SET_NAME: "DefaultResultSet",

        // Splitter & BorderLayout constants
        HPR_EXPLORATION_VIEW_LEFT_PANEL_DEFAULT_SIZE: "25%",
        HPR_EXPLORATION_VIEW_MAIN_PANEL_DEFAULT_SIZE: "auto",
        HPR_EXPLORATION_VIEW_RIGHT_PANEL_DEFAULT_SIZE: "20%",
        HPR_EXPLORATION_VIEW_SIDE_PANEL_MIN_SIZE: 42,
        HPR_EXPLORATION_VIEW_SIDE_PANEL_MIN_PIXEL_SIZE: "42px",
        HPR_EXPLORATION_VIEW_MAIN_PANEL_MIN_SIZE: 300,
        HPR_DATA_PANE_TOP_BORDERLAYOUTAREA_DEFAULT_SIZE: "5.0rem",
        HPR_DATA_PANE_BOTTOM_BORDERLAYOUTAREA_TOOLBAR_SIZE: "4.0rem",

        // DataPane constants
        HPR_DATA_PANE_RISK_CUBES_NODE_ID: "dataPane_riskCubesNode",
        HPR_DATA_PANE_CLASS_VARIABLES_NODE_ID: "dataPane_classVariablesNode",
        HPR_DATA_PANE_HIERARCHIES_NODE_ID: "dataPane_hierarchiesNode",
        HPR_DATA_PANE_HORIZONS_NODE_ID: "dataPane_horizonsNode",
        HPR_DATA_PANE_OUTPUT_VARIABLES_NODE_ID: "dataPane_outputVariablesNode",
        HPR_DATA_PANE_COMPUTED_VARIABLES_NODE_ID: "dataPane_computedVariablesNode",
        HPR_DATA_PANE_BENCHMARK_VARIABLES_NODE_ID: "dataPane_benchMarkVariablesNode",
        HPR_DATA_PANE_STATISTICS_NODE_ID: "dataPane_statisticsNode",
        //HPR_DATA_PANE_RESULTSETS_NODE_ID: "dataPane_resultSetsNode",
        HPR_DATA_PANE_SCENARIOS_NODE_ID: "dataPane_scenariosNode",

        // TreeTable constants
        HPR_TREETABLE_LEVEL_TOP: "topLevel",

        // ChooseDataSourceDialog mode constants
        HPR_CHOOSEDATASOURCE_DIALOG_NEW_EXPLORATION_MODE: "newExploration",
        HPR_CHOOSEDATASOURCE_DIALOG_REPLACE_DATA_SOURCE_MODE: "replaceDataSource",
        HPR_CHOOSEDATASOURCE_DIALOG_ADD_DATA_SOURCE_MODE: "addDataSource",

        // OptionsPane constants
        HPR_OPTIONS_PANE_PAGE_TYPE: "PAGE",
        HPR_OPTIONS_PANE_CROSSTAB_TYPE: "CROSSTAB",
        HPR_OPTIONS_PANE_PLOT_TYPE: "PLOT",
        HPR_OPTIONS_PANE_PORTFOLIO_DETAILS_TYPE: "PORTFOLIO_DETAILS",
        HPR_OPTIONS_PANE_RISK_FACTOR_SENSITIVITIES_TYPE: "RISK_FACTOR_SENSITIVITIES",
        HPR_OPTIONS_PANE_TABLE_VIEWER_TYPE: "TABLE_VIEWER",
        HPR_OPTIONS_PANE_ZERO_STATE_TYPE: "ZERO_STATE",
        HPR_OPTIONS_PANE_DEFAULT_TYPE: "DEFAULT",

        HPR_OPTIONS_PANE_PAGE_GENERAL_SECTION_ID: "pageOptions_generalWindowShadeSection",
        HPR_OPTIONS_PANE_PAGE_THEME_SECTION_ID: "pageOptions_themeWindowShadeSection",

        HPR_OPTIONS_PANE_CROSSTAB_GENERAL_SECTION_ID: "crosstabOptions_generalWindowShadeSection",
        HPR_OPTIONS_PANE_CROSSTAB_TOTALS_SECTION_ID: "crosstabOptions_totalsWindowShadeSection",
        HPR_OPTIONS_PANE_CROSSTAB_ADVANCED_QUERY_SECTION_ID: "crosstabOptions_advancedQueryWindowShadeSection",

        HPR_OPTIONS_PANE_PLOT_GENERAL_SECTION_ID: "plotOptions_generalWindowShadeSection",
        HPR_OPTIONS_PANE_PLOT_GRAPH_SECTION_ID: "plotOptions_graphWindowShadeSection",
        HPR_OPTIONS_PANE_PLOT_ADVANCED_QUERY_SECTION_ID: "plotOptions_advancedQueryWindowShadeSection",

        HPR_OPTIONS_PANE_PORTFOLIO_DETAILS_GENERAL_SECTION_ID: "portfolioDetailsOptions_generalWindowShadeSection",

        HPR_OPTIONS_PANE_RISK_FACTOR_SENSITIVITIES_GENERAL_SECTION_ID: "rfsOptions_generalWindowShadeSection",

        HPR_OPTIONS_PANE_TABLE_VIEWER_GENERAL_SECTION_ID: "tableViewerOptions_generalWindowShadeSection",

        HPR_OPTIONS_PANE_ALPHA_NAME: "ALPHA",
        HPR_OPTIONS_PANE_PCTLDEF_NAME: "PCTLDEF",
        HPR_OPTIONS_PANE_NDENSITY_NAME: "NDENSITY",
        HPR_OPTIONS_PANE_KERNEL_NAME: "KERNEL",
        HPR_OPTIONS_PANE_NRFIM_NAME: "NRFIM",
        HPR_OPTIONS_PANE_NROWS_NAME: "NROWS",
        HPR_OPTIONS_PANE_NDETAILS_NAME: "NDETAILS",
        HPR_OPTIONS_PANE_MKTCACHE_NAME: "MKTCACHE",
        HPR_OPTIONS_PANE_POSCACHE_NAME: "POSCACHE",
        HPR_OPTIONS_PANE_HIERARCHY_NAME: "HIERARCHY",
        HPR_OPTIONS_PANE_TOTALS_NAME: "TOTALS",
        HPR_OPTIONS_PANE_SUBTOTALS_NAME: "SUBTOTALS",
        HPR_OPTIONS_PANE_LOCATION_NAME: "LOCATION",
        HPR_OPTIONS_PANE_TRANSPOSE_NAME: "TRANSPOSE",
        HPR_OPTIONS_PANE_INDENT_ROWS_NAME: "INDENTROWS",
        HPR_OPTIONS_PANE_SHOW_LABELS_NAME: "SHOWLABELS",
        HPR_OPTIONS_PANE_DISPLAY_HORIZONS_NAME: "DISPLAYHORIZONS",

        // FiltersPane constants
        HPR_FILTERS_PANE_DEFAULT_TYPE: "DEFAULT",
        HPR_FILTERS_PANE_CROSSTAB_TYPE: "CROSSTAB",
        HPR_FILTERS_PANE_PLOT_TYPE: "PLOT",
        HPR_FILTERS_PANE_PORTFOLIO_DETAILS_TYPE: "PORTFOLIO_DETAILS",
        HPR_FILTERS_PANE_RISK_FACTOR_SENSITIVITIES_TYPE: "RISK_FACTOR_SENSITIVITIES",
        HPR_FILTERS_PANE_ZERO_STATE_TYPE: "ZERO_STATE",
        HPR_FILTERS_PANE_VALUES_PAGE_SIZE: 2500,
        HPR_FILTERS_PANE_FILTER_ITEM_POPOVER_WIDTH: "20rem",
        HPR_FILTER_TYPE_INCLUDE_VALUE: true,
        HPR_FILTER_TYPE_EXCLUDE_VALUE: false,

        // HierarchiesPane constants
        HPR_HIERARCHIES_PANE_CROSSTAB_TYPE: "CROSSTAB",
        HPR_HIERARCHIES_PANE_ZERO_STATE_TYPE: "ZERO_STATE",

        // DisplayRulesPane constants
        HPR_DISPLAY_RULES_PANE_CROSSTAB_TYPE: "CROSSTAB",
        HPR_DISPLAY_RULES_PANE_ZERO_STATE_TYPE: "ZERO_STATE",

        HPR_CROSSTAB_PANEL: 'crosstab',
        HPR_TABLE_VIEWER_PANEL: 'tableviewer',
        HPR_LIST_TABLE_PANEL: 'listtable',
        HPR_UNKNOWN_PANEL: 'unknown',

        // Plot constants
        HPR_PLOT_PANEL: 'plot',
        PlotType: {
            Density: "density", // Density???
            CashFlow: "cashFlow", //"CashFlowLeg",
            PortfolioDetails: "PortfolioDetails",
            Comparison: "comparison",
            Distribution: "distribution", // box plot
            Sensitivity: "sensitivity",
            DeltaNormalSensitivity: "deltaNormalSensitivity",
            RiskFactorInformationMeasures: "riskFactorInformationMeasures",

            // FIXME: These do not belong here
            ZeroState: "ZeroState" // TODO: Fix this - MCA
        },

        WhatType: {
            BenchmarkVariable: "benchmarkVariable",
            ComputedVariable: "computedVariable",
            Statistic: "statistic",
            Distribution: "distribution"
        },

        ByType: {
            Subportfolio: "Subportfolio"
            // {item: dataItem, index: x, type: ByType.Subportfolio|DataItem.type}
        },

        HowType: {
            Line: "Line",
            Bar: "Bar",
            Distribution: "distribution", // Tie Fighter
            Table: "Table"
        },

        // Portfolio details constants
        HPR_PORTFOLIO_DETAILS_PANEL: 'portfolioDetails',
        HPR_CUBE_ID_TOKEN: "{cubeID}",
        HPR_PORTFOLIO_DETAILS_QUERY_URL: "rest/cubes/{cubeID}/query",
        HPR_PORTFOLIO_DETAILS_QUERY_TYPE: "portfolio",
        HPR_PORTFOLIO_COLS_ALL_OPTION_KEY: "%ALL%",
        HPR_PORTFOLIO_COLS_REQUIRED_OPTION_KEY: "%REQUIRED%",
        HPR_PORTFOLIO_COLS_INST_TYPE_OPTION_KEY: "%INST_TYPE%",
        HPR_PORTFOLIO_COLS_ALL_INSTTYPE_NAME: "%ALL%",  //TODO remove?
        HPR_PORTFOLIO_INSTTYPE_POSITION_KEY: "_POS_",
        HPR_PORTFOLIO_INSTTYPE_QUADRATIC_KEY: "_QUAD_",

        //Table Viewer
        HPR_TABLE_QUERY_URL: "rest/cubes/{cubeID}/query",

        HPR_SIMULATED_VALUES_PANEL: 'simulatedValues',
        HPR_SIMVAL_VALUE_DEFAULT_FORMAT: 'COMMA.4',
        HPR_SIMVAL_DATE_DEFAULT_FORMAT: 'NLDATE10', //'NLDATM9',

        // Risk Factor Sensitivities constants
        HPR_RISK_FACTOR_SENSITIVITIES_PANEL: "riskFactorSensitivities",
        HPR_RISK_FACTOR_SENSITIVITIES_COMPONENT_ID: "RiskFactorSensitivities_",
        HPR_RISK_FACTOR_SENSITIVITIES_RISK_FACTOR_THRESHOLD: 1000000, // max number of risk factors to load in selection dialog

        // column & data item types
        HPR_DATA_TYPE_STRING: "string",
        HPR_DATA_TYPE_NUMBER: "numeric",
        HPR_DATA_TYPE_DATE: "date",

        DISPLAY_HORIZONS_ABSOLUTE_VALUE: 'absolute',
        DISPLAY_HORIZONS_RELATIVE_VALUE: 'relative',

        CLASS_VARIABLE_DATA_ITEM_TYPE: "classVariable",
        PORTFOLIO_COLUMN_DATA_ITEM_TYPE: "instrumentVariable",

        // flag to change all panels into debug mode when created.
        USE_DEBUG_MODE_FOR_PANELS: false,

        // Settings/Preferences constants
        HPR_SETTINGS_SHOW_STALENESS_NOTIFICATION: "hpriskui.showStalenessNotification", // Display staleness notification; true or false
        HPR_SETTINGS_SHOW_LABELS: "hpriskui.showLabels", // Show labels; true or false
        HPR_SETTINGS_SHOW_LABELS_DEFAULT_VALUE: true,
        HPR_SETTINGS_INCLUDE_PLOT_IMAGE: "hpriskui.includePlotImage", // Include Plot Image in Export; true or false
        HPR_SETTINGS_PLOT_WIDTH_DIMENSION: "hpriskui.plotWidthDimension",
        HPR_SETTINGS_PLOT_WIDTH_DIMENSION_DEFAULT_VALUE: 640,
        HPR_SETTINGS_PLOT_WIDTH_DIMENSION_MIN_VALUE: 320,
        HPR_SETTINGS_PLOT_WIDTH_DIMENSION_MAX_VALUE: 1280,
        HPR_SETTINGS_PLOT_HEIGHT_DIMENSION: "hpriskui.plotHeightDimension",
        HPR_SETTINGS_PLOT_HEIGHT_DIMENSION_DEFAULT_VALUE: 480,
        HPR_SETTINGS_PLOT_HEIGHT_DIMENSION_MIN_VALUE: 240,
        HPR_SETTINGS_PLOT_HEIGHT_DIMENSION_MAX_VALUE: 1024,
        HPR_SETTINGS_CUBE_POLLING: "hpriskui.cubePolling", // Start Cube Polling on Open; true or false
        HPR_SETTINGS_CUBE_POLLING_INTERVAL: "hpriskui.cubePollingInterval", // Cube Polling Interval
        HPR_SETTINGS_CUBE_POLLING_INTERVAL_DEFAULT_VALUE: 5,
        HPR_SETTINGS_CUBE_POLLING_INTERVAL_MIN_VALUE: 1,
        HPR_SETTINGS_CUBE_POLLING_INTERVAL_MAX_VALUE: 60,
        HPR_SETTINGS_DISPLAY_HORIZONS: "hpriskui.displayHorizons", // Display Horizons
        HPR_SETTINGS_PORTFOLIO_DETAILS_PAGE_SIZE: "hpriskui.portfolioDetailsPageSize", // Portfolio Details Page Size
        HPR_SETTINGS_PORTFOLIO_DETAILS_PAGE_SIZE_DEFAULT_VALUE: 200,
        HPR_SETTINGS_PORTFOLIO_DETAILS_PAGE_SIZE_MIN_VALUE: 100,
        HPR_SETTINGS_PORTFOLIO_DETAILS_PAGE_SIZE_MAX_VALUE: 10000,

        // general
        SAS_NAME_MAX_LENGTH: 32,

        // default column width
        DEFAULT_CROSSTAB_WIDTH: 120,

        // export
        HPR_EXPORT_URL: "rest/export",
        HPR_EXPORT_TO_EXCEL_INVALID_CHARS: "\\[]/?:*",
        HPR_EXPORT_FORMAT_EXCEL: "excel",
        HPR_EXPORT_TABLE_NAME_KEY: "tableName",
        HPR_EXPORT_TABLE_TYPE_KEY: "tableType",
        HPR_EXPORT_TABLE_DATA_KEY: "tableData",
        HPR_EXPORT_DATA_SOURCE_NAME_KEY: "dataSourceName",
        HPR_EXPORT_DATASOURCE_CREATION_DATE_KEY: "creationDate",
        HPR_EXPORT_EXPORT_CREATION_DATE_KEY: "exportCreationDate",
        HPR_EXPORT_PORTFOLIO_DRILL_KEY: "portfolioDrill",
        HPR_EXPORT_RISK_CUBE_KEY: "riskCube",
        HPR_EXPORT_FILENAME_HEADER_NAME: "Content-disposition",
        HPR_EXPORT_FILENAME_HEADER_KEY: "filename=",

        // data source health status (numbers prefixes are for column sorting)
        HPR_DATA_SOURCE_STATUS_TESTING: "0dataSourceTesting",
        HPR_DATA_SOURCE_STATUS_NO_DESCRIPTOR: "1dataSourceNoDescriptor",
        HPR_DATA_SOURCE_STATUS_MISSING_FILES: "2dataSourceMissingFiles",
        HPR_DATA_SOURCE_STATUS_MISSING_TYPE_PRICE: "3dataSourceMissingPrice",
        HPR_DATA_SOURCE_STATUS_MISSING_TYPE_STRESS: "4dataSourceMissingStress",
        HPR_DATA_SOURCE_STATUS_WARNING_NOT_PRICESTRESS: "5dataSourceNotPriceStress",
        HPR_DATA_SOURCE_STATUS_UNKNOWN: "6dataSourceUnknown",
        HPR_DATA_SOURCE_STATUS_VALID: "7dataSourceValid",

        // Help EUA constants
        HPR_EUA_LIBRARY: "sas.analytics.riskhp",
        HPR_EUA_APPLY_HIERARCHY_KEY: "apply_hierarchy",
        HPR_EUA_COMPUTED_VARIABLE_KEY: "computed_variable"
    };

}());

HprConstants = sas.analytics.riskhp.utils.HprConstants;