// (c) 2017, SAS Institute Inc.

jQuery.sap.require('sas.analytics.riskhp.common.riskcommons.CrosstabUtil');
jQuery.sap.require("sas.analytics.riskhp.models.dataitems.Classvar");
jQuery.sap.require("sas.analytics.riskhp.models.HPRiskModelManager");
jQuery.sap.require("sas.analytics.riskhp.utils.ViewManager");
jQuery.sap.require("sas.analytics.riskhp.views.hierarchies.HierarchiesPaneDragDropHandler");

sap.ui.controller('sas.analytics.riskhp.views.hierarchies.HierarchiesPane', {
    //DragDropHandler : sas.analytics.riskhp.views.hierarchies.HierarchiesPaneDragDropHandler,
    CLASSVAR : sas.analytics.riskhp.models.dataitems.Classvar.CLASSVAR,
    HIERARCHY : sas.analytics.riskhp.models.dataitems.Hierarchy.HIERARCHY,
    RISKCUBE : sas.analytics.riskhp.models.dataitems.RiskCube.RISKCUBE,
    hierarchyDropped : "",
    CrosstabUtil : sas.analytics.riskhp.common.riskcommons.CrosstabUtil,
    crosstabContext : {},
    HprUtil: sas.analytics.riskhp.utils.HprUtil,
    ViewManager: sas.analytics.riskhp.utils.ViewManager,

    onInit: function() {
        var ctrl = this;
        var view = ctrl.getView();

        // Set up row hierarchy list to be drag and drop sortable
        var rowHierarchyList = view.rowHierarchyList;
        var rowHierarchyListId = rowHierarchyList.getId();
        var rowHierarchyListUlId = rowHierarchyListId + "-listUl";

        // rowHierarchyList.onAfterRendering = function() {
        //     if (sap.m.List.prototype.onAfterRendering) {
        //         sap.m.List.prototype.onAfterRendering.apply(this);
        //     }
        //     $("#"+rowHierarchyListUlId).addClass('rowHierarchyList-sortable');
        //     $("#"+rowHierarchyListUlId).sortable({
        //         connectWith : ".rowHierarchyList-sortable",
        //         cursor: "move",
        //         update: function( event, ui ) {ctrl._enableApplyButton(true);}
        //     }).disableSelection();
        // };

        // Set up column hierarchy list to be drag and drop sortable
        var columnHierarchyList = view.columnHierarchyList;
        var columnHierarchyListId = columnHierarchyList.getId();
        var columnHierarchyListUlId = columnHierarchyListId + "-listUl";

        // columnHierarchyList.onAfterRendering = function() {
        //     if (sap.m.List.prototype.onAfterRendering) {
        //         sap.m.List.prototype.onAfterRendering.apply(this);
        //     }
        //     $("#"+columnHierarchyListUlId).addClass('columnHierarchyList-sortable');
        //     $("#"+columnHierarchyListUlId).sortable({
        //         connectWith : ".columnHierarchyList-sortable",
        //         cursor: "move",
        //         update: function( event, ui ) {ctrl._enableApplyButton(true);}
        //     }).disableSelection();
        // };

        // Subscribe to events that are published when the Hierarchies panes should be updated
        sas.eventBus.subscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_CHANGED, this.onChangeHierarchiesPane, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_UPDATED, this.onUpdateHierarchiesPane, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_RESET, this.onResetHierarchiesPane, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_DATA_ITEM_LABEL_UPDATED, this.onDataItemLabelUpdate, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_SHOW_LABELS_UPDATED, this._onShowLabelsChange, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_TRANSPOSE_UPDATED, this._onCrosstabTransposeChange, this);
        sas.eventBus.subscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_NAME_UPDATED, this.onParentPanelOptionsNameUpdate, this);
    },

    onExit: function() {
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_CHANGED, this.onChangeHierarchiesPane, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_UPDATED, this.onUpdateHierarchiesPane, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_HIERARCHIES_PANE, HprConstants.EVENT_HIERARCHIES_PANE_RESET, this.onResetHierarchiesPane, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_EXPLORATION, HprConstants.EVENT_DATA_ITEM_LABEL_UPDATED, this.onDataItemLabelUpdate, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_SHOW_LABELS_UPDATED, this._onShowLabelsChange, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_TRANSPOSE_UPDATED, this._onCrosstabTransposeChange, this);
        sas.eventBus.unsubscribe(HprConstants.CHANNEL_OPTIONS_PANE, HprConstants.EVENT_CROSSTAB_OPTIONS_NAME_UPDATED, this.onParentPanelOptionsNameUpdate, this);
    },

    onBeforeRendering: function () {
        var ctrl = this;
        var view = ctrl.getView();

    },

    onAfterRendering: function () {
        var ctrl = this;
        var view = ctrl.getView();

       //this.DragDropHandler.configureDroppableWithId(view.getId(), this, "touch");
    },

    setModelCache: function(modelCache) {
        this.modelCache = modelCache;
    },

    getModelCache: function() {
        if (!this.modelCache) {
            this.setModelCache({});
        }
        return this.modelCache;
    },

    _getResourceBundle: function () {
        return sas.analytics.riskhp.utils.HprUtil.getBundle();
    },

    // Get the crosstab's model
    getCrosstabContext: function() {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy

        if (hierarchiesModel !== undefined && Object.keys(hierarchiesModel).length > 0) {
            // Since we don't know which Crosstab is selected when this event happens, pull the Crosstab id from the hierarchiesModel
            var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
            // Only continue if we have a Crosstab id
            if (hierarchiesCrosstabId) {
                return sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);
            }
        }
        return undefined;
    },

    _enableApplyButton: function(enabled) {
        var ctrl = this;
        var view = ctrl.getView();

        view.applyButton.setEnabled(enabled);
        view.cancelButton.setEnabled(enabled);
    },

    _onApplyButtonPressed: function(evt) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id"); // id of the appropriate CrosstabContext and Crosstab
        var crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);

        var hColumn = hierarchiesModel.getProperty("/crosstab/column");
        var hRow = hierarchiesModel.getProperty("/crosstab/row");

        var newColumnOrder = [];
        // Add the riskcube back into the column list if this is NOT a side by side because it was remove previously
        // so it would not show up in the column hierarchy list.
        if (crosstabContext && !crosstabContext.cubeDataModel.isSideBySide()) {
            newColumnOrder.push(ctrl.RISKCUBE);
        }
        for (var idx = 0; idx < hColumn.length; idx++) {
            var item = hColumn[idx].type;
            // Since we can hide the Risk Cube list item for certain types of cubes, we need to re-populate it here
            // to make sure the columnHierarchyList displays correctly after an update; The columnHierarchyList component
            // holds a reference to the list item which has been set to "visible: false"
            // if (item === "sap-ui-invisible-riskCube") {
            //     item = ctrl.RISKCUBE;
            // }
            newColumnOrder.push(item);
        }

        var dataSourceDeferred = DataSourceCacheManager.getDataSource(crosstabContext.dataSourceId);
        dataSourceDeferred.done(function(dataSource) {
            var newRowOrder = [];
            for (var idx = 0; idx < hRow.length; idx++) {
                var dataItem = hRow[idx];
                newRowOrder.push(dataItem.id);
            }

            // Check if each hierarchy changed
            var rebuildCrosstab = false;

            var updateCrosstabRowHierarchy = function () {
                // Set the new row Hierarchy
                crosstabContext.replaceClassVariables(newRowOrder);
                rebuildCrosstab = true;
            };

            var updateCrosstabColumnHierarchy = function () {
                // Set the new column Hierarchy
                crosstabContext.setColumnMembers(newColumnOrder);

                // Update the column tree with the new layout.
                crosstabContext.updateColumnTree();
                rebuildCrosstab = true;
            };

            if (ctrl.hierarchyDropped.length > 0) {
                var hierarchyDialog = sap.ui.jsfragment("sas.analytics.riskhp.fragments.HierarchyDialog", {
                    messageText: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("Hierarchy.forced.enable.dialog.txt"),
                    doContinue: function () {
                        // Set hierarchy option
                        var optionHierarchy = crosstabContext.getOptionHIERARCHY();
                        optionHierarchy.value = ctrl.hierarchyDropped;
                        crosstabContext.setOptionHIERARCHY(optionHierarchy);

                        ctrl.hierarchyDropped = "";

                        updateCrosstabRowHierarchy();
                        updateCrosstabColumnHierarchy();

                        // Disable Apply button
                        ctrl._enableApplyButton(false);

                        ctrl._updateHierarchiesModel(hierarchiesModel, crosstabContext, hierarchiesCrosstabId);

                        // clear results and clear drill
                        crosstabContext.resetReportResultsTree();

                        crosstabContext.crosstab.rebuildCrosstab(true);
                    },
                    doCancel: function () {
                        ctrl.hierarchyDropped = "";
                        ctrl._onCancelButtonPressed();
                    }
                });
                hierarchyDialog.open();
            }
            else
            if (crosstabContext.isForcedHierarchyMode() && !ctrl._isHierarchyIntact(hRow, crosstabContext)) {
                var hierarchyDialog = sap.ui.jsfragment("sas.analytics.riskhp.fragments.HierarchyDialog", {
                    messageText: sas.analytics.riskhp.utils.HprUtil.getBundle().getText("Hierarchy.forced.disable.dialog.txt"),
                    doContinue: function () {
                        crosstabContext.setForcedHierarchyModeOff();
                        updateCrosstabRowHierarchy();
                        updateCrosstabColumnHierarchy();

                        // Remove warning icon
                        view.warnIcon.setVisible(false);

                        // Disable Apply button
                        ctrl._enableApplyButton(false);

                        // Update the context and rebuild crosstab if necessary
                        if (rebuildCrosstab) {
                            ctrl._updateHierarchiesModel(hierarchiesModel, crosstabContext, hierarchiesCrosstabId);
                            crosstabContext.crosstab.rebuildCrosstab(true);
                        }
                    },
                    doCancel: function () {
                        ctrl._onCancelButtonPressed();
                    }
                });
                hierarchyDialog.open();
            }
            // Not in forced hierarchy mode
            else {
                updateCrosstabRowHierarchy();
                updateCrosstabColumnHierarchy();

                // Disable Apply button
                ctrl._enableApplyButton(false);

                // Update the context and rebuild crosstab if necessary
                if (rebuildCrosstab) {
                    ctrl._updateHierarchiesModel(hierarchiesModel, crosstabContext, hierarchiesCrosstabId);
                    crosstabContext.crosstab.rebuildCrosstab();
                }
            }
        });
    },

    _onCancelButtonPressed: function(evt) {
        var ctrl = this;
        var view = ctrl.getView();

        // Dispense with this warning...  begone!
        view.warnIcon.setVisible(false);

        // Disable Apply button
        this._enableApplyButton(false);

        // Revert components back to previous state by getting previous Crosstab context information;
        // We can't rely on the borderLayout model because it is bound and already updated at this point
        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id"); // id of the appropriate CrosstabContext and Crosstab
        var crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);
        ctrl._updateHierarchiesModel(hierarchiesModel, this.crosstabContext, hierarchiesCrosstabId);
    },

    // Update the Hierarchies pane when a label for a Data Item is updated.
    onDataItemLabelUpdate: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy

        // Since we don't know which Crosstab is selected when this event happens, pull the Crosstab id from the hierarchiesModel
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
        // Only continue if we have a Crosstab id
        if (hierarchiesCrosstabId) {
            this.crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);

            // Only try to update the label if the id's of the DataSource being updated and DataSource for the CrosstabContext match
            if (data && data.dataSourceId) {
                if (data.dataSourceId != this.crosstabContext.getDataSourceId()) return;
            }

            ctrl._updateHierarchiesModel(hierarchiesModel, this.crosstabContext, hierarchiesCrosstabId);
        }
    },

    // Build a StandardListItem to use inside the Row Hierarchy Table
    _buildRowHierarchyTableListItem: function(sId, oContext, crosstabContext) {
        var ctrl = this;

        // If there is no context passed in, locate the one off of the hierarchies model
        if (!crosstabContext) {
            var hierarchiesCrosstabId = ctrl._getHierarchiesModel().getProperty("/crosstab/id");
            crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);
        }

        // Retrieve the showLabels option value from the CrosstabContext
        var showLabels = crosstabContext.getOptionShowLabels().value;

        // Based on the showLabels value, either display the label or name for the StandardListItem;
        // These are not DataItems, so we must use the List functions to get the label or name
        var displayLabel = showLabels ? oContext.getProperty("label") : oContext.getProperty("name");

        var listItem = new sas.hc.m.StandardListItem({
            //id: sId,
            title: displayLabel,
            type: sap.m.ListType.Active
        });
        return listItem;
    },

    _onCrosstabTransposeChange: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy

        // Since we don't know which Crosstab is selected when this event happens, pull the Crosstab id from the hierarchiesModel
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");

        // Only continue if we are working with the same Crosstab which fired the event
        if (hierarchiesCrosstabId === data.crosstabId) {

            // Get the correct CrosstabContext so the row labels will be displayed the same as the Crosstab
            ctrl.crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);
            var isTransposed = data.transposed;
            var hierarchyName = ctrl.crosstabContext.optionHIERARCHY.value;

            ctrl.updateColumnHierarchyLabel(ctrl.crosstabContext);
            ctrl.updateRowHierarchyLabel(ctrl.crosstabContext);
        }
    },

    // This event is captured when a Crosstab fires a showLabels update event; Make sure we update the display of labels
    // if we are working with the same Crosstab which fired the event
    _onShowLabelsChange: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy

        // Since we don't know which Crosstab is selected when this event happens, pull the Crosstab id from the hierarchiesModel
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");

        // Only continue if we are working with the same Crosstab which fired the event
        if (hierarchiesCrosstabId === data.crosstabId) {

            // Get the correct CrosstabContext so the row labels will be displayed the same as the Crosstab
            ctrl.crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(hierarchiesCrosstabId);

            // Brute force way to refresh the RowHierarchy List/Table so the correct label's will be displayed to the user
            var rowHierarchyList = view.rowHierarchyList;
            rowHierarchyList.unbindItems();

            // rowHierarchyList.bindAggregation("items", "/crosstab/row", function(sId, oContext) {
            //     return ctrl._buildRowHierarchyTableListItem(sId, oContext, ctrl.crosstabContext);
            // });

            var showLabels = false;
            if (ctrl.crosstabContext !== undefined) {
                showLabels = ctrl.crosstabContext.getOptionShowLabels().value;
            }

            var oItemTemplate = new sas.hc.m.StandardListItem({
                title: {parts: ["name", "label"], formatter: function(name, label) {
                    //return name
                    return showLabels ? label : name
                }},
                type: sap.m.ListType.Active
            });
            rowHierarchyList.bindAggregation("items", {path: "/crosstab/row", template: oItemTemplate} );

        }
    },

    // Update the Hierarchies pane.  Normally this update comes from the crosstab itself.
    onUpdateHierarchiesPane: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        // Check to see if the Crosstab in the model is the same one the user
        // clicked on, if so, just return and don't set model again
        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy

        // Since 'onUpdateHierarchiesPane' is called by EventBus subscription and by 'onChangeHierarchiesPane' sometimes
        // we don't want the Hierarchies pane to show the update.  This is especially true when multiple Crosstabs are displayed
        // and an update happened on the Crosstab that is currently not reflected in the Hierarchies pane.  We still need to update
        // the corresponding model so next time the user clicks on the Crosstab, the Hierarchies pane reflects the changes
        if (data.checkIdOfHierarchiesPane && hierarchiesModel.getProperty('/crosstab/id') !== data.crosstabId) {
            var crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(data.crosstabId);
            ctrl._updateHierarchiesCachedModel(crosstabContext, data.crosstabId);
            return;
        }

        // If the data has a 'crosstabId' and an appropriate 'hierarchiesType' property, then we know we have a valid Crosstab
        if (data && data.crosstabId && (data.hierarchiesType && data.hierarchiesType.toUpperCase() === HprConstants.HPR_FILTERS_PANE_CROSSTAB_TYPE)) {
            this.crosstabContext = sas.analytics.riskhp.models.HPRiskModelManager.getCrosstabContext(data.crosstabId);
            ctrl._updateHierarchiesModel(hierarchiesModel, this.crosstabContext, data.crosstabId, eventId === HprConstants.EVENT_HIERARCHIES_PANE_CHANGED);
        } else {
            // In this case, the user selected a Plot or Portfolio Details, adjust the model accordingly
            this.crosstabContext = null;
            ctrl._updateHierarchiesModel(hierarchiesModel, null, null);
        }
    },


    /**
     * Update title text based on parent panel
     * @param titleStr
     */
    updateParentPanelTitle: function(titleStr) {
        var ctrl = this;

        if (!titleStr) {
            var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
            var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
            var selectedRiskPanelsView = this.HprUtil.getSelectedRiskPanelsView();
            var riskPanelsViewDelegate = selectedRiskPanelsView.getDelegate();
            titleStr = riskPanelsViewDelegate.getTitleForContent(hierarchiesCrosstabId);
        }
        ctrl.getView().parentPanelTitleText.setText(titleStr);
    },


    // Change the Hierarchy panes depending on what type of Object is selected in the Exploration view
    onChangeHierarchiesPane: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        // Check to see if the Crosstab in the model is the same one the user
        // clicked on, if so, just return and don't set model again
        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
        if (hierarchiesCrosstabId && hierarchiesCrosstabId === data.crosstabId && data.hierarchiesType.toUpperCase() === HprConstants.HPR_FILTERS_PANE_CROSSTAB_TYPE) {
            // If we have a valid Crosstab to show Hierarchies for, make sure the NavContainer is showing the correct page
            var currentPageId = view.navContainer.getCurrentPage().getId();
            if (currentPageId.indexOf("defaultPage") === -1) {
                view.navContainer.to(view.defaultPage, "show");

                // Make sure the HelpPopup is displayed; Since HelpPopup is declared on HierarchiesPane.fragment, we have to go through ExplorationView
                ctrl.ViewManager.getExplorationView().getHierarchiesPane().setHelpPopupVisible(true);
            }
        }
        else {
            // When changing the Hierarchies pane, by-pass the id check in the 'onUpdateHierarchiesPane' method since we definitely want to update the Hierarchies pane model
            data.checkIdOfHierarchiesPane = false;

            // If the data has a 'crosstabId' and appropriate 'hierarchiesType' property, then we know we have a valid Crosstab
            if (data.crosstabId && data.hierarchiesType.toUpperCase() === HprConstants.HPR_FILTERS_PANE_CROSSTAB_TYPE) {
                // Switch to the defaultPage in the navContainer
                view.navContainer.to(view.defaultPage, "show");

                // Make sure the HelpPopup is displayed; Since HelpPopup is declared on HierarchiesPane.fragment, we have to go through ExplorationView
                ctrl.ViewManager.getExplorationView().getHierarchiesPane().setHelpPopupVisible(true);

                // Disable the Apply button and update the HierarchiesPane accordingly
                ctrl._enableApplyButton(false);
                ctrl.onUpdateHierarchiesPane(channelId, eventId, data);
            } else {
                // Display the empty/zero state by switching to the zeroStatePage in the navContainer
                view.navContainer.to(view.zeroStatePage, "show");

                // Hide the HelpPopup in Zero State; Since HelpPopup is declared on HierarchiesPane.fragment, we have to go through ExplorationView
                ctrl.ViewManager.getExplorationView().getHierarchiesPane().setHelpPopupVisible(false);

                // Update the HierarchiesPane accordingly
                ctrl.onUpdateHierarchiesPane(channelId, eventId, data);
            }
        }
    },

    onResetHierarchiesPane: function(channelId, eventId, data) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        ctrl._resetHierarchiesModel(hierarchiesModel);
    },

    /**
     * Returns the model for the HierarchiesPane view which holds the Crosstab properties to make
     * the HierarchiesPane function correctly.
     * @returns {*}
     * @private
     */
    _getHierarchiesModel: function() {
        var ctrl = this;
        var view = ctrl.getView();
        return view.getModel();
    },

    /**
     * Set the model on the HierarchiesPane view for easy access.
     * @param model {sap.ui.model.json.JSONModel} The model to set on the view
     * @private
     */
    _setHierarchiesModel: function(model) {
        var ctrl = this;
        var view = ctrl.getView();
        view.setModel(model);

        ctrl.updateParentPanelTitle();
   },

    _resetHierarchiesModel: function(hierarchiesModel) {
        var ctrl = this;
        var view = ctrl.getView();

        hierarchiesModel.crosstab = {};
        hierarchiesModel.crosstab.id = null;

        hierarchiesModel.crosstab.context = null;
        hierarchiesModel.crosstab.column = null;
        hierarchiesModel.crosstab.row = null;

        var hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);
        ctrl._setHierarchiesModel(hierarchiesJSONModel);
    },

    /**
     * Update the cached Hierarchies model for the Crosstab corresponding to "crosstabId"; This method only updates the
     * cached model, it does not change the visuals on the Hierarchies Pane
     * @param crosstabContext
     * @param crosstabId
     * @private
     */
    _updateHierarchiesCachedModel: function(crosstabContext, crosstabId) {
        var ctrl = this;

        // Retrieve the Data Source associated with the CrosstabContext because we need some information from it
        var dataSourceDeferred = DataSourceCacheManager.getDataSource(crosstabContext.dataSourceId);
        dataSourceDeferred.done(function(dataSource) {
            var hierarchiesModel = ctrl.getModelCache()[crosstabId];
            if (hierarchiesModel !== undefined) {
                hierarchiesModel.crosstab = ctrl._constructHierarchiesModelCrosstabObject(crosstabContext, crosstabId, dataSource);
            }
            ctrl.getModelCache()[crosstabId] = new sap.ui.model.json.JSONModel(hierarchiesModel);
        });
    },

    /**
     * Update the appropriate Hierarchies model for the Crosstab corresponding to "crosstabId" and also update the visuals
     * on the Hierarchies Pane so the changes will be visible immediately.
     * @param hierarchiesModel
     * @param crosstabContext
     * @param crosstabId
     * @param useCacheModel
     * @private
     */
    _updateHierarchiesModel: function(hierarchiesModel, crosstabContext, crosstabId, useCacheModel) {
        var ctrl = this;
        var hierarchiesJSONModel;

        // If there is no Crosstab context we still need to populate the Hierarchies model correctly
        if (!crosstabContext) {
            hierarchiesModel.crosstab = ctrl._constructHierarchiesModelCrosstabObject(crosstabContext, crosstabId, null);
            hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);

            ctrl.getModelCache()[crosstabId] = hierarchiesJSONModel;

            // Update the hierarchy titles based on transpose and forced hierarchy option
            ctrl.updateRowHierarchyLabel(crosstabContext);
            ctrl.updateColumnHierarchyLabel(crosstabContext);

            ctrl._setHierarchiesModel(hierarchiesJSONModel);
            return;
        }

        // Retrieve the Data Source associated with the CrosstabContext because we need some information from it
        var dataSourceDeferred = DataSourceCacheManager.getDataSource(crosstabContext.dataSourceId);
        dataSourceDeferred.done(function(dataSource) {
            if (useCacheModel && ctrl.getModelCache()[crosstabId]) {
                hierarchiesJSONModel = ctrl.getModelCache()[crosstabId];
                hierarchiesJSONModel.crosstab = ctrl._constructHierarchiesModelCrosstabObject(crosstabContext, crosstabId, dataSource);
                hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesJSONModel);
                ctrl.getModelCache()[crosstabId] = hierarchiesJSONModel;
            }
            else {
                hierarchiesModel.crosstab = ctrl._constructHierarchiesModelCrosstabObject(crosstabContext, crosstabId, dataSource);
                hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);

                ctrl.getModelCache()[crosstabId] = hierarchiesJSONModel;
            }

            // Update the hierarchy titles based on transpose and forced hierarchy option
            ctrl.updateRowHierarchyLabel(crosstabContext);
            ctrl.updateColumnHierarchyLabel(crosstabContext);

            ctrl._setHierarchiesModel(hierarchiesJSONModel);
        });
    },

    _constructHierarchiesModelCrosstabObject: function(crosstabContext, crosstabId, dataSource) {
        var ctrl = this;

        var hierarchiesModelCrosstabObject = {};
        hierarchiesModelCrosstabObject.id = crosstabId;
        hierarchiesModelCrosstabObject.context = crosstabContext;

        // Remove the Risk Cube column list item if the cube is not a comparison join
        var crosstabColumnMembers = crosstabContext ? crosstabContext.getColumnMembers().concat() : null;
        if (crosstabColumnMembers && crosstabColumnMembers.length > 0) {
            crosstabColumnMembers = _.reject(crosstabColumnMembers, function(crosstabColumnMember) {
                if (dataSource && !dataSource.isSideBySide() && crosstabColumnMember.type === ctrl.RISKCUBE) {
                    return true;
                }
                return false;
            });
        }
        hierarchiesModelCrosstabObject.column = crosstabColumnMembers;

        hierarchiesModelCrosstabObject.row = crosstabContext ? crosstabContext.getClassVariables().concat() : null;

        return hierarchiesModelCrosstabObject;
    },

    _isRowHierarchyChanged: function(newHierarchy, context) {
        var ctrl = this;
        var view = ctrl.getView();
        var oldClassvars = context.getClassVariables();

        // Compare newHierarchy ( classvar ids ) with existing classvars in crosstab context.

        // Check order
        for (var idx = 0; idx < newHierarchy.length; idx++) {
            if (idx >= oldClassvars.length) {
                return true; // more new ones than old
            }
            if (newHierarchy[idx] !== oldClassvars[idx].id) {
                return true;
            }
        }

        // Check array lengths
        if (newHierarchy.length !== oldClassvars.length) {
            return true;
        }

        return false;
    },

    getHighlighterEnabled : function () {
        var debugOptionsModel = sas.analytics.riskhp.models.HPRiskModelManager.getDebugOptions();
        if (debugOptionsModel === undefined) {
            return false;
        }
        return debugOptionsModel.options.cellHighlighter;
    },

    _isHierarchyIntact: function(hRow, hContext) {
        var ctrl = this;
        var intactHierarchy = true;

        if (hContext.optionHIERARCHY && hContext.optionHIERARCHY.value.length !== 0) {
            var hierarchyDataItem = ctrl.CrosstabUtil.getDataItem(hContext.optionHIERARCHY.value, ctrl.HIERARCHY, hContext.cubeDataModel);
            if (hierarchyDataItem) {
                var hierarchyClassvars = hierarchyDataItem.classVariables;

                // find the start of the hierarchy in the hRow list
                var hRowStartIndex = _.findIndex(hRow, function (cv) {
                    return (cv.id === hierarchyClassvars[0].id);
                });

                // trim this hRow list of classvars before the start of the hierarchy
                var trimmedHRow = _.rest(hRow, hRowStartIndex);

                if (trimmedHRow.length >= hierarchyClassvars.length) {
                    intactHierarchy = _.every(trimmedHRow, function (cv, idx) {
                        if (idx >= hierarchyClassvars.length)
                            return false;
                        return (cv.id === hierarchyClassvars[idx].id);
                    });
                }
                else
                    // HRow contains a hierarchy with one or more missing classvars.
                    intactHierarchy = false;
            }
        }
        return intactHierarchy;
    },

    _moveRowHierarchy: function(removeIndex, insertIndex) {
        var ctrl = this;
        var view = ctrl.getView();

        var _doRowMove = function() {
            ctrl._enableApplyButton(true);

            hierarchiesModel.crosstab = {};
            hierarchiesModel.crosstab.id = hId;
            hierarchiesModel.crosstab.context = hContext;
            hierarchiesModel.crosstab.column = hColumn;
            hierarchiesModel.crosstab.row = hRow;

            var hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);
            ctrl._setHierarchiesModel(hierarchiesJSONModel);

            // Make sure item is selected after move
            // We use a completely different id method of (maintaining) selection of item in the list.
            var selectId = ctrl.rowBaseSelectedId.concat(insertIndex !== undefined ? insertIndex : removeIndex);
            view.rowHierarchyList.setSelectedItemById(selectId, true /*bSelect*/);
        };

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hId = hierarchiesModel.getProperty("/crosstab/id");
        var hContext = hierarchiesModel.getProperty("/crosstab/context");
        var hColumn = hierarchiesModel.getProperty("/crosstab/column");
        var hRow = hierarchiesModel.getProperty("/crosstab/row");

        var selectedItem = hRow[removeIndex];

        if (insertIndex && insertIndex === Number.MAX_SAFE_INTEGER) {
            insertIndex = hRow.length - 1;
        };

        hRow.splice(removeIndex, 1);
        if (insertIndex !== undefined)
            hRow.splice(insertIndex, 0, selectedItem);

        // If forced hierarchy in effect, then check if the move impacts the hierarchy and would force a disable.
        if (!ctrl._isHierarchyIntact(hRow, hContext)) {
            // Add warning
            view.warnIcon.setVisible(true);

            // Create an id that will be used by the dialog so it can be suppressed by the Global Settings
            var hierarchyChangeConfirmationDialogId = view.rowHierarchyList.getId() + "-hierarchyChange-Dialog";
            // Check the global settings to see if the dialog is being blocked from opening
            if (sas.hc.ui.core.settings.GlobalSettingsHelper.getSuppressedMessages().indexOf(hierarchyChangeConfirmationDialogId) === -1) {
                var hierarchyChangeConfirmationDialog = new sas.hc.m.MessageDialog({
                    id: hierarchyChangeConfirmationDialogId,
                    type: sas.hc.m.MessageDialogType.Warning,
                    text: ctrl.HprUtil.getBundle().getText("HierarchiesPane.row.warning.dialog.txt"),
                    title: ctrl.HprUtil.getBundle().getText("HierarchiesPane.forcedHierarchy.txt"),
                    includeDontShowCheckBox: true,
                    buttonActions: [
                        {
                            text: sas.hc.m.MessageDialogAction.Ok,
                            initialFocus: true,
                            defaultButton: true
                        }
                    ],
                    afterClose: function (evt) {
                        this.destroy();

                        // Do the move
                        _doRowMove();
                    }
                });
                hierarchyChangeConfirmationDialog.open();
            }
            else {
                _doRowMove();
            }
        }
        else {
            view.warnIcon.setVisible(false);
            _doRowMove();
        }

    },

    onRowHierarchyUpButtonPressed : function(buttonEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var selectedContext = view.rowHierarchyList.getSelectedContexts(true);
        if (selectedContext[0] !== undefined) {
            // We use one id method of identifying item in the list to move.
            var path = selectedContext[0].sPath;
            var pathArray = path.split("/");
            var index = parseInt(pathArray[pathArray.length - 1]);

            // No point in moving up if we are at the top already
            if (index > 0) {
                ctrl._moveRowHierarchy(index, index - 1);
            }
        }
    },

    onRowHierarchyDownButtonPressed : function(buttonEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var selectedContext = view.rowHierarchyList.getSelectedContexts(true);
        if (selectedContext[0] !== undefined) {
            // We use one id method of identifying item in the list to move.
            var path = selectedContext[0].sPath;
            var pathArray = path.split("/");
            var index = parseInt(pathArray[pathArray.length - 1]);

            var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
            var hRow = hierarchiesModel.getProperty("/crosstab/row");

            // No point in moving up if we are at the bottom already
            if (index < hRow.length - 1) {
                ctrl._moveRowHierarchy(index, index + 1);
            }
        }
    },

    onRowHierarchySelectionChange : function(selectionChangeEvent) {
        var ctrl = this;
        var view = ctrl.getView();
        var parameters = selectionChangeEvent.getParameters();

        // Get the id of the list item selected.  Why?  So we can build an new
        // selection id later, when we move the selected item around.
        var selectedId = parameters.listItem.sId; // _item46-rowHierarchy-list-0
        var idx = selectedId.lastIndexOf("-");
        ctrl.rowBaseSelectedId = selectedId.slice(0, idx + 1);
        view.rowContextMenu.setVisible(true);
    },

    // onRowHierarchyDelete : function(deleteEvent) {
    //     var ctrl = this;
    //     var view = ctrl.getView();
    //     var item = deleteEvent.getParameter("listItem");
    //     var parameters = deleteEvent.getParameters();
    //
    //     var selectedId = parameters.listItem.sId; // _item46-rowHierarchy-list-0
    //
    //     var idx = selectedId.lastIndexOf("-");
    //     ctrl.rowBaseSelectedId = selectedId.slice(0, idx + 1);
    //
    //     var idArray = selectedId.split("-");
    //     var index = parseInt(idArray[idArray.length - 1]);
    //     ctrl._moveRowHierarchy(index);
    //
    //     view.rowHierarchyList.$().find(".sapMLIBSelectD").hide();
    // },

    onRowItemSelectFunction : function (oEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hRow = hierarchiesModel.getProperty("/crosstab/row");

        var oItem = oEvent.getParameter("item");
        var oSource = oEvent.getSource();
        var listItemId = oSource.baseItemId;
        var listItemTitle = oSource.baseItemTitle;
        var listItemIndex = parseInt(oSource.baseItemIndex);

        var itemId = oItem.getId();

        switch (itemId) {
            case view.MOVEROWTOTOP:
                if (listItemIndex > 0)
                    ctrl._moveRowHierarchy(listItemIndex, 0);
                break;
            case view.MOVEROWTOBOTTOM:
                if (listItemIndex < hRow.length - 1 )
                    ctrl._moveRowHierarchy(listItemIndex, hRow.length - 1);
                break;
            case view.MOVEROWUP:
                if (listItemIndex > 0)
                    ctrl._moveRowHierarchy(listItemIndex, listItemIndex - 1);
                break;
            case view.MOVEROWDOWN:
                if (listItemIndex < hRow.length - 1 )
                    ctrl._moveRowHierarchy(listItemIndex, listItemIndex + 1);
                break;
            case view.REMOVE:
                if (hRow.length > 1)
                    ctrl._moveRowHierarchy(listItemIndex);
                break;
        }
    },

    _moveColumnHierarchy: function(removeIndex, insertIndex) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hId = hierarchiesModel.getProperty("/crosstab/id");
        var hContext = hierarchiesModel.getProperty("/crosstab/context");
        var hColumn = hierarchiesModel.getProperty("/crosstab/column");
        var hRow = hierarchiesModel.getProperty("/crosstab/row");

        var selectedItem = hColumn[removeIndex];

        if (insertIndex && insertIndex === Number.MAX_SAFE_INTEGER) {
            insertIndex = hColumn.length - 1;
        }

        hColumn.splice(removeIndex, 1);
        hColumn.splice(insertIndex, 0, selectedItem);

        ctrl._enableApplyButton(true);

        hierarchiesModel.crosstab = {};
        hierarchiesModel.crosstab.id = hId;
        hierarchiesModel.crosstab.context = hContext;
        hierarchiesModel.crosstab.column = hColumn;
        hierarchiesModel.crosstab.row = hRow;

        var hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);
        ctrl._setHierarchiesModel(hierarchiesJSONModel);

        // Make sure item is selected after move
        // We use a completely different id method of (maintaining) selection of item in the list.
        var selectId = ctrl.columnBaseSelectedId.concat(insertIndex !== undefined ? insertIndex : removeIndex);
        view.columnHierarchyList.setSelectedItemById(selectId, true /*bSelect*/);
    },

    onColumnHierarchyUpButtonPressed : function(buttonEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var selectedContext = view.columnHierarchyList.getSelectedContexts(true);
        if (selectedContext[0] !== undefined) {
            // We use one id method of identifying item in the list to move.
            var path = selectedContext[0].sPath;
            var pathArray = path.split("/");
            var index = parseInt(pathArray[pathArray.length - 1]);

            // No point in moving up if we are at the top already
            if (index > 0) {
                ctrl._moveColumnHierarchy(index, index - 1);
           }
        }
    },

    onColumnHierarchyDownButtonPressed : function(buttonEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var selectedContext = view.columnHierarchyList.getSelectedContexts(true);
        if (selectedContext[0] !== undefined) {
            // We use one id method of identifying item in the list to move.
            var path = selectedContext[0].sPath;
            var pathArray = path.split("/");
            var index = parseInt(pathArray[pathArray.length - 1]);

            var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
            var hColumn = hierarchiesModel.getProperty("/crosstab/column");

            // No point in moving up if we are at the bottom already
            if (index < hColumn.length - 1) {
                ctrl._moveColumnHierarchy(index, index + 1);
            }
        }
    },

    onColumnHierarchySelectionChange : function(selectionChangeEvent) {
        var ctrl = this;
        var view = ctrl.getView();
        var parameters = selectionChangeEvent.getParameters();

        // Get the id of the list item selected.  Why?  So we can build an new
        // selection id later, when we move the selected item around.
        var selectedId = parameters.listItem.sId; // _item46-columnHierarchy-list-0
        var idx = selectedId.lastIndexOf("-");
        ctrl.columnBaseSelectedId = selectedId.slice(0, idx + 1);
        view.columnContextMenu.setVisible(true);
    },

    onColumnItemSelectFunction : function (oEvent) {
        var ctrl = this;
        var view = ctrl.getView();

        var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
        var hColumn = hierarchiesModel.getProperty("/crosstab/column");

        var oItem = oEvent.getParameter("item");
        var oSource = oEvent.getSource();
        var listItemId = oSource.baseItemId;
        var listItemTitle = oSource.baseItemTitle;
        var listItemIndex = parseInt(oSource.baseItemIndex);

        var itemId = oItem.getId();

        switch (itemId) {
            case view.MOVECOLUMNTOTOP:
                if (listItemIndex > 0)
                    ctrl._moveColumnHierarchy(listItemIndex, 0);
                break;
            case view.MOVECOLUMNTOBOTTOM:
                if (listItemIndex < hColumn.length - 1 )
                    ctrl._moveColumnHierarchy(listItemIndex, hColumn.length - 1);
                break;
            case view.MOVECOLUMNUP:
                if (listItemIndex > 0)
                    ctrl._moveColumnHierarchy(listItemIndex, listItemIndex - 1);
                break;
            case view.MOVECOLUMNDOWN:
                if (listItemIndex < hColumn.length - 1 )
                    ctrl._moveColumnHierarchy(listItemIndex, listItemIndex + 1);
                break;
        }
        // if (!oItem.getSubmenu()) {
        //     sap.m.MessageToast.show(itemId);
        // }
    },


// handleExternalOutEvent : function(event, ui) {
    //     var draggable = ui.draggable;
    //     var ctrl = this;
    //     var view = ctrl.getView();
    //     view.rowHierarchyList.removeStyleClass("droppableHierarchy");
    // },
    //
    // handleExternalOverEvent : function(event, ui) {
    //     var draggable = ui.draggable;
    //     var ctrl = this;
    //     var view = ctrl.getView();
    //
    //     var isClassvars = false;
    //     var draggableObjects = sas.analytics.riskhp.models.HPRiskModelManager.getDraggableObjects();
    //     if (draggableObjects && draggableObjects.length > 0) {
    //         isClassvars = true;
    //         for (var i = 0; i < draggableObjects.length; i++) {
    //             if ((draggableObjects[i].rowType !== this.CLASSVAR) && (draggableObjects[i].rowType !== this.HIERARCHY)) {
    //                 isClassvars = false;
    //             }
    //         }
    //     }
    //     if ((isClassvars === true) && (ctrl.getHighlighterEnabled())) {
    //         view.rowHierarchyList.addStyleClass("droppableHierarchy");
    //     }
    // },
    //
    // handleExternalDropEvent : function(event, ui) {
    //     var ctrl = this;
    //     var view = ctrl.getView();
    //
    //     view.rowHierarchyList.removeStyleClass("droppableHierarchy");
    //
    //     // For some reason, drops associated with sorting the list come thru here.
    //     // If this is the case, then bail because we aren't adding anything, but just rearranging.
    //     var parent = ui.helper.parent();
    //     var parentSortable = parent.hasClass("ui-sortable");
    //     if (parentSortable) {
    //         return;
    //     }
    //
    //     // Process what is being dropped
    //     var draggableObjects = sas.analytics.riskhp.models.HPRiskModelManager.getDraggableObjects();
    //     if (draggableObjects && draggableObjects.length > 0) {
    //         var dataItems = [];
    //
    //         var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
    //         var hId = hierarchiesModel.getProperty("/crosstab/id");
    //         var hContext = hierarchiesModel.getProperty("/crosstab/context");
    //         var hColumn = hierarchiesModel.getProperty("/crosstab/column");
    //         var hRow = hierarchiesModel.getProperty("/crosstab/row");
    //
    //         for (var i = 0; i < draggableObjects.length; i++) {
    //             var draggableObjectType = draggableObjects[i].rowType;
    //             if (draggableObjectType) {
    //                 var item = ctrl.CrosstabUtil.getDataItemFromDraggable(draggableObjects[i]);
    //                 if (item) {
    //                     if (item.type == this.CLASSVAR) {
    //                         // prevent adding duplicates
    //                         var found = _.findWhere(hRow, {id: item.id});
    //                         if (found == undefined) {
    //                             hRow.push(item);
    //                             //dataItems.push(item);
    //                         }
    //                         //_.each(dataItems, function(element,index) {
    //                         //    hRow.push(element);
    //                         //})
    //                     } else if (item.type == this.HIERARCHY) {
    //                         // Replace CVs with CVs from hierarchy
    //                         hRow = item.classVariables;
    //                         ctrl.hierarchyDropped = item.name;
    //                     } else {
    //                         // Something isn't a classvar, so we ignore it.
    //                         // Let processing of other dataitems continue.
    //                         // BUT SHOULD WE?
    //                     }
    //                 } else {
    //                     sas.log.error("Could not find dataItem for  name: " + draggableObjects[i].rowName +
    //                         "  id: " + draggableObjects[i].rowId +
    //                         "  type: " + draggableObjects[i].rowType);
    //                 }
    //             }
    //         }
    //
    //         // _.each(dataItems, function(element,index) {
    //         //     hRow.push(element);
    //         // })
    //
    //         this._enableApplyButton(true);
    //
    //         hierarchiesModel.crosstab = {};
    //         hierarchiesModel.crosstab.id = hId;
    //         hierarchiesModel.crosstab.context = hContext;
    //         hierarchiesModel.crosstab.column = hColumn;
    //         hierarchiesModel.crosstab.row = hRow;
    //
    //         var hierarchiesJSONModel = new sap.ui.model.json.JSONModel(hierarchiesModel);
    //         ctrl._setHierarchiesModel(hierarchiesJSONModel);
    //
    //         // Clear out the draggable objects because they have been consumed.
    //         sas.analytics.riskhp.models.HPRiskModelManager.setDraggableObjects([]);
    //     }
    // },
    //
    // /**
    //  * Determines if the Hierarchies Pane can accept a list of draggables from another part of the UI.
    //  * @param draggableArray An array of draggables in the current drag context that are being dragged around the window
    //  * @returns {boolean} Whether this control can handle the list of draggables
    //  */
    // canAcceptDrop : function(draggables) {
    //     var ctrl = this;
    //     var hierarchiesModel = $.extend(true, {}, ctrl._getHierarchiesModel()); // Create copy
    //
    //     // Pull the Crosstab id from the hierarchiesModel (i.e. no Crosstab id if in ZeroState)
    //     var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
    //     // Only continue if we have a Crosstab id
    //     if (hierarchiesCrosstabId) {
    //         // Goal is to return true if this delegate can deal with the draggable or not
    //         var draggableObjects = sas.analytics.riskhp.models.HPRiskModelManager.getDraggableObjects();
    //
    //         if (draggableObjects && draggableObjects.length > 0) {
    //             var acceptable = true;
    //             for (var i = 0; i < draggableObjects.length; i++) {
    //                 var draggableObjectType = draggableObjects[i].rowType;
    //                 if (draggableObjectType) {
    //                     var item = this.CrosstabUtil.getDataItemFromDraggable(draggableObjects[i]);
    //                     if (item) {
    //                         if ((item.type != this.CLASSVAR) && (item.type != this.HIERARCHY))
    //                             acceptable = false;
    //                     } else {
    //                         sas.log.error("Could not find dataItem for  name: " + draggableObjects[i].rowName +
    //                             "  id: " + draggableObjects[i].rowId +
    //                             "  type: " + draggableObjects[i].rowType);
    //                     }
    //                 }
    //             }
    //
    //             return acceptable;
    //         }
    //     }
    //
    //     return false;
    // },

    updateColumnHierarchyLabel : function(crosstabContext) {
        var ctrl = this;
        var view = ctrl.getView();

        var headerText = "";
        if(crosstabContext) {
            if (crosstabContext.optionTranspose.value === true) {
                headerText = view._getResourceBundle().getText("HierarchiesPane.row.txt");
            }
            else {
                headerText = view._getResourceBundle().getText("HierarchiesPane.column.txt");
            }
        }
        view.columnHierarchyListHeaderText.setText(headerText);
    },

    updateRowHierarchyLabel : function(crosstabContext) {
        var ctrl = this;
        var view = ctrl.getView();

        if(crosstabContext) {
            var optionHierarchy = crosstabContext.getOptionHIERARCHY();
            if (optionHierarchy.value.length > 0) {
                var headerText = "";
                if (crosstabContext.optionTranspose.value === true) {
                    headerText = view._getResourceBundle().getText("HierarchiesPane.column.txt");
                }
                else {
                    headerText = view._getResourceBundle().getText("HierarchiesPane.row.txt");
                }

                // Retrieve the correct label for the Hierarchy Data Item from the DataSource
                var dataSourceDeferred = DataSourceCacheManager.getDataSource(crosstabContext.dataSourceId);
                dataSourceDeferred.done(function(dataSource) {
                    // "optionHierarchy.value" corresponds to the Hierarchy Data Item 'name'
                    var showLabels = crosstabContext.getOptionShowLabels().value;
                    var hierarhcyDataItem = dataSource.getDataItemByNameAndType(optionHierarchy.value, ctrl.HIERARCHY);
                    headerText = headerText + " (" + hierarhcyDataItem.getDisplayLabel(showLabels) + ")";
                });
                //view.rowHierarchyList.setHeaderText(headerText);
                view.rowHierarchyListHeaderText.setText(headerText);
            } else {
                if (crosstabContext.optionTranspose.value === true) {
                    //view.rowHierarchyList.setHeaderText(view._getResourceBundle().getText("HierarchiesPane.column.txt"));
                    view.rowHierarchyListHeaderText.setText(view._getResourceBundle().getText("HierarchiesPane.column.txt"));
                }
                else {
                    //view.rowHierarchyList.setHeaderText(view._getResourceBundle().getText("HierarchiesPane.row.txt"));
                    view.rowHierarchyListHeaderText.setText(view._getResourceBundle().getText("HierarchiesPane.row.txt"));
                }
            }
        }
    },

    onParentPanelOptionsNameUpdate: function(channelId, eventId, data) {
        var hierarchiesModel = $.extend(true, {}, this._getHierarchiesModel()); // Create copy
        var hierarchiesCrosstabId = hierarchiesModel.getProperty("/crosstab/id");
        if (hierarchiesCrosstabId === data.crosstabId) {
            this.updateParentPanelTitle(data.newCrosstabName);
        }
    }
});